/*
jsSMS - A Sega Master System/Game Gear emulator in JavaScript
Copyright (C) 2012-2013 Guillaume Marty (https://github.com/gmarty)
Based on JavaGear Copyright (c) 2002-2008 Chris White

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
(function(window){'use strict';var DEBUG=!1,ENABLE_DEBUGGER=!1,ENABLE_COMPILER=!0,WRITE_MODE=0,READ_MODE=1,ENABLE_SERVER_LOGGER=!1,SYNC_MODE=READ_MODE,ACCURATE=!1,LITTLE_ENDIAN=!0,FORCE_TYPED_ARRAYS=!1,SUPPORT_TYPED_ARRAYS=FORCE_TYPED_ARRAYS||"Uint8Array"in window,FORCE_DATAVIEW=!1,SUPPORT_DATAVIEW=FORCE_DATAVIEW||"ArrayBuffer"in window&&"DataView"in window,FORCE_DESTRUCTURING=!1,SUPPORT_DESTRUCTURING=!1,SAMPLE_RATE=44100,DEBUG_TIMING=DEBUG,REFRESH_EMULATION=!1,ACCURATE_INTERRUPT_EMULATION=!1,LIGHTGUN=!1,VDP_SPRITE_COLLISIONS=
ACCURATE,PAGE_SIZE=16384;var fpsInterval=500,CLOCK_NTSC=3579545,CLOCK_PAL=3546893;
function JSSMS(a){this.opts={ui:JSSMS.DummyUI,swfPath:"lib/"};if(void 0!==a)for(var b in this.opts)void 0!==a[b]&&(this.opts[b]=a[b]);void 0!==a.DEBUG&&(DEBUG=a.DEBUG);void 0!==a.ENABLE_COMPILER&&(ENABLE_COMPILER=a.ENABLE_COMPILER);this.keyboard=new JSSMS.Keyboard(this);this.ui=new this.opts.ui(this);this.vdp=new JSSMS.Vdp(this);this.psg=new JSSMS.SN76489(this);this.ports=new JSSMS.Ports(this);this.cpu=new JSSMS.Z80(this);this.ui.updateStatus("Ready to load a ROM.");this.ui=this.ui}
JSSMS.prototype={isRunning:!1,cyclesPerLine:0,no_of_scanlines:0,frameSkip:0,throttle:!0,fps:0,frameskip_counter:0,pause_button:!1,is_sms:!0,is_gg:!1,soundEnabled:!1,audioBuffer:[],audioBufferOffset:0,samplesPerFrame:0,samplesPerLine:[],emuWidth:0,emuHeight:0,fpsFrameCount:0,z80Time:0,drawTime:0,z80TimeCounter:0,drawTimeCounter:0,frameCount:0,romData:"",romFileName:"",lineno:0,reset:function(){this.setVideoTiming(this.vdp.videoMode);this.frameCount=0;this.frameskip_counter=this.frameSkip;this.keyboard.reset();
this.ui.reset();this.vdp.reset();this.ports.reset();this.cpu.reset();ENABLE_DEBUGGER&&this.cpu.resetDebug();DEBUG&&clearInterval(this.fpsInterval)},start:function(){var a=this;this.isRunning||(this.isRunning=!0,this.ui.requestAnimationFrame(this.frame.bind(this),this.ui.screen),DEBUG&&(this.resetFps(),this.fpsInterval=setInterval(function(){a.printFps()},fpsInterval)));this.ui.updateStatus("Running")},stop:function(){DEBUG&&clearInterval(this.fpsInterval);this.isRunning=!1},frame:function(){this.isRunning&&
(this.cpu.frame(),this.fpsFrameCount++,this.ui.requestAnimationFrame(this.frame.bind(this),this.ui.screen))},nextStep:function(){this.cpu.frame()},setSMS:function(){this.is_sms=!0;this.is_gg=!1;this.vdp.h_start=0;this.vdp.h_end=32;this.emuWidth=SMS_WIDTH;this.emuHeight=SMS_HEIGHT},setGG:function(){this.is_gg=!0;this.is_sms=!1;this.vdp.h_start=5;this.vdp.h_end=27;this.emuWidth=GG_WIDTH;this.emuHeight=GG_HEIGHT},setVideoTiming:function(a){var b=0;a==NTSC||this.is_gg?(this.fps=60,this.no_of_scanlines=
SMS_Y_PIXELS_NTSC,b=CLOCK_NTSC):(this.fps=50,this.no_of_scanlines=SMS_Y_PIXELS_PAL,b=CLOCK_PAL);this.cyclesPerLine=Math.round(b/this.fps/this.no_of_scanlines+1);this.vdp.videoMode=a;if(this.soundEnabled){this.psg.init(b,SAMPLE_RATE);this.samplesPerFrame=Math.round(SAMPLE_RATE/this.fps);if(0===this.audioBuffer.length||this.audioBuffer.length!=this.samplesPerFrame)this.audioBuffer=Array(this.samplesPerFrame);if(0===this.samplesPerLine.length||this.samplesPerLine.length!=this.no_of_scanlines){this.samplesPerLine=
Array(this.no_of_scanlines);var c=0;for(a=0;a<this.no_of_scanlines;a++)b=(this.samplesPerFrame<<16)/this.no_of_scanlines+c,c=b-(b>>16<<16),this.samplesPerLine[a]=b>>16}}},audioOutput:function(a){this.ui.writeAudio(a)},doRepaint:function(){this.ui.writeFrame()},printFps:function(){var a=JSSMS.Utils.getTimestamp(),b="Running: "+(this.fpsFrameCount/((a-this.lastFpsTime)/1E3)).toFixed(2)+" FPS";this.ui.updateStatus(b);this.fpsFrameCount=0;this.lastFpsTime=a},resetFps:function(){this.lastFpsTime=JSSMS.Utils.getTimestamp();
this.fpsFrameCount=0},updateSound:function(a){0===a&&(this.audioBufferOffset=0);a=this.samplesPerLine[a];this.audioBuffer=this.psg.update(this.audioBufferOffset,a);this.audioBufferOffset+=a},readRomDirectly:function(a,b){var c;c=".gg"==b.substr(-3).toLowerCase()?2:1;var e=a.length;1==c?this.setSMS():2==c&&this.setGG();if(e<=PAGE_SIZE)return!1;c=this.loadROM(a,e);if(null===c)return!1;this.cpu.resetMemory(c);this.romData=a;this.romFileName=b;return!0},loadROM:function(a,b){0!==b%1024&&(a=a.substr(512),
b-=512);var c,e,d=Math.round(b/PAGE_SIZE),g=Array(d);for(c=0;c<d;c++)if(g[c]=JSSMS.Utils.Array(PAGE_SIZE),SUPPORT_DATAVIEW)for(e=0;e<PAGE_SIZE;e++)g[c].setUint8(e,a.charCodeAt(c*PAGE_SIZE+e));else for(e=0;e<PAGE_SIZE;e++)g[c][e]=a.charCodeAt(c*PAGE_SIZE+e)&255;return g},reloadRom:function(){return""!==this.romData&&""!==this.romFileName?this.readRomDirectly(this.romData,this.romFileName):!1}};(function(){"console"in window?"bind"in window.console.log||(window.console.log=function(a){return function(b){return a(b)}}(window.console.log),window.console.error=function(a){return function(b){return a(b)}}(window.console.error)):window.console={log:function(){},error:function(){}}})();
JSSMS.Utils={rndInt:function(a){return Math.round(Math.random()*a)},Uint8Array:function(){return SUPPORT_TYPED_ARRAYS?Uint8Array:Array}(),Array:function(){return SUPPORT_DATAVIEW?function(a){return new DataView(new ArrayBuffer(a))}:Array}(),copyArrayElements:function(){return SUPPORT_DATAVIEW?function(a,b,c,e,d){for(;d--;)c.setInt8(e+d,a.getInt8(b+d))}:function(a,b,c,e,d){for(;d--;)c[e+d]=a[b+d]}}(),console:{log:function(){return DEBUG?window.console.log.bind(window.console):function(a){}}(),error:function(){return DEBUG?
window.console.error.bind(window.console):function(a){}}(),time:function(){return DEBUG&&window.console.time?window.console.time.bind(window.console):function(a){}}(),timeEnd:function(){return DEBUG&&window.console.timeEnd?window.console.timeEnd.bind(window.console):function(a){}}()},traverse:function(a,b){var c,e;b.call(null,a);for(c in a)a.hasOwnProperty(c)&&(e=a[c],Object(e)===e&&(a[c]=JSSMS.Utils.traverse(e,b)));return a},getTimestamp:function(){return window.performance&&window.performance.now?
window.performance.now.bind(window.performance):function(){return(new Date).getTime()}}(),toHex:function(a){a=a.toString(16).toUpperCase();a.length%2&&(a="0"+a);return"0x"+a},getPrefix:function(a,b){var c=!1;void 0===b&&(b=document);a.some(function(a){return a in b?(c=a,!0):!1});return c},isIE:function(){return/msie/i.test(navigator.userAgent)&&!/opera/i.test(navigator.userAgent)}};function BinaryRequest(a,b,c,e,d){a=a||"GET";var g=[];if(c){var h=[],f;for(f in c){var k=encodeURI(f);void 0!==c[f]&&(k+="="+encodeURI(c[f]));h.push(k)}b+="?"+h.join("&")}var l=new XMLHttpRequest;l.open(a,b,!0);try{l.responseType="arraybuffer"}catch(m){console.error("responseType arrayBuffer not supported!")}l.onreadystatechange=function(){if(4==l.readyState){var a;for(a=0;a<g.length;++a)g[a]()}};l.onload=function(){this.response instanceof ArrayBuffer?d(this.response):console.error("Bad response type: "+
typeof this.response+" for "+JSON.stringify(this.response))};l.send(e);this.always=function(a){4==l.readyState&&a();g.push(a);return this}}function SyncWriter(){this.kBufferLength=524288;this.syncBuffer=new Uint16Array(this.kBufferLength);this.fileOffset=this.syncBufferIdx=0;this.curRequest=null;this.buffers=[]}
SyncWriter.prototype={flushBuffer:function(){this.syncBufferIdx>=this.syncBuffer.length&&(this.buffers.push(this.syncBuffer),this.syncBuffer=new Uint16Array(this.kBufferLength),this.syncBufferIdx=0)},tick:function(){if(!this.curRequest&&0<this.syncBufferIdx){for(var a=new Uint16Array(this.syncBufferIdx),b=0;b<this.syncBufferIdx;++b)a[b]=this.syncBuffer[b];this.buffers.push(a);this.syncBuffer=new Uint16Array(this.kBufferLength);this.syncBufferIdx=0}if(!this.curRequest&&0<this.buffers.length){var c=
this,a=this.buffers[0];this.buffers.splice(0,1);var e=2*a.length;this.curRequest=(new BinaryRequest("POST","/wsynclog",{o:this.fileOffset,l:e},a,function(){c.fileOffset+=e})).always(function(){c.curRequest=null})}return 0===this.buffers.length},getAvailableBytes:function(){return 1E9},sync16:function(a,b){this.syncBufferIdx>=this.syncBuffer.length&&this.flushBuffer();this.syncBuffer[this.syncBufferIdx]=a;this.syncBufferIdx++},reflect16:function(a){this.syncBufferIdx>=this.syncBuffer.length&&this.flushBuffer();
this.syncBuffer[this.syncBufferIdx]=a;this.syncBufferIdx++;return a}};function SyncReader(){this.kBufferLength=1048576;this.syncBuffer=null;this.fileOffset=this.syncBufferIdx=0;this.curRequest=null;this.oos=!1;this.nextBuffer=null}
SyncReader.prototype={refill:function(){if(!this.syncBuffer||this.syncBufferIdx>=this.syncBuffer.length)this.syncBuffer=this.nextBuffer,this.syncBufferIdx=0,this.nextBuffer=null},tick:function(){this.refill();if(!this.nextBuffer&&!this.curRequest){var a=this;this.curRequest=(new BinaryRequest("GET","/rsynclog",{o:this.fileOffset,l:this.kBufferLength},void 0,function(b){a.nextBuffer=new Uint16Array(b);a.fileOffset+=b.byteLength})).always(function(){a.curRequest=null});return!1}return!0},getAvailableBytes:function(){var a=
0;this.syncBuffer&&(a+=this.syncBuffer.length-this.syncBufferIdx);this.nextBuffer&&(a+=this.nextBuffer.length);return 2*a},pop:function(){(!this.syncBuffer||this.syncBufferIdx>=this.syncBuffer.length)&&this.refill();if(this.syncBuffer&&this.syncBufferIdx<this.syncBuffer.length){var a=this.syncBuffer[this.syncBufferIdx];this.syncBufferIdx++;return a}return-1},sync16:function(a,b){if(this.oos)return!1;var c=JSSMS.Utils.toHex,e=this.pop();if(a==e)console.log(b,c(a),c(e));else if(console.log("%c"+b,"color: red;",
c(a),c(e)),"pc"==b){debugger;return!1}return!0},reflect16:function(a){return this.oos?a:this.pop()}};var HALT_SPEEDUP=!0,F_CARRY=1,F_NEGATIVE=2,F_PARITY=4,F_OVERFLOW=4,F_BIT3=8,F_HALFCARRY=16,F_BIT5=32,F_ZERO=64,F_SIGN=128,BIT_0=1,BIT_1=2,BIT_2=4,BIT_3=8,BIT_4=16,BIT_5=32,BIT_6=64,BIT_7=128,OP_STATES=[4,10,7,6,4,4,7,4,4,11,7,6,4,4,7,4,8,10,7,6,4,4,7,4,12,11,7,6,4,4,7,4,7,10,16,6,4,4,7,4,7,11,16,6,4,4,7,4,7,10,13,6,11,11,10,4,7,11,13,6,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,7,7,7,7,7,7,4,7,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,
7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,4,4,4,4,4,4,7,4,5,10,10,10,10,11,7,11,5,10,10,0,10,17,7,11,5,10,10,11,10,11,7,11,5,4,10,11,10,0,7,11,5,10,10,19,10,11,7,11,5,4,10,4,10,0,7,11,5,10,10,4,10,11,7,11,5,6,10,4,10,0,7,11],OP_CB_STATES=[8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,
8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,12,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8,8,8,8,8,8,8,15,8],OP_DD_STATES=[4,4,4,4,4,4,4,4,4,15,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,15,4,4,4,4,4,4,4,14,20,10,8,8,11,4,4,15,20,10,8,8,11,4,4,4,4,4,23,23,19,4,4,15,4,4,4,4,4,4,4,4,4,4,8,8,19,4,4,4,
4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,8,8,8,8,8,8,19,8,8,8,8,8,8,8,19,8,19,19,19,19,19,19,4,19,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,8,8,19,4,4,4,4,4,4,4,4,4,4,4,4,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,14,4,23,4,15,4,4,4,8,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,10,4,4,4,4,4,4],OP_INDEX_CB_STATES=[23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23],OP_ED_STATES=[8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,9,12,12,15,20,8,14,8,18,12,12,15,20,8,14,8,18,8,12,15,20,8,14,8,8,12,12,15,20,8,14,8,8,8,8,8,8,8,8,8,8,
8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,16,16,16,16,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8];
JSSMS.Z80=function(a){this.main=a;this.vdp=a.vdp;this.psg=a.psg;this.port=a.ports;this.im=this.sp=this.pc=0;this.interruptLine=this.EI_inst=this.halt=this.iff2=this.iff1=!1;this.tstates=this.totalCycles=this.f2=this.f=this.i=this.r=this.iyH=this.iyL=this.ixH=this.ixL=this.l2=this.h2=this.l=this.h=this.e2=this.d2=this.e=this.d=this.c2=this.b2=this.c=this.b=this.a2=this.a=this.interruptVector=0;this.rom=[];this.sram=JSSMS.Utils.Array(32768);this.useSRAM=!1;this.frameReg=Array(4);this.number_of_pages=
this.romPageMask=0;this.memWriteMap=JSSMS.Utils.Array(8192);this.DAA_TABLE=Array(2048);this.SZ_TABLE=Array(256);this.SZP_TABLE=Array(256);this.SZHV_INC_TABLE=Array(256);this.SZHV_DEC_TABLE=Array(256);this.SZHVC_ADD_TABLE=Array(131072);this.SZHVC_SUB_TABLE=Array(131072);this.SZ_BIT_TABLE=Array(256);this.generateFlagTables();this.generateDAATable();this.generateMemory();if(ENABLE_DEBUGGER)for(var b in JSSMS.Debugger.prototype)this[b]=JSSMS.Debugger.prototype[b];ENABLE_COMPILER&&(this.recompiler=new Recompiler(this));
ENABLE_SERVER_LOGGER&&(this.syncServer=SYNC_MODE==WRITE_MODE?new SyncWriter:new SyncReader,this.syncServer.tick(),this.sync=function(){this.syncServer.sync16(this.pc,"pc")})};
JSSMS.Z80.prototype={reset:function(){this.pc=this.f2=this.f=this.i=this.r=this.iyL=this.iyH=this.ixL=this.ixH=this.h=this.l=this.h2=this.l2=this.d=this.e=this.d2=this.e2=this.b=this.c=this.b2=this.c2=this.a=this.a2=0;this.sp=57328;this.im=this.tstates=this.totalCycles=0;this.EI_inst=this.iff2=this.iff1=!1;this.interruptVector=0;this.halt=!1;ENABLE_COMPILER&&this.recompiler.reset()},frame:function(){this.lineno=0;this.tstates+=this.main.cyclesPerLine;this.totalCycles=this.main.cyclesPerLine;for(ACCURATE_INTERRUPT_EMULATION&&
this.interruptLine&&this.interrupt();!(ENABLE_DEBUGGER&&this.main.ui.updateDisassembly(this.pc),ENABLE_COMPILER?this.recompile():(ENABLE_SERVER_LOGGER&&this.sync(),this.interpret()),0>=this.tstates&&this.eol()););ENABLE_SERVER_LOGGER&&this.syncServer.tick()},recompile:function(){1024>this.pc?(this.branches[0][this.pc]||this.recompiler.recompileFromAddress(this.pc,0,0),this.branches[0][this.pc].call(this,0)):16384>this.pc?(this.branches[this.frameReg[0]][this.pc]||this.recompiler.recompileFromAddress(this.pc,
this.frameReg[0],0),this.branches[this.frameReg[0]][this.pc].call(this,0)):32768>this.pc?(this.branches[this.frameReg[1]][this.pc-16384]||this.recompiler.recompileFromAddress(this.pc,this.frameReg[1],1),this.branches[this.frameReg[1]][this.pc-16384].call(this,1)):49152>this.pc?(this.branches[this.frameReg[2]][this.pc-32768]||this.recompiler.recompileFromAddress(this.pc,this.frameReg[2],2),this.branches[this.frameReg[2]][this.pc-32768].call(this,2)):this.interpret()},eol:function(){this.main.soundEnabled&&
this.main.updateSound(this.lineno);this.vdp.line=this.lineno;192>this.lineno&&this.vdp.drawLine(this.lineno);this.vdp.interrupts(this.lineno);this.interruptLine&&this.interrupt();this.lineno++;if(this.lineno>=this.main.no_of_scanlines)return this.eof(),!0;this.tstates+=this.main.cyclesPerLine;this.totalCycles=this.main.cyclesPerLine;return!1},eof:function(){this.main.soundEnabled&&this.main.audioOutput(this.main.audioBuffer);this.main.pause_button&&(this.nmi(),this.main.pause_button=!1);this.main.doRepaint()},
branches:[Object.create(null),Object.create(null),Object.create(null)],interpret:function(){var a=0,a=this.readMem(this.pc++);ACCURATE_INTERRUPT_EMULATION&&(this.EI_inst=!1);this.tstates-=OP_STATES[a];REFRESH_EMULATION&&this.incR();switch(a){case 1:this.setBC(this.readMemWord(this.pc++));this.pc++;break;case 2:this.writeMem(this.getBC(),this.a);break;case 3:this.incBC();break;case 4:this.b=this.inc8(this.b);break;case 5:this.b=this.dec8(this.b);break;case 6:this.b=this.readMem(this.pc++);break;case 7:this.rlca_a();
break;case 8:this.exAF();break;case 9:this.setHL(this.add16(this.getHL(),this.getBC()));break;case 10:this.a=this.readMem(this.getBC());break;case 11:this.decBC();break;case 12:this.c=this.inc8(this.c);break;case 13:this.c=this.dec8(this.c);break;case 14:this.c=this.readMem(this.pc++);break;case 15:this.rrca_a();break;case 16:this.b=this.b-1&255;this.jr(0!==this.b);break;case 17:this.setDE(this.readMemWord(this.pc++));this.pc++;break;case 18:this.writeMem(this.getDE(),this.a);break;case 19:this.incDE();
break;case 20:this.d=this.inc8(this.d);break;case 21:this.d=this.dec8(this.d);break;case 22:this.d=this.readMem(this.pc++);break;case 23:this.rla_a();break;case 24:this.pc+=this.signExtend(this.d_()+1);break;case 25:this.setHL(this.add16(this.getHL(),this.getDE()));break;case 26:this.a=this.readMem(this.getDE());break;case 27:this.decDE();break;case 28:this.e=this.inc8(this.e);break;case 29:this.e=this.dec8(this.e);break;case 30:this.e=this.readMem(this.pc++);break;case 31:this.rra_a();break;case 32:this.jr(0===
(this.f&F_ZERO));break;case 33:this.setHL(this.readMemWord(this.pc++));this.pc++;break;case 34:this.writeMemWord(this.readMemWord(this.pc++),this.getHL());this.pc++;break;case 35:this.incHL();break;case 36:this.h=this.inc8(this.h);break;case 37:this.h=this.dec8(this.h);break;case 38:this.h=this.readMem(this.pc++);break;case 39:this.daa();break;case 40:this.jr(0!==(this.f&F_ZERO));break;case 41:this.setHL(this.add16(this.getHL(),this.getHL()));break;case 42:this.setHL(this.readMemWord(this.readMemWord(this.pc++)));
this.pc++;break;case 43:this.decHL();break;case 44:this.l=this.inc8(this.l);break;case 45:this.l=this.dec8(this.l);break;case 46:this.l=this.readMem(this.pc++);break;case 47:this.cpl_a();break;case 48:this.jr(0===(this.f&F_CARRY));break;case 49:this.sp=this.readMemWord(this.pc++);this.pc++;break;case 50:this.writeMem(this.readMemWord(this.pc++),this.a);this.pc++;break;case 51:this.sp++;break;case 52:this.incMem(this.getHL());break;case 53:this.decMem(this.getHL());break;case 54:this.writeMem(this.getHL(),
this.readMem(this.pc++));break;case 55:this.f|=F_CARRY;this.f&=~F_NEGATIVE;this.f&=~F_HALFCARRY;break;case 56:this.jr(0!==(this.f&F_CARRY));break;case 57:this.setHL(this.add16(this.getHL(),this.sp));break;case 58:this.a=this.readMem(this.readMemWord(this.pc++));this.pc++;break;case 59:this.sp--;break;case 60:this.a=this.inc8(this.a);break;case 61:this.a=this.dec8(this.a);break;case 62:this.a=this.readMem(this.pc++);break;case 63:this.ccf();break;case 65:this.b=this.c;break;case 66:this.b=this.d;break;
case 67:this.b=this.e;break;case 68:this.b=this.h;break;case 69:this.b=this.l;break;case 70:this.b=this.readMem(this.getHL());break;case 71:this.b=this.a;break;case 72:this.c=this.b;break;case 74:this.c=this.d;break;case 75:this.c=this.e;break;case 76:this.c=this.h;break;case 77:this.c=this.l;break;case 78:this.c=this.readMem(this.getHL());break;case 79:this.c=this.a;break;case 80:this.d=this.b;break;case 81:this.d=this.c;break;case 83:this.d=this.e;break;case 84:this.d=this.h;break;case 85:this.d=
this.l;break;case 86:this.d=this.readMem(this.getHL());break;case 87:this.d=this.a;break;case 88:this.e=this.b;break;case 89:this.e=this.c;break;case 90:this.e=this.d;break;case 92:this.e=this.h;break;case 93:this.e=this.l;break;case 94:this.e=this.readMem(this.getHL());break;case 95:this.e=this.a;break;case 96:this.h=this.b;break;case 97:this.h=this.c;break;case 98:this.h=this.d;break;case 99:this.h=this.e;break;case 101:this.h=this.l;break;case 102:this.h=this.readMem(this.getHL());break;case 103:this.h=
this.a;break;case 104:this.l=this.b;break;case 105:this.l=this.c;break;case 106:this.l=this.d;break;case 107:this.l=this.e;break;case 108:this.l=this.h;break;case 110:this.l=this.readMem(this.getHL());break;case 111:this.l=this.a;break;case 112:this.writeMem(this.getHL(),this.b);break;case 113:this.writeMem(this.getHL(),this.c);break;case 114:this.writeMem(this.getHL(),this.d);break;case 115:this.writeMem(this.getHL(),this.e);break;case 116:this.writeMem(this.getHL(),this.h);break;case 117:this.writeMem(this.getHL(),
this.l);break;case 118:HALT_SPEEDUP&&(this.tstates=0);this.halt=!0;this.pc--;break;case 119:this.writeMem(this.getHL(),this.a);break;case 120:this.a=this.b;break;case 121:this.a=this.c;break;case 122:this.a=this.d;break;case 123:this.a=this.e;break;case 124:this.a=this.h;break;case 125:this.a=this.l;break;case 126:this.a=this.readMem(this.getHL());break;case 128:this.add_a(this.b);break;case 129:this.add_a(this.c);break;case 130:this.add_a(this.d);break;case 131:this.add_a(this.e);break;case 132:this.add_a(this.h);
break;case 133:this.add_a(this.l);break;case 134:this.add_a(this.readMem(this.getHL()));break;case 135:this.add_a(this.a);break;case 136:this.adc_a(this.b);break;case 137:this.adc_a(this.c);break;case 138:this.adc_a(this.d);break;case 139:this.adc_a(this.e);break;case 140:this.adc_a(this.h);break;case 141:this.adc_a(this.l);break;case 142:this.adc_a(this.readMem(this.getHL()));break;case 143:this.adc_a(this.a);break;case 144:this.sub_a(this.b);break;case 145:this.sub_a(this.c);break;case 146:this.sub_a(this.d);
break;case 147:this.sub_a(this.e);break;case 148:this.sub_a(this.h);break;case 149:this.sub_a(this.l);break;case 150:this.sub_a(this.readMem(this.getHL()));break;case 151:this.sub_a(this.a);break;case 152:this.sbc_a(this.b);break;case 153:this.sbc_a(this.c);break;case 154:this.sbc_a(this.d);break;case 155:this.sbc_a(this.e);break;case 156:this.sbc_a(this.h);break;case 157:this.sbc_a(this.l);break;case 158:this.sbc_a(this.readMem(this.getHL()));break;case 159:this.sbc_a(this.a);break;case 160:this.f=
this.SZP_TABLE[this.a&=this.b]|F_HALFCARRY;break;case 161:this.f=this.SZP_TABLE[this.a&=this.c]|F_HALFCARRY;break;case 162:this.f=this.SZP_TABLE[this.a&=this.d]|F_HALFCARRY;break;case 163:this.f=this.SZP_TABLE[this.a&=this.e]|F_HALFCARRY;break;case 164:this.f=this.SZP_TABLE[this.a&=this.h]|F_HALFCARRY;break;case 165:this.f=this.SZP_TABLE[this.a&=this.l]|F_HALFCARRY;break;case 166:this.f=this.SZP_TABLE[this.a&=this.readMem(this.getHL())]|F_HALFCARRY;break;case 167:this.f=this.SZP_TABLE[this.a]|F_HALFCARRY;
break;case 168:this.f=this.SZP_TABLE[this.a^=this.b];break;case 169:this.f=this.SZP_TABLE[this.a^=this.c];break;case 170:this.f=this.SZP_TABLE[this.a^=this.d];break;case 171:this.f=this.SZP_TABLE[this.a^=this.e];break;case 172:this.f=this.SZP_TABLE[this.a^=this.h];break;case 173:this.f=this.SZP_TABLE[this.a^=this.l];break;case 174:this.f=this.SZP_TABLE[this.a^=this.readMem(this.getHL())];break;case 175:this.f=this.SZP_TABLE[this.a=0];break;case 176:this.f=this.SZP_TABLE[this.a|=this.b];break;case 177:this.f=
this.SZP_TABLE[this.a|=this.c];break;case 178:this.f=this.SZP_TABLE[this.a|=this.d];break;case 179:this.f=this.SZP_TABLE[this.a|=this.e];break;case 180:this.f=this.SZP_TABLE[this.a|=this.h];break;case 181:this.f=this.SZP_TABLE[this.a|=this.l];break;case 182:this.f=this.SZP_TABLE[this.a|=this.readMem(this.getHL())];break;case 183:this.f=this.SZP_TABLE[this.a];break;case 184:this.cp_a(this.b);break;case 185:this.cp_a(this.c);break;case 186:this.cp_a(this.d);break;case 187:this.cp_a(this.e);break;case 188:this.cp_a(this.h);
break;case 189:this.cp_a(this.l);break;case 190:this.cp_a(this.readMem(this.getHL()));break;case 191:this.cp_a(this.a);break;case 192:this.ret(0===(this.f&F_ZERO));break;case 193:this.setBC(this.readMemWord(this.sp));this.sp+=2;break;case 194:this.jp(0===(this.f&F_ZERO));break;case 195:this.pc=this.readMemWord(this.pc);break;case 196:this.call(0===(this.f&F_ZERO));break;case 197:this.push(this.getBC());break;case 198:this.add_a(this.readMem(this.pc++));break;case 199:this.push(this.pc);this.pc=0;
break;case 200:this.ret(0!==(this.f&F_ZERO));break;case 201:this.pc=this.readMemWord(this.sp);this.sp+=2;break;case 202:this.jp(0!==(this.f&F_ZERO));break;case 203:this.doCB(this.readMem(this.pc++));break;case 204:this.call(0!==(this.f&F_ZERO));break;case 205:this.push(this.pc+2);this.pc=this.readMemWord(this.pc);break;case 206:this.adc_a(this.readMem(this.pc++));break;case 207:this.push(this.pc);this.pc=8;break;case 208:this.ret(0===(this.f&F_CARRY));break;case 209:this.setDE(this.readMemWord(this.sp));
this.sp+=2;break;case 210:this.jp(0===(this.f&F_CARRY));break;case 211:this.port.out(this.readMem(this.pc++),this.a);break;case 212:this.call(0===(this.f&F_CARRY));break;case 213:this.push(this.getDE());break;case 214:this.sub_a(this.readMem(this.pc++));break;case 215:this.push(this.pc);this.pc=16;break;case 216:this.ret(0!==(this.f&F_CARRY));break;case 217:this.exBC();this.exDE();this.exHL();break;case 218:this.jp(0!==(this.f&F_CARRY));break;case 219:this.a=this.port.in_(this.readMem(this.pc++));
break;case 220:this.call(0!==(this.f&F_CARRY));break;case 221:this.doIndexOpIX(this.readMem(this.pc++));break;case 222:this.sbc_a(this.readMem(this.pc++));break;case 223:this.push(this.pc);this.pc=24;break;case 224:this.ret(0===(this.f&F_PARITY));break;case 225:this.setHL(this.readMemWord(this.sp));this.sp+=2;break;case 226:this.jp(0===(this.f&F_PARITY));break;case 227:a=this.getHL();this.setHL(this.readMemWord(this.sp));this.writeMemWord(this.sp,a);break;case 228:this.call(0===(this.f&F_PARITY));
break;case 229:this.push(this.getHL());break;case 230:this.f=this.SZP_TABLE[this.a&=this.readMem(this.pc++)]|F_HALFCARRY;break;case 231:this.push(this.pc);this.pc=32;break;case 232:this.ret(0!==(this.f&F_PARITY));break;case 233:this.pc=this.getHL();break;case 234:this.jp(0!==(this.f&F_PARITY));break;case 235:a=this.d;this.d=this.h;this.h=a;a=this.e;this.e=this.l;this.l=a;break;case 236:this.call(0!==(this.f&F_PARITY));break;case 237:this.doED(this.readMem(this.pc));break;case 238:this.f=this.SZP_TABLE[this.a^=
this.readMem(this.pc++)];break;case 239:this.push(this.pc);this.pc=40;break;case 240:this.ret(0===(this.f&F_SIGN));break;case 241:this.setAF(this.readMemWord(this.sp));this.sp+=2;break;case 242:this.jp(0===(this.f&F_SIGN));break;case 243:this.iff1=this.iff2=!1;this.EI_inst=!0;break;case 244:this.call(0===(this.f&F_SIGN));break;case 245:this.push(this.getAF());break;case 246:this.f=this.SZP_TABLE[this.a|=this.readMem(this.pc++)];break;case 247:this.push(this.pc);this.pc=48;break;case 248:this.ret(0!==
(this.f&F_SIGN));break;case 249:this.sp=this.getHL();break;case 250:this.jp(0!==(this.f&F_SIGN));break;case 251:this.iff1=this.iff2=this.EI_inst=!0;break;case 252:this.call(0!==(this.f&F_SIGN));break;case 253:this.doIndexOpIY(this.readMem(this.pc++));break;case 254:this.cp_a(this.readMem(this.pc++));break;case 255:this.push(this.pc),this.pc=56}},getCycle:function(){return this.totalCycles-this.tstates},nmi:function(){this.iff2=this.iff1;this.iff1=!1;REFRESH_EMULATION&&this.incR();this.halt&&(this.pc++,
this.halt=!1);this.push(this.pc);this.pc=102;this.tstates-=11},interrupt:function(){!this.iff1||ACCURATE_INTERRUPT_EMULATION&&this.EI_inst||(this.halt&&(this.pc++,this.halt=!1),REFRESH_EMULATION&&this.incR(),this.interruptLine=this.iff1=this.iff2=!1,this.push(this.pc),0===this.im?(this.pc=0===this.interruptVector||255===this.interruptVector?56:this.interruptVector,this.tstates-=13):1==this.im?(this.pc=56,this.tstates-=13):(this.pc=this.readMemWord((this.i<<8)+this.interruptVector),this.tstates-=19))},
jp:function(a){this.pc=a?this.readMemWord(this.pc):this.pc+2},jr:function(a){a?(this.pc+=this.signExtend(this.d_()+1),this.tstates-=5):this.pc++},signExtend:function(a){128<=a&&(a-=256);return a},call:function(a){a?(this.push(this.pc+2),this.pc=this.readMemWord(this.pc),this.tstates-=7):this.pc+=2},ret:function(a){a&&(this.pc=this.readMemWord(this.sp),this.sp+=2,this.tstates-=6)},push:function(a){this.sp-=2;this.writeMemWord(this.sp,a)},pushUint8:function(a,b){this.sp-=2;this.writeMemWord(this.sp,
a<<8|b)},incMem:function(a){this.writeMem(a,this.inc8(this.readMem(a)))},decMem:function(a){this.writeMem(a,this.dec8(this.readMem(a)))},ccf:function(){0!==(this.f&F_CARRY)?(this.f&=~F_CARRY,this.f|=F_HALFCARRY):(this.f|=F_CARRY,this.f&=~F_HALFCARRY);this.f&=~F_NEGATIVE},daa:function(){var a=this.DAA_TABLE[this.a|(this.f&F_CARRY)<<8|(this.f&F_NEGATIVE)<<8|(this.f&F_HALFCARRY)<<6];this.a=a&255;this.f=this.f&F_NEGATIVE|a>>8},doCB:function(a){this.tstates-=OP_CB_STATES[a];REFRESH_EMULATION&&this.incR();
switch(a){case 0:this.b=this.rlc(this.b);break;case 1:this.c=this.rlc(this.c);break;case 2:this.d=this.rlc(this.d);break;case 3:this.e=this.rlc(this.e);break;case 4:this.h=this.rlc(this.h);break;case 5:this.l=this.rlc(this.l);break;case 6:this.writeMem(this.getHL(),this.rlc(this.readMem(this.getHL())));break;case 7:this.a=this.rlc(this.a);break;case 8:this.b=this.rrc(this.b);break;case 9:this.c=this.rrc(this.c);break;case 10:this.d=this.rrc(this.d);break;case 11:this.e=this.rrc(this.e);break;case 12:this.h=
this.rrc(this.h);break;case 13:this.l=this.rrc(this.l);break;case 14:this.writeMem(this.getHL(),this.rrc(this.readMem(this.getHL())));break;case 15:this.a=this.rrc(this.a);break;case 16:this.b=this.rl(this.b);break;case 17:this.c=this.rl(this.c);break;case 18:this.d=this.rl(this.d);break;case 19:this.e=this.rl(this.e);break;case 20:this.h=this.rl(this.h);break;case 21:this.l=this.rl(this.l);break;case 22:this.writeMem(this.getHL(),this.rl(this.readMem(this.getHL())));break;case 23:this.a=this.rl(this.a);
break;case 24:this.b=this.rr(this.b);break;case 25:this.c=this.rr(this.c);break;case 26:this.d=this.rr(this.d);break;case 27:this.e=this.rr(this.e);break;case 28:this.h=this.rr(this.h);break;case 29:this.l=this.rr(this.l);break;case 30:this.writeMem(this.getHL(),this.rr(this.readMem(this.getHL())));break;case 31:this.a=this.rr(this.a);break;case 32:this.b=this.sla(this.b);break;case 33:this.c=this.sla(this.c);break;case 34:this.d=this.sla(this.d);break;case 35:this.e=this.sla(this.e);break;case 36:this.h=
this.sla(this.h);break;case 37:this.l=this.sla(this.l);break;case 38:this.writeMem(this.getHL(),this.sla(this.readMem(this.getHL())));break;case 39:this.a=this.sla(this.a);break;case 40:this.b=this.sra(this.b);break;case 41:this.c=this.sra(this.c);break;case 42:this.d=this.sra(this.d);break;case 43:this.e=this.sra(this.e);break;case 44:this.h=this.sra(this.h);break;case 45:this.l=this.sra(this.l);break;case 46:this.writeMem(this.getHL(),this.sra(this.readMem(this.getHL())));break;case 47:this.a=this.sra(this.a);
break;case 48:this.b=this.sll(this.b);break;case 49:this.c=this.sll(this.c);break;case 50:this.d=this.sll(this.d);break;case 51:this.e=this.sll(this.e);break;case 52:this.h=this.sll(this.h);break;case 53:this.l=this.sll(this.l);break;case 54:this.writeMem(this.getHL(),this.sll(this.readMem(this.getHL())));break;case 55:this.a=this.sll(this.a);break;case 56:this.b=this.srl(this.b);break;case 57:this.c=this.srl(this.c);break;case 58:this.d=this.srl(this.d);break;case 59:this.e=this.srl(this.e);break;
case 60:this.h=this.srl(this.h);break;case 61:this.l=this.srl(this.l);break;case 62:this.writeMem(this.getHL(),this.srl(this.readMem(this.getHL())));break;case 63:this.a=this.srl(this.a);break;case 64:this.bit(this.b&BIT_0);break;case 65:this.bit(this.c&BIT_0);break;case 66:this.bit(this.d&BIT_0);break;case 67:this.bit(this.e&BIT_0);break;case 68:this.bit(this.h&BIT_0);break;case 69:this.bit(this.l&BIT_0);break;case 70:this.bit(this.readMem(this.getHL())&BIT_0);break;case 71:this.bit(this.a&BIT_0);
break;case 72:this.bit(this.b&BIT_1);break;case 73:this.bit(this.c&BIT_1);break;case 74:this.bit(this.d&BIT_1);break;case 75:this.bit(this.e&BIT_1);break;case 76:this.bit(this.h&BIT_1);break;case 77:this.bit(this.l&BIT_1);break;case 78:this.bit(this.readMem(this.getHL())&BIT_1);break;case 79:this.bit(this.a&BIT_1);break;case 80:this.bit(this.b&BIT_2);break;case 81:this.bit(this.c&BIT_2);break;case 82:this.bit(this.d&BIT_2);break;case 83:this.bit(this.e&BIT_2);break;case 84:this.bit(this.h&BIT_2);
break;case 85:this.bit(this.l&BIT_2);break;case 86:this.bit(this.readMem(this.getHL())&BIT_2);break;case 87:this.bit(this.a&BIT_2);break;case 88:this.bit(this.b&BIT_3);break;case 89:this.bit(this.c&BIT_3);break;case 90:this.bit(this.d&BIT_3);break;case 91:this.bit(this.e&BIT_3);break;case 92:this.bit(this.h&BIT_3);break;case 93:this.bit(this.l&BIT_3);break;case 94:this.bit(this.readMem(this.getHL())&BIT_3);break;case 95:this.bit(this.a&BIT_3);break;case 96:this.bit(this.b&BIT_4);break;case 97:this.bit(this.c&
BIT_4);break;case 98:this.bit(this.d&BIT_4);break;case 99:this.bit(this.e&BIT_4);break;case 100:this.bit(this.h&BIT_4);break;case 101:this.bit(this.l&BIT_4);break;case 102:this.bit(this.readMem(this.getHL())&BIT_4);break;case 103:this.bit(this.a&BIT_4);break;case 104:this.bit(this.b&BIT_5);break;case 105:this.bit(this.c&BIT_5);break;case 106:this.bit(this.d&BIT_5);break;case 107:this.bit(this.e&BIT_5);break;case 108:this.bit(this.h&BIT_5);break;case 109:this.bit(this.l&BIT_5);break;case 110:this.bit(this.readMem(this.getHL())&
BIT_5);break;case 111:this.bit(this.a&BIT_5);break;case 112:this.bit(this.b&BIT_6);break;case 113:this.bit(this.c&BIT_6);break;case 114:this.bit(this.d&BIT_6);break;case 115:this.bit(this.e&BIT_6);break;case 116:this.bit(this.h&BIT_6);break;case 117:this.bit(this.l&BIT_6);break;case 118:this.bit(this.readMem(this.getHL())&BIT_6);break;case 119:this.bit(this.a&BIT_6);break;case 120:this.bit(this.b&BIT_7);break;case 121:this.bit(this.c&BIT_7);break;case 122:this.bit(this.d&BIT_7);break;case 123:this.bit(this.e&
BIT_7);break;case 124:this.bit(this.h&BIT_7);break;case 125:this.bit(this.l&BIT_7);break;case 126:this.bit(this.readMem(this.getHL())&BIT_7);break;case 127:this.bit(this.a&BIT_7);break;case 128:this.b&=~BIT_0;break;case 129:this.c&=~BIT_0;break;case 130:this.d&=~BIT_0;break;case 131:this.e&=~BIT_0;break;case 132:this.h&=~BIT_0;break;case 133:this.l&=~BIT_0;break;case 134:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_0);break;case 135:this.a&=~BIT_0;break;case 136:this.b&=~BIT_1;break;
case 137:this.c&=~BIT_1;break;case 138:this.d&=~BIT_1;break;case 139:this.e&=~BIT_1;break;case 140:this.h&=~BIT_1;break;case 141:this.l&=~BIT_1;break;case 142:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_1);break;case 143:this.a&=~BIT_1;break;case 144:this.b&=~BIT_2;break;case 145:this.c&=~BIT_2;break;case 146:this.d&=~BIT_2;break;case 147:this.e&=~BIT_2;break;case 148:this.h&=~BIT_2;break;case 149:this.l&=~BIT_2;break;case 150:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_2);
break;case 151:this.a&=~BIT_2;break;case 152:this.b&=~BIT_3;break;case 153:this.c&=~BIT_3;break;case 154:this.d&=~BIT_3;break;case 155:this.e&=~BIT_3;break;case 156:this.h&=~BIT_3;break;case 157:this.l&=~BIT_3;break;case 158:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_3);break;case 159:this.a&=~BIT_3;break;case 160:this.b&=~BIT_4;break;case 161:this.c&=~BIT_4;break;case 162:this.d&=~BIT_4;break;case 163:this.e&=~BIT_4;break;case 164:this.h&=~BIT_4;break;case 165:this.l&=~BIT_4;break;
case 166:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_4);break;case 167:this.a&=~BIT_4;break;case 168:this.b&=~BIT_5;break;case 169:this.c&=~BIT_5;break;case 170:this.d&=~BIT_5;break;case 171:this.e&=~BIT_5;break;case 172:this.h&=~BIT_5;break;case 173:this.l&=~BIT_5;break;case 174:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_5);break;case 175:this.a&=~BIT_5;break;case 176:this.b&=~BIT_6;break;case 177:this.c&=~BIT_6;break;case 178:this.d&=~BIT_6;break;case 179:this.e&=
~BIT_6;break;case 180:this.h&=~BIT_6;break;case 181:this.l&=~BIT_6;break;case 182:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_6);break;case 183:this.a&=~BIT_6;break;case 184:this.b&=~BIT_7;break;case 185:this.c&=~BIT_7;break;case 186:this.d&=~BIT_7;break;case 187:this.e&=~BIT_7;break;case 188:this.h&=~BIT_7;break;case 189:this.l&=~BIT_7;break;case 190:this.writeMem(this.getHL(),this.readMem(this.getHL())&~BIT_7);break;case 191:this.a&=~BIT_7;break;case 192:this.b|=BIT_0;break;case 193:this.c|=
BIT_0;break;case 194:this.d|=BIT_0;break;case 195:this.e|=BIT_0;break;case 196:this.h|=BIT_0;break;case 197:this.l|=BIT_0;break;case 198:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_0);break;case 199:this.a|=BIT_0;break;case 200:this.b|=BIT_1;break;case 201:this.c|=BIT_1;break;case 202:this.d|=BIT_1;break;case 203:this.e|=BIT_1;break;case 204:this.h|=BIT_1;break;case 205:this.l|=BIT_1;break;case 206:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_1);break;case 207:this.a|=BIT_1;
break;case 208:this.b|=BIT_2;break;case 209:this.c|=BIT_2;break;case 210:this.d|=BIT_2;break;case 211:this.e|=BIT_2;break;case 212:this.h|=BIT_2;break;case 213:this.l|=BIT_2;break;case 214:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_2);break;case 215:this.a|=BIT_2;break;case 216:this.b|=BIT_3;break;case 217:this.c|=BIT_3;break;case 218:this.d|=BIT_3;break;case 219:this.e|=BIT_3;break;case 220:this.h|=BIT_3;break;case 221:this.l|=BIT_3;break;case 222:this.writeMem(this.getHL(),this.readMem(this.getHL())|
BIT_3);break;case 223:this.a|=BIT_3;break;case 224:this.b|=BIT_4;break;case 225:this.c|=BIT_4;break;case 226:this.d|=BIT_4;break;case 227:this.e|=BIT_4;break;case 228:this.h|=BIT_4;break;case 229:this.l|=BIT_4;break;case 230:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_4);break;case 231:this.a|=BIT_4;break;case 232:this.b|=BIT_5;break;case 233:this.c|=BIT_5;break;case 234:this.d|=BIT_5;break;case 235:this.e|=BIT_5;break;case 236:this.h|=BIT_5;break;case 237:this.l|=BIT_5;break;case 238:this.writeMem(this.getHL(),
this.readMem(this.getHL())|BIT_5);break;case 239:this.a|=BIT_5;break;case 240:this.b|=BIT_6;break;case 241:this.c|=BIT_6;break;case 242:this.d|=BIT_6;break;case 243:this.e|=BIT_6;break;case 244:this.h|=BIT_6;break;case 245:this.l|=BIT_6;break;case 246:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_6);break;case 247:this.a|=BIT_6;break;case 248:this.b|=BIT_7;break;case 249:this.c|=BIT_7;break;case 250:this.d|=BIT_7;break;case 251:this.e|=BIT_7;break;case 252:this.h|=BIT_7;break;case 253:this.l|=
BIT_7;break;case 254:this.writeMem(this.getHL(),this.readMem(this.getHL())|BIT_7);break;case 255:this.a|=BIT_7;break;default:JSSMS.Utils.console.log("Unimplemented CB Opcode: "+JSSMS.Utils.toHex(a))}},rlc:function(a){var b=(a&128)>>7;a=(a<<1|a>>7)&255;this.f=b|this.SZP_TABLE[a];return a},rrc:function(a){var b=a&1;a=(a>>1|a<<7)&255;this.f=b|this.SZP_TABLE[a];return a},rl:function(a){var b=(a&128)>>7;a=(a<<1|this.f&F_CARRY)&255;this.f=b|this.SZP_TABLE[a];return a},rr:function(a){var b=a&1;a=(a>>1|this.f<<
7)&255;this.f=b|this.SZP_TABLE[a];return a},sla:function(a){var b=(a&128)>>7;a=a<<1&255;this.f=b|this.SZP_TABLE[a];return a},sll:function(a){var b=(a&128)>>7;a=(a<<1|1)&255;this.f=b|this.SZP_TABLE[a];return a},sra:function(a){var b=a&1;a=a>>1|a&128;this.f=b|this.SZP_TABLE[a];return a},srl:function(a){var b=a&1;a=a>>1&255;this.f=b|this.SZP_TABLE[a];return a},bit:function(a){this.f=this.f&F_CARRY|this.SZ_BIT_TABLE[a]},doIndexOpIX:function(a){var b=0;this.tstates-=OP_DD_STATES[a];REFRESH_EMULATION&&
this.incR();switch(a){case 9:this.setIXHIXL(this.add16(this.getIXHIXL(),this.getBC()));break;case 25:this.setIXHIXL(this.add16(this.getIXHIXL(),this.getDE()));break;case 33:this.setIXHIXL(this.readMemWord(this.pc++));this.pc++;break;case 34:this.writeMemWord(this.readMemWord(this.pc++),this.getIXHIXL());this.pc++;break;case 35:this.incIXHIXL();break;case 36:this.ixH=this.inc8(this.ixH);break;case 37:this.ixH=this.dec8(this.ixH);break;case 38:this.ixH=this.readMem(this.pc++);break;case 41:this.setIXHIXL(this.add16(this.getIXHIXL(),
this.getIXHIXL()));break;case 42:this.setIXHIXL(this.readMemWord(this.readMemWord(this.pc++)));this.pc++;break;case 43:this.decIXHIXL();break;case 44:this.ixL=this.inc8(this.ixL);break;case 45:this.ixL=this.dec8(this.ixL);break;case 46:this.ixL=this.readMem(this.pc++);break;case 52:this.incMem(this.getIXHIXL()+this.d_());this.pc++;break;case 53:this.decMem(this.getIXHIXL()+this.d_());this.pc++;break;case 54:this.writeMem(this.getIXHIXL()+this.d_(),this.readMem(++this.pc));this.pc++;break;case 57:this.setIXHIXL(this.add16(this.getIXHIXL(),
this.sp));break;case 68:this.b=this.ixH;break;case 69:this.b=this.ixL;break;case 70:this.b=this.readMem(this.getIXHIXL()+this.d_());this.pc++;break;case 76:this.c=this.ixH;break;case 77:this.c=this.ixL;break;case 78:this.c=this.readMem(this.getIXHIXL()+this.d_());this.pc++;break;case 84:this.d=this.ixH;break;case 85:this.d=this.ixL;break;case 86:this.d=this.readMem(this.getIXHIXL()+this.d_());this.pc++;break;case 92:this.e=this.ixH;break;case 93:this.e=this.ixL;break;case 94:this.e=this.readMem(this.getIXHIXL()+
this.d_());this.pc++;break;case 96:this.ixH=this.b;break;case 97:this.ixH=this.c;break;case 98:this.ixH=this.d;break;case 99:this.ixH=this.e;break;case 100:break;case 101:this.ixH=this.ixL;break;case 102:this.h=this.readMem(this.getIXHIXL()+this.d_());this.pc++;break;case 103:this.ixH=this.a;break;case 104:this.ixL=this.b;break;case 105:this.ixL=this.c;break;case 106:this.ixL=this.d;break;case 107:this.ixL=this.e;break;case 108:this.ixL=this.ixH;break;case 109:break;case 110:this.l=this.readMem(this.getIXHIXL()+
this.d_());this.pc++;break;case 111:this.ixL=this.a;break;case 112:this.writeMem(this.getIXHIXL()+this.d_(),this.b);this.pc++;break;case 113:this.writeMem(this.getIXHIXL()+this.d_(),this.c);this.pc++;break;case 114:this.writeMem(this.getIXHIXL()+this.d_(),this.d);this.pc++;break;case 115:this.writeMem(this.getIXHIXL()+this.d_(),this.e);this.pc++;break;case 116:this.writeMem(this.getIXHIXL()+this.d_(),this.h);this.pc++;break;case 117:this.writeMem(this.getIXHIXL()+this.d_(),this.l);this.pc++;break;
case 119:this.writeMem(this.getIXHIXL()+this.d_(),this.a);this.pc++;break;case 124:this.a=this.ixH;break;case 125:this.a=this.ixL;break;case 126:this.a=this.readMem(this.getIXHIXL()+this.d_());this.pc++;break;case 132:this.add_a(this.ixH);break;case 133:this.add_a(this.ixL);break;case 134:this.add_a(this.readMem(this.getIXHIXL()+this.d_()));this.pc++;break;case 140:this.adc_a(this.ixH);break;case 141:this.adc_a(this.ixL);break;case 142:this.adc_a(this.readMem(this.getIXHIXL()+this.d_()));this.pc++;
break;case 148:this.sub_a(this.ixH);break;case 149:this.sub_a(this.ixL);break;case 150:this.sub_a(this.readMem(this.getIXHIXL()+this.d_()));this.pc++;break;case 156:this.sbc_a(this.ixH);break;case 157:this.sbc_a(this.ixL);break;case 158:this.sbc_a(this.readMem(this.getIXHIXL()+this.d_()));this.pc++;break;case 164:this.f=this.SZP_TABLE[this.a&=this.ixH]|F_HALFCARRY;break;case 165:this.f=this.SZP_TABLE[this.a&=this.ixL]|F_HALFCARRY;break;case 166:this.f=this.SZP_TABLE[this.a&=this.readMem(this.getIXHIXL()+
this.d_())]|F_HALFCARRY;this.pc++;break;case 172:this.f=this.SZP_TABLE[this.a^=this.ixH];break;case 173:this.f=this.SZP_TABLE[this.a^=this.ixL];break;case 174:this.f=this.SZP_TABLE[this.a^=this.readMem(this.getIXHIXL()+this.d_())];this.pc++;break;case 180:this.f=this.SZP_TABLE[this.a|=this.ixH];break;case 181:this.f=this.SZP_TABLE[this.a|=this.ixL];break;case 182:this.f=this.SZP_TABLE[this.a|=this.readMem(this.getIXHIXL()+this.d_())];this.pc++;break;case 188:this.cp_a(this.ixH);break;case 189:this.cp_a(this.ixL);
break;case 190:this.cp_a(this.readMem(this.getIXHIXL()+this.d_()));this.pc++;break;case 203:this.doIndexCB(this.getIXHIXL());break;case 225:this.setIXHIXL(this.readMemWord(this.sp));this.sp+=2;break;case 227:b=this.getIXHIXL();this.setIXHIXL(this.readMemWord(this.sp));this.writeMemWord(this.sp,b);break;case 229:this.push(this.getIXHIXL());break;case 233:this.pc=this.getIXHIXL();break;case 249:this.sp=this.getIXHIXL();break;default:JSSMS.Utils.console.log("Unimplemented DD/FD Opcode: "+JSSMS.Utils.toHex(a)),
this.pc--}},doIndexOpIY:function(a){this.tstates-=OP_DD_STATES[a];REFRESH_EMULATION&&this.incR();switch(a){case 9:this.setIYHIYL(this.add16(this.getIYHIYL(),this.getBC()));break;case 25:this.setIYHIYL(this.add16(this.getIYHIYL(),this.getDE()));break;case 33:this.setIYHIYL(this.readMemWord(this.pc++));this.pc++;break;case 34:this.writeMemWord(this.readMemWord(this.pc++),this.getIYHIYL());this.pc++;break;case 35:this.incIYHIYL();break;case 36:this.iyH=this.inc8(this.iyH);break;case 37:this.iyH=this.dec8(this.iyH);
break;case 38:this.iyH=this.readMem(this.pc++);break;case 41:this.setIYHIYL(this.add16(this.getIYHIYL(),this.getIYHIYL()));break;case 42:this.setIYHIYL(this.readMemWord(this.readMemWord(this.pc++)));this.pc++;break;case 43:this.decIYHIYL();break;case 44:this.iyL=this.inc8(this.iyL);break;case 45:this.iyL=this.dec8(this.iyL);break;case 46:this.iyL=this.readMem(this.pc++);break;case 52:this.incMem(this.getIYHIYL()+this.d_());this.pc++;break;case 53:this.decMem(this.getIYHIYL()+this.d_());this.pc++;
break;case 54:this.writeMem(this.getIYHIYL()+this.d_(),this.readMem(++this.pc));this.pc++;break;case 57:this.setIYHIYL(this.add16(this.getIYHIYL(),this.sp));break;case 68:this.b=this.iyH;break;case 69:this.b=this.iyL;break;case 70:this.b=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 76:this.c=this.iyH;break;case 77:this.c=this.iyL;break;case 78:this.c=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 84:this.d=this.iyH;break;case 85:this.d=this.iyL;break;case 86:this.d=
this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 92:this.e=this.iyH;break;case 93:this.e=this.iyL;break;case 94:this.e=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 96:this.iyH=this.b;break;case 97:this.iyH=this.c;break;case 98:this.iyH=this.d;break;case 99:this.iyH=this.e;break;case 100:break;case 101:this.iyH=this.iyL;break;case 102:this.h=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 103:this.iyH=this.a;break;case 104:this.iyL=this.b;break;case 105:this.iyL=
this.c;break;case 106:this.iyL=this.d;break;case 107:this.iyL=this.e;break;case 108:this.iyL=this.iyH;break;case 109:break;case 110:this.l=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 111:this.iyL=this.a;break;case 112:this.writeMem(this.getIYHIYL()+this.d_(),this.b);this.pc++;break;case 113:this.writeMem(this.getIYHIYL()+this.d_(),this.c);this.pc++;break;case 114:this.writeMem(this.getIYHIYL()+this.d_(),this.d);this.pc++;break;case 115:this.writeMem(this.getIYHIYL()+this.d_(),this.e);
this.pc++;break;case 116:this.writeMem(this.getIYHIYL()+this.d_(),this.h);this.pc++;break;case 117:this.writeMem(this.getIYHIYL()+this.d_(),this.l);this.pc++;break;case 119:this.writeMem(this.getIYHIYL()+this.d_(),this.a);this.pc++;break;case 124:this.a=this.iyH;break;case 125:this.a=this.iyL;break;case 126:this.a=this.readMem(this.getIYHIYL()+this.d_());this.pc++;break;case 132:this.add_a(this.iyH);break;case 133:this.add_a(this.iyL);break;case 134:this.add_a(this.readMem(this.getIYHIYL()+this.d_()));
this.pc++;break;case 140:this.adc_a(this.iyH);break;case 141:this.adc_a(this.iyL);break;case 142:this.adc_a(this.readMem(this.getIYHIYL()+this.d_()));this.pc++;break;case 148:this.sub_a(this.iyH);break;case 149:this.sub_a(this.iyL);break;case 150:this.sub_a(this.readMem(this.getIYHIYL()+this.d_()));this.pc++;break;case 156:this.sbc_a(this.iyH);break;case 157:this.sbc_a(this.iyL);break;case 158:this.sbc_a(this.readMem(this.getIYHIYL()+this.d_()));this.pc++;break;case 164:this.f=this.SZP_TABLE[this.a&=
this.iyH]|F_HALFCARRY;break;case 165:this.f=this.SZP_TABLE[this.a&=this.iyL]|F_HALFCARRY;break;case 166:this.f=this.SZP_TABLE[this.a&=this.readMem(this.getIYHIYL()+this.d_())]|F_HALFCARRY;this.pc++;break;case 172:this.f=this.SZP_TABLE[this.a^=this.iyH];break;case 173:this.f=this.SZP_TABLE[this.a^=this.iyL];break;case 174:this.f=this.SZP_TABLE[this.a^=this.readMem(this.getIYHIYL()+this.d_())];this.pc++;break;case 180:this.f=this.SZP_TABLE[this.a|=this.iyH];break;case 181:this.f=this.SZP_TABLE[this.a|=
this.iyL];break;case 182:this.f=this.SZP_TABLE[this.a|=this.readMem(this.getIYHIYL()+this.d_())];this.pc++;break;case 188:this.cp_a(this.iyH);break;case 189:this.cp_a(this.iyL);break;case 190:this.cp_a(this.readMem(this.getIYHIYL()+this.d_()));this.pc++;break;case 203:this.doIndexCB(this.getIYHIYL());break;case 225:this.setIYHIYL(this.readMemWord(this.sp));this.sp+=2;break;case 227:a=this.getIYHIYL();this.setIYHIYL(this.readMemWord(this.sp));this.writeMemWord(this.sp,a);break;case 229:this.push(this.getIYHIYL());
break;case 233:this.pc=this.getIYHIYL();break;case 249:this.sp=this.getIYHIYL();break;default:JSSMS.Utils.console.log("Unimplemented DD/FD Opcode: "+JSSMS.Utils.toHex(a)),this.pc--}},doIndexCB:function(a){a=a+this.readMem(this.pc)&65535;var b=this.readMem(++this.pc);this.tstates-=OP_INDEX_CB_STATES[b];switch(b){case 0:this.b=this.rlc(this.readMem(a));this.writeMem(a,this.b);break;case 1:this.c=this.rlc(this.readMem(a));this.writeMem(a,this.c);break;case 2:this.d=this.rlc(this.readMem(a));this.writeMem(a,
this.d);break;case 3:this.e=this.rlc(this.readMem(a));this.writeMem(a,this.e);break;case 4:this.h=this.rlc(this.readMem(a));this.writeMem(a,this.h);break;case 5:this.l=this.rlc(this.readMem(a));this.writeMem(a,this.l);break;case 6:this.writeMem(a,this.rlc(this.readMem(a)));break;case 7:this.a=this.rlc(this.readMem(a));this.writeMem(a,this.a);break;case 8:this.b=this.rrc(this.readMem(a));this.writeMem(a,this.b);break;case 9:this.c=this.rrc(this.readMem(a));this.writeMem(a,this.c);break;case 10:this.d=
this.rrc(this.readMem(a));this.writeMem(a,this.d);break;case 11:this.e=this.rrc(this.readMem(a));this.writeMem(a,this.e);break;case 12:this.h=this.rrc(this.readMem(a));this.writeMem(a,this.h);break;case 13:this.l=this.rrc(this.readMem(a));this.writeMem(a,this.l);break;case 14:this.writeMem(a,this.rrc(this.readMem(a)));break;case 15:this.a=this.rrc(this.readMem(a));this.writeMem(a,this.a);break;case 16:this.b=this.rl(this.readMem(a));this.writeMem(a,this.b);break;case 17:this.c=this.rl(this.readMem(a));
this.writeMem(a,this.c);break;case 18:this.d=this.rl(this.readMem(a));this.writeMem(a,this.d);break;case 19:this.e=this.rl(this.readMem(a));this.writeMem(a,this.e);break;case 20:this.h=this.rl(this.readMem(a));this.writeMem(a,this.h);break;case 21:this.l=this.rl(this.readMem(a));this.writeMem(a,this.l);break;case 22:this.writeMem(a,this.rl(this.readMem(a)));break;case 23:this.a=this.rl(this.readMem(a));this.writeMem(a,this.a);break;case 24:this.b=this.rr(this.readMem(a));this.writeMem(a,this.b);break;
case 25:this.c=this.rr(this.readMem(a));this.writeMem(a,this.c);break;case 26:this.d=this.rr(this.readMem(a));this.writeMem(a,this.d);break;case 27:this.e=this.rr(this.readMem(a));this.writeMem(a,this.e);break;case 28:this.h=this.rr(this.readMem(a));this.writeMem(a,this.h);break;case 29:this.l=this.rr(this.readMem(a));this.writeMem(a,this.l);break;case 30:this.writeMem(a,this.rr(this.readMem(a)));break;case 31:this.a=this.rr(this.readMem(a));this.writeMem(a,this.a);break;case 32:this.b=this.sla(this.readMem(a));
this.writeMem(a,this.b);break;case 33:this.c=this.sla(this.readMem(a));this.writeMem(a,this.c);break;case 34:this.d=this.sla(this.readMem(a));this.writeMem(a,this.d);break;case 35:this.e=this.sla(this.readMem(a));this.writeMem(a,this.e);break;case 36:this.h=this.sla(this.readMem(a));this.writeMem(a,this.h);break;case 37:this.l=this.sla(this.readMem(a));this.writeMem(a,this.l);break;case 38:this.writeMem(a,this.sla(this.readMem(a)));break;case 39:this.a=this.sla(this.readMem(a));this.writeMem(a,this.a);
break;case 40:this.b=this.sra(this.readMem(a));this.writeMem(a,this.b);break;case 41:this.c=this.sra(this.readMem(a));this.writeMem(a,this.c);break;case 42:this.d=this.sra(this.readMem(a));this.writeMem(a,this.d);break;case 43:this.e=this.sra(this.readMem(a));this.writeMem(a,this.e);break;case 44:this.h=this.sra(this.readMem(a));this.writeMem(a,this.h);break;case 45:this.l=this.sra(this.readMem(a));this.writeMem(a,this.l);break;case 46:this.writeMem(a,this.sra(this.readMem(a)));break;case 47:this.a=
this.sra(this.readMem(a));this.writeMem(a,this.a);break;case 48:this.b=this.sll(this.readMem(a));this.writeMem(a,this.b);break;case 49:this.c=this.sll(this.readMem(a));this.writeMem(a,this.c);break;case 50:this.d=this.sll(this.readMem(a));this.writeMem(a,this.d);break;case 51:this.e=this.sll(this.readMem(a));this.writeMem(a,this.e);break;case 52:this.h=this.sll(this.readMem(a));this.writeMem(a,this.h);break;case 53:this.l=this.sll(this.readMem(a));this.writeMem(a,this.l);break;case 54:this.writeMem(a,
this.sll(this.readMem(a)));break;case 55:this.a=this.sll(this.readMem(a));this.writeMem(a,this.a);break;case 56:this.b=this.srl(this.readMem(a));this.writeMem(a,this.b);break;case 57:this.c=this.srl(this.readMem(a));this.writeMem(a,this.c);break;case 58:this.d=this.srl(this.readMem(a));this.writeMem(a,this.d);break;case 59:this.e=this.srl(this.readMem(a));this.writeMem(a,this.e);break;case 60:this.h=this.srl(this.readMem(a));this.writeMem(a,this.h);break;case 61:this.l=this.srl(this.readMem(a));this.writeMem(a,
this.l);break;case 62:this.writeMem(a,this.srl(this.readMem(a)));break;case 63:this.a=this.srl(this.readMem(a));this.writeMem(a,this.a);break;case 64:case 65:case 66:case 67:case 68:case 69:case 70:case 71:this.bit(this.readMem(a)&BIT_0);break;case 72:case 73:case 74:case 75:case 76:case 77:case 78:case 79:this.bit(this.readMem(a)&BIT_1);break;case 80:case 81:case 82:case 83:case 84:case 85:case 86:case 87:this.bit(this.readMem(a)&BIT_2);break;case 88:case 89:case 90:case 91:case 92:case 93:case 94:case 95:this.bit(this.readMem(a)&
BIT_3);break;case 96:case 97:case 98:case 99:case 100:case 101:case 102:case 103:this.bit(this.readMem(a)&BIT_4);break;case 104:case 105:case 106:case 107:case 108:case 109:case 110:case 111:this.bit(this.readMem(a)&BIT_5);break;case 112:case 113:case 114:case 115:case 116:case 117:case 118:case 119:this.bit(this.readMem(a)&BIT_6);break;case 120:case 121:case 122:case 123:case 124:case 125:case 126:case 127:this.bit(this.readMem(a)&BIT_7);break;case 128:case 129:case 130:case 131:case 132:case 133:case 134:case 135:this.writeMem(a,
this.readMem(a)&~BIT_0);break;case 136:case 137:case 138:case 139:case 140:case 141:case 142:case 143:this.writeMem(a,this.readMem(a)&~BIT_1);break;case 144:case 145:case 146:case 147:case 148:case 149:case 150:case 151:this.writeMem(a,this.readMem(a)&~BIT_2);break;case 152:case 153:case 154:case 155:case 156:case 157:case 158:case 159:this.writeMem(a,this.readMem(a)&~BIT_3);break;case 160:case 161:case 162:case 163:case 164:case 165:case 166:case 167:this.writeMem(a,this.readMem(a)&~BIT_4);break;
case 168:case 169:case 170:case 171:case 172:case 173:case 174:case 175:this.writeMem(a,this.readMem(a)&~BIT_5);break;case 176:case 177:case 178:case 179:case 180:case 181:case 182:case 183:this.writeMem(a,this.readMem(a)&~BIT_6);break;case 184:case 185:case 186:case 187:case 188:case 189:case 190:case 191:this.writeMem(a,this.readMem(a)&~BIT_7);break;case 192:case 193:case 194:case 195:case 196:case 197:case 198:case 199:this.writeMem(a,this.readMem(a)|BIT_0);break;case 200:case 201:case 202:case 203:case 204:case 205:case 206:case 207:this.writeMem(a,
this.readMem(a)|BIT_1);break;case 208:case 209:case 210:case 211:case 212:case 213:case 214:case 215:this.writeMem(a,this.readMem(a)|BIT_2);break;case 216:case 217:case 218:case 219:case 220:case 221:case 222:case 223:this.writeMem(a,this.readMem(a)|BIT_3);break;case 224:case 225:case 226:case 227:case 228:case 229:case 230:case 231:this.writeMem(a,this.readMem(a)|BIT_4);break;case 232:case 233:case 234:case 235:case 236:case 237:case 238:case 239:this.writeMem(a,this.readMem(a)|BIT_5);break;case 240:case 241:case 242:case 243:case 244:case 245:case 246:case 247:this.writeMem(a,
this.readMem(a)|BIT_6);break;case 248:case 249:case 250:case 251:case 252:case 253:case 254:case 255:this.writeMem(a,this.readMem(a)|BIT_7);break;default:JSSMS.Utils.console.log("Unimplemented DDCB/FDCB Opcode: "+JSSMS.Utils.toHex(b))}this.pc++},doED:function(a){var b=0,c=0;this.tstates-=OP_ED_STATES[a];REFRESH_EMULATION&&this.incR();switch(a){case 64:this.b=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.b];this.pc++;break;case 65:this.port.out(this.c,this.b);this.pc++;break;case 66:this.sbc16(this.getBC());
this.pc++;break;case 67:this.writeMemWord(this.readMemWord(++this.pc),this.getBC());this.pc+=2;break;case 68:case 76:case 84:case 92:case 100:case 108:case 116:case 124:b=this.a;this.a=0;this.sub_a(b);this.pc++;break;case 69:case 77:case 85:case 93:case 101:case 109:case 117:case 125:this.pc=this.readMemWord(this.sp);this.sp+=2;this.iff1=this.iff2;break;case 70:case 78:case 102:case 110:this.im=0;this.pc++;break;case 71:this.i=this.a;this.pc++;break;case 72:this.c=this.port.in_(this.c);this.f=this.f&
F_CARRY|this.SZP_TABLE[this.c];this.pc++;break;case 73:this.port.out(this.c,this.c);this.pc++;break;case 74:this.adc16(this.getBC());this.pc++;break;case 75:this.setBC(this.readMemWord(this.readMemWord(++this.pc)));this.pc+=2;break;case 79:this.r=this.a;this.pc++;break;case 80:this.d=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.d];this.pc++;break;case 81:this.port.out(this.c,this.d);this.pc++;break;case 82:this.sbc16(this.getDE());this.pc++;break;case 83:this.writeMemWord(this.readMemWord(++this.pc),
this.getDE());this.pc+=2;break;case 86:case 118:this.im=1;this.pc++;break;case 87:this.a=this.i;this.f=this.f&F_CARRY|this.SZ_TABLE[this.a]|(this.iff2?F_PARITY:0);this.pc++;break;case 88:this.e=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.e];this.pc++;break;case 89:this.port.out(this.c,this.e);this.pc++;break;case 90:this.adc16(this.getDE());this.pc++;break;case 91:this.setDE(this.readMemWord(this.readMemWord(++this.pc)));this.pc+=2;break;case 95:this.a=REFRESH_EMULATION?this.r:
JSSMS.Utils.rndInt(255);this.f=this.f&F_CARRY|this.SZ_TABLE[this.a]|(this.iff2?F_PARITY:0);this.pc++;break;case 96:this.h=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.h];this.pc++;break;case 97:this.port.out(this.c,this.h);this.pc++;break;case 98:this.sbc16(this.getHL());this.pc++;break;case 99:this.writeMemWord(this.readMemWord(++this.pc),this.getHL());this.pc+=2;break;case 103:c=this.getHL();b=this.readMem(c);this.writeMem(c,b>>4|(this.a&15)<<4);this.a=this.a&240|b&15;this.f=
this.f&F_CARRY|this.SZP_TABLE[this.a];this.pc++;break;case 104:this.l=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.l];this.pc++;break;case 105:this.port.out(this.c,this.l);this.pc++;break;case 106:this.adc16(this.getHL());this.pc++;break;case 107:this.setHL(this.readMemWord(this.readMemWord(++this.pc)));this.pc+=2;break;case 111:c=this.getHL();b=this.readMem(c);this.writeMem(c,(b&15)<<4|this.a&15);this.a=this.a&240|b>>4;this.f=this.f&F_CARRY|this.SZP_TABLE[this.a];this.pc++;break;
case 113:this.port.out(this.c,0);this.pc++;break;case 114:this.sbc16(this.sp);this.pc++;break;case 115:this.writeMemWord(this.readMemWord(++this.pc),this.sp);this.pc+=2;break;case 120:this.a=this.port.in_(this.c);this.f=this.f&F_CARRY|this.SZP_TABLE[this.a];this.pc++;break;case 121:this.port.out(this.c,this.a);this.pc++;break;case 122:this.adc16(this.sp);this.pc++;break;case 123:this.sp=this.readMemWord(this.readMemWord(++this.pc));this.pc+=2;break;case 160:b=this.readMem(this.getHL());this.writeMem(this.getDE(),
b);this.decBC();this.incDE();this.incHL();b=b+this.a&255;this.f=this.f&193|(this.getBC()?F_PARITY:0)|b&8|(b&2?32:0);this.pc++;break;case 161:b=this.f&F_CARRY|F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.decBC();this.incHL();b|=0===this.getBC()?0:F_PARITY;this.f=this.f&248|b;this.pc++;break;case 162:b=this.port.in_(this.c);this.writeMem(this.getHL(),b);this.b=this.dec8(this.b);this.incHL();this.f=128===(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;this.pc++;break;case 163:b=this.readMem(this.getHL());
this.port.out(this.c,b);this.b=this.dec8(this.b);this.incHL();255<this.l+b?(this.f|=F_CARRY,this.f|=F_HALFCARRY):(this.f&=~F_CARRY,this.f&=~F_HALFCARRY);this.f=128===(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;this.pc++;break;case 168:b=this.readMem(this.getHL());this.writeMem(this.getDE(),b);this.decBC();this.decDE();this.decHL();b=b+this.a&255;this.f=this.f&193|(this.getBC()?F_PARITY:0)|b&F_BIT3|(b&F_NEGATIVE?32:0);this.pc++;break;case 169:b=this.f&F_CARRY|F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));
this.decBC();this.decHL();b|=0===this.getBC()?0:F_PARITY;this.f=this.f&248|b;this.pc++;break;case 170:b=this.port.in_(this.c);this.writeMem(this.getHL(),b);this.b=this.dec8(this.b);this.decHL();this.f=0!==(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;this.pc++;break;case 171:b=this.readMem(this.getHL());this.port.out(this.c,b);this.b=this.dec8(this.b);this.decHL();255<this.l+b?(this.f|=F_CARRY,this.f|=F_HALFCARRY):(this.f&=~F_CARRY,this.f&=~F_HALFCARRY);this.f=128===(b&128)?this.f|F_NEGATIVE:this.f&
~F_NEGATIVE;this.pc++;break;case 176:b=this.readMem(this.getHL());this.writeMem(this.getDE(),b);this.decBC();this.incDE();this.incHL();b=b+this.a&255;this.f=this.f&193|(this.getBC()?F_PARITY:0)|b&8|(b&2?32:0);0!==this.getBC()?(this.tstates-=5,this.pc--):this.pc++;break;case 177:b=this.f&F_CARRY|F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.decBC();this.incHL();b|=0===this.getBC()?0:F_PARITY;0!==(b&F_PARITY)&&0===(this.f&F_ZERO)?(this.tstates-=5,this.pc--):this.pc++;this.f=this.f&248|b;break;
case 178:b=this.port.in_(this.c);this.writeMem(this.getHL(),b);this.b=this.dec8(this.b);this.incHL();0!==this.b?(this.tstates-=5,this.pc--):this.pc++;this.f=128===(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;break;case 179:b=this.readMem(this.getHL());this.port.out(this.c,b);this.b=this.dec8(this.b);this.incHL();0!==this.b?(this.tstates-=5,this.pc--):this.pc++;255<this.l+b?(this.f|=F_CARRY,this.f|=F_HALFCARRY):(this.f&=~F_CARRY,this.f&=~F_HALFCARRY);this.f=0!==(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;
break;case 184:b=this.readMem(this.getHL());this.writeMem(this.getDE(),b);this.decBC();this.decDE();this.decHL();b=b+this.a&255;this.f=this.f&193|(this.getBC()?F_PARITY:0)|b&F_BIT3|(b&F_NEGATIVE?32:0);0!==this.getBC()?(this.tstates-=5,this.pc--):this.pc++;break;case 185:b=this.f&F_CARRY|F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.decBC();this.decHL();b|=0===this.getBC()?0:F_PARITY;0!==(b&F_PARITY)&&0===(this.f&F_ZERO)?(this.tstates-=5,this.pc--):this.pc++;this.f=this.f&248|b;break;case 186:b=
this.port.in_(this.c);this.writeMem(this.getHL(),b);this.b=this.dec8(this.b);this.decHL();0!==this.b?(this.tstates-=5,this.pc--):this.pc++;this.f=0!==(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;break;case 187:b=this.readMem(this.getHL());this.port.out(this.c,b);this.b=this.dec8(this.b);this.decHL();0!==this.b?(this.tstates-=5,this.pc--):this.pc++;255<this.l+b?(this.f|=F_CARRY,this.f|=F_HALFCARRY):(this.f&=~F_CARRY,this.f&=~F_HALFCARRY);this.f=0!==(b&128)?this.f|F_NEGATIVE:this.f&~F_NEGATIVE;break;
default:JSSMS.Utils.console.log("Unimplemented ED Opcode: "+JSSMS.Utils.toHex(a)),this.pc++}},generateDAATable:function(){var a,b,c,e;for(a=256;a--;)for(b=0;1>=b;b++)for(c=0;1>=c;c++)for(e=0;1>=e;e++)this.DAA_TABLE[b<<8|e<<9|c<<10|a]=this.getDAAResult(a,b|e<<1|c<<4);this.a=this.f=0},getDAAResult:function(a,b){this.a=a;this.f=b;var c=this.a,e=0,d=b&F_CARRY,g=d;if(0!==(b&F_HALFCARRY)||9<(c&15))e|=6;if(1==d||159<c||143<c&&9<(c&15))e|=96,g=1;153<c&&(g=1);0!==(b&F_NEGATIVE)?this.sub_a(e):this.add_a(e);
b=this.f&254|g;b=this.getParity(this.a)?b&251|F_PARITY:b&251;return this.a|b<<8},add_a:function(a){a=this.a+a&255;this.f=this.SZHVC_ADD_TABLE[this.a<<8|a];this.a=a},adc_a:function(a){var b=this.f&F_CARRY;a=this.a+a+b&255;this.f=this.SZHVC_ADD_TABLE[b<<16|this.a<<8|a];this.a=a},sub_a:function(a){a=this.a-a&255;this.f=this.SZHVC_SUB_TABLE[this.a<<8|a];this.a=a},sbc_a:function(a){var b=this.f&F_CARRY;a=this.a-a-b&255;this.f=this.SZHVC_SUB_TABLE[b<<16|this.a<<8|a];this.a=a},cp_a:function(a){this.f=this.SZHVC_SUB_TABLE[this.a<<
8|this.a-a&255]},cpl_a:function(){this.a^=255;this.f=this.f|F_NEGATIVE|F_HALFCARRY},rra_a:function(){var a=this.a&1;this.a=(this.a>>1|(this.f&F_CARRY)<<7)&255;this.f=this.f&236|a},rla_a:function(){var a=this.a>>7;this.a=(this.a<<1|this.f&F_CARRY)&255;this.f=this.f&236|a},rlca_a:function(){var a=this.a>>7;this.a=this.a<<1&255|a;this.f=this.f&236|a},rrca_a:function(){var a=this.a&1;this.a=this.a>>1|a<<7;this.f=this.f&236|a},getBC:function(){return this.b<<8|this.c},getDE:function(){return this.d<<8|
this.e},getHL:function(){return this.h<<8|this.l},getAF:function(){return this.a<<8|this.f},getIXHIXL:function(){return this.ixH<<8|this.ixL},getIYHIYL:function(){return this.iyH<<8|this.iyL},setBC:function(a){this.b=a>>8;this.c=a&255},setDE:function(a){this.d=a>>8;this.e=a&255},setHL:function(a){this.h=a>>8;this.l=a&255},setAF:function(a){this.a=a>>8;this.f=a&255},setIXHIXL:function(a){this.ixH=a>>8;this.ixL=a&255},setIYHIYL:function(a){this.iyH=a>>8;this.iyL=a&255},incBC:function(){this.c=this.c+
1&255;0===this.c&&(this.b=this.b+1&255)},incDE:function(){this.e=this.e+1&255;0===this.e&&(this.d=this.d+1&255)},incHL:function(){this.l=this.l+1&255;0===this.l&&(this.h=this.h+1&255)},incIXHIXL:function(){this.ixL=this.ixL+1&255;0===this.ixL&&(this.ixH=this.ixH+1&255)},incIYHIYL:function(){this.iyL=this.iyL+1&255;0===this.iyL&&(this.iyH=this.iyH+1&255)},decBC:function(){this.c=this.c-1&255;255==this.c&&(this.b=this.b-1&255)},decDE:function(){this.e=this.e-1&255;255==this.e&&(this.d=this.d-1&255)},
decHL:function(){this.l=this.l-1&255;255==this.l&&(this.h=this.h-1&255)},decIXHIXL:function(){this.ixL=this.ixL-1&255;255==this.ixL&&(this.ixH=this.ixH-1&255)},decIYHIYL:function(){this.iyL=this.iyL-1&255;255==this.iyL&&(this.iyH=this.iyH-1&255)},inc8:function(a){a=a+1&255;this.f=this.f&F_CARRY|this.SZHV_INC_TABLE[a];return a},dec8:function(a){a=a-1&255;this.f=this.f&F_CARRY|this.SZHV_DEC_TABLE[a];return a},exAF:function(){var a=this.a;this.a=this.a2;this.a2=a;a=this.f;this.f=this.f2;this.f2=a},exBC:function(){var a=
this.b;this.b=this.b2;this.b2=a;a=this.c;this.c=this.c2;this.c2=a},exDE:function(){var a=this.d;this.d=this.d2;this.d2=a;a=this.e;this.e=this.e2;this.e2=a},exHL:function(){var a=this.h;this.h=this.h2;this.h2=a;a=this.l;this.l=this.l2;this.l2=a},add16:function(a,b){var c=a+b;this.f=this.f&196|(a^c^b)>>8&16|c>>16&1;return c&65535},adc16:function(a){var b=this.getHL(),c=b+a+(this.f&F_CARRY);this.f=(b^c^a)>>8&16|c>>16&1|c>>8&128|(0!==(c&65535)?0:64)|((a^b^32768)&(a^c)&32768)>>13;this.h=c>>8&255;this.l=
c&255},sbc16:function(a){var b=this.getHL(),c=b-a-(this.f&F_CARRY);this.f=(b^c^a)>>8&16|2|c>>16&1|c>>8&128|(0!==(c&65535)?0:64)|((a^b)&(b^c)&32768)>>13;this.h=c>>8&255;this.l=c&255},incR:function(){this.r=this.r&128|this.r+1&127},generateFlagTables:function(){var a,b,c,e,d,g,h;for(a=0;256>a;a++)b=0!==(a&128)?F_SIGN:0,c=0===a?F_ZERO:0,e=a&32,d=a&8,g=this.getParity(a)?F_PARITY:0,this.SZ_TABLE[a]=b|c|e|d,this.SZP_TABLE[a]=b|c|e|d|g,this.SZHV_INC_TABLE[a]=b|c|e|d,this.SZHV_INC_TABLE[a]|=128===a?F_OVERFLOW:
0,this.SZHV_INC_TABLE[a]|=0===(a&15)?F_HALFCARRY:0,this.SZHV_DEC_TABLE[a]=b|c|e|d|F_NEGATIVE,this.SZHV_DEC_TABLE[a]|=127===a?F_OVERFLOW:0,this.SZHV_DEC_TABLE[a]|=15===(a&15)?F_HALFCARRY:0,this.SZ_BIT_TABLE[a]=0!==a?a&128:F_ZERO|F_PARITY,this.SZ_BIT_TABLE[a]=this.SZ_BIT_TABLE[a]|e|d|F_HALFCARRY;a=0;b=65536;c=0;e=65536;for(g=0;256>g;g++)for(h=0;256>h;h++)d=h-g,this.SZHVC_ADD_TABLE[a]=0!==h?0!==(h&128)?F_SIGN:0:F_ZERO,this.SZHVC_ADD_TABLE[a]|=h&(F_BIT5|F_BIT3),(h&15)<(g&15)&&(this.SZHVC_ADD_TABLE[a]|=
F_HALFCARRY),h<g&&(this.SZHVC_ADD_TABLE[a]|=F_CARRY),0!==((d^g^128)&(d^h)&128)&&(this.SZHVC_ADD_TABLE[a]|=F_OVERFLOW),a++,d=h-g-1,this.SZHVC_ADD_TABLE[b]=0!==h?0!==(h&128)?F_SIGN:0:F_ZERO,this.SZHVC_ADD_TABLE[b]|=h&(F_BIT5|F_BIT3),(h&15)<=(g&15)&&(this.SZHVC_ADD_TABLE[b]|=F_HALFCARRY),h<=g&&(this.SZHVC_ADD_TABLE[b]|=F_CARRY),0!==((d^g^128)&(d^h)&128)&&(this.SZHVC_ADD_TABLE[b]|=F_OVERFLOW),b++,d=g-h,this.SZHVC_SUB_TABLE[c]=0!==h?0!==(h&128)?F_NEGATIVE|F_SIGN:F_NEGATIVE:F_NEGATIVE|F_ZERO,this.SZHVC_SUB_TABLE[c]|=
h&(F_BIT5|F_BIT3),(h&15)>(g&15)&&(this.SZHVC_SUB_TABLE[c]|=F_HALFCARRY),h>g&&(this.SZHVC_SUB_TABLE[c]|=F_CARRY),0!==((d^g)&(g^h)&128)&&(this.SZHVC_SUB_TABLE[c]|=F_OVERFLOW),c++,d=g-h-1,this.SZHVC_SUB_TABLE[e]=0!==h?0!==(h&128)?F_NEGATIVE|F_SIGN:F_NEGATIVE:F_NEGATIVE|F_ZERO,this.SZHVC_SUB_TABLE[e]|=h&(F_BIT5|F_BIT3),(h&15)>=(g&15)&&(this.SZHVC_SUB_TABLE[e]|=F_HALFCARRY),h>=g&&(this.SZHVC_SUB_TABLE[e]|=F_CARRY),0!==((d^g)&(g^h)&128)&&(this.SZHVC_SUB_TABLE[e]|=F_OVERFLOW),e++},getParity:function(a){var b=
!0,c;for(c=0;8>c;c++)0!==(a&1<<c)&&(b=!b);return b},generateMemory:function(){if(SUPPORT_DATAVIEW)for(var a=0;8192>a;a++)this.memWriteMap.setUint8(a,0);else for(a=0;8192>a;a++)this.memWriteMap[a]=0;if(SUPPORT_DATAVIEW)for(a=0;32768>a;a++)this.sram.setUint8(a,0);else for(a=0;32768>a;a++)this.sram[a]=0;this.useSRAM=!1;this.number_of_pages=2;for(a=0;4>a;a++)this.frameReg[a]=a%3},resetMemory:function(a){var b=0;a&&(this.rom=a);if(this.rom.length){this.number_of_pages=this.rom.length;this.romPageMask=
this.number_of_pages-1;for(b=0;3>b;b++)this.frameReg[b]=b%this.number_of_pages;this.frameReg[3]=0;if(ENABLE_COMPILER){this.branches=Array(this.number_of_pages);for(b=0;b<this.number_of_pages;b++)this.branches[b]=Object.create(null);this.recompiler.setRom(this.rom)}}else this.romPageMask=this.number_of_pages=0},d_:function(){return this.readMem(this.pc)},writeMem:function(){return SUPPORT_DATAVIEW?function(a,b){65535>=a?(this.memWriteMap.setUint8(a&8191,b),65532===a?this.frameReg[3]=b:65533===a?this.frameReg[0]=
b&this.romPageMask:65534===a?this.frameReg[1]=b&this.romPageMask:65535===a&&(this.frameReg[2]=b&this.romPageMask)):JSSMS.Utils.console.error(JSSMS.Utils.toHex(a))}:function(a,b){65535>=a?(this.memWriteMap[a&8191]=b,65532===a?this.frameReg[3]=b:65533===a?this.frameReg[0]=b&this.romPageMask:65534===a?this.frameReg[1]=b&this.romPageMask:65535===a&&(this.frameReg[2]=b&this.romPageMask)):JSSMS.Utils.console.error(JSSMS.Utils.toHex(a))}}(),writeMemWord:function(){return SUPPORT_DATAVIEW?function(a,b){65532>
a?this.memWriteMap.setUint16(a&8191,b,LITTLE_ENDIAN):65532===a?(this.frameReg[3]=b&255,this.frameReg[0]=b>>8&this.romPageMask):65533===a?(this.frameReg[0]=b&255&this.romPageMask,this.frameReg[1]=b>>8&this.romPageMask):65534===a?(this.frameReg[1]=b&255&this.romPageMask,this.frameReg[2]=b>>8&this.romPageMask):JSSMS.Utils.console.error(JSSMS.Utils.toHex(a))}:function(a,b){65532>a?(a&=8191,this.memWriteMap[a++]=b&255,this.memWriteMap[a]=b>>8):65532===a?(this.frameReg[3]=b&255,this.frameReg[0]=b>>8&this.romPageMask):
65533===a?(this.frameReg[0]=b&255&this.romPageMask,this.frameReg[1]=b>>8&this.romPageMask):65534===a?(this.frameReg[1]=b&255&this.romPageMask,this.frameReg[2]=b>>8&this.romPageMask):JSSMS.Utils.console.error(JSSMS.Utils.toHex(a))}}(),readMem:function(){return SUPPORT_DATAVIEW?function(a){if(1024>a)return this.rom[0].getUint8(a);if(16384>a)return this.rom[this.frameReg[0]].getUint8(a);if(32768>a)return this.rom[this.frameReg[1]].getUint8(a-16384);if(49152>a)return 8==(this.frameReg[3]&12)?(this.useSRAM=
!0,this.sram.getUint8(a-32768)):12==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram.getUint8(a-16384)):this.rom[this.frameReg[2]].getUint8(a-32768);if(57344>a)return this.memWriteMap.getUint8(a-49152);if(65532>a)return this.memWriteMap.getUint8(a-57344);if(65532===a)return this.frameReg[3];if(65533===a)return this.frameReg[0];if(65534===a)return this.frameReg[1];if(65535===a)return this.frameReg[2];JSSMS.Utils.console.error(JSSMS.Utils.toHex(a));return 0}:function(a){if(1024>a)return this.rom[0][a];
if(16384>a)return this.rom[this.frameReg[0]][a];if(32768>a)return this.rom[this.frameReg[1]][a-16384];if(49152>a)return 8==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a-32768]):12==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a-16384]):this.rom[this.frameReg[2]][a-32768];if(57344>a)return this.memWriteMap[a-49152];if(65532>a)return this.memWriteMap[a-57344];if(65532===a)return this.frameReg[3];if(65533===a)return this.frameReg[0];if(65534===a)return this.frameReg[1];if(65535===a)return this.frameReg[2];
JSSMS.Utils.console.error(JSSMS.Utils.toHex(a));return 0}}(),readMemWord:function(){return SUPPORT_DATAVIEW?function(a){if(1024>a)return this.rom[0].getUint16(a,LITTLE_ENDIAN);if(16384>a)return this.rom[this.frameReg[0]].getUint16(a,LITTLE_ENDIAN);if(32768>a)return this.rom[this.frameReg[1]].getUint16(a-16384,LITTLE_ENDIAN);if(49152>a)return 8==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a-32768]):12==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a-16384]):this.rom[this.frameReg[2]].getUint16(a-
32768,LITTLE_ENDIAN);if(57344>a)return this.memWriteMap.getUint16(a-49152,LITTLE_ENDIAN);if(65532>a)return this.memWriteMap.getUint16(a-57344,LITTLE_ENDIAN);if(65532===a)return this.frameReg[3];if(65533===a)return this.frameReg[0];if(65534===a)return this.frameReg[1];if(65535===a)return this.frameReg[2];JSSMS.Utils.console.error(JSSMS.Utils.toHex(a));return 0}:function(a){if(1024>a)return this.rom[0][a++]|this.rom[0][a]<<8;if(16384>a)return this.rom[this.frameReg[0]][a++]|this.rom[this.frameReg[0]][a]<<
8;if(32768>a)return this.rom[this.frameReg[1]][a++-16384]|this.rom[this.frameReg[1]][a-16384]<<8;if(49152>a)return 8==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a++-32768]|this.sram[a-32768]<<8):12==(this.frameReg[3]&12)?(this.useSRAM=!0,this.sram[a++-16384]|this.sram[a-16384]<<8):this.rom[this.frameReg[2]][a++-32768]|this.rom[this.frameReg[2]][a-32768]<<8;if(57344>a)return this.memWriteMap[a++-49152]|this.memWriteMap[a-49152]<<8;if(65532>a)return this.memWriteMap[a++-57344]|this.memWriteMap[a-
57344]<<8;if(65532===a)return this.frameReg[3];if(65533===a)return this.frameReg[0];if(65534===a)return this.frameReg[1];if(65535===a)return this.frameReg[2];JSSMS.Utils.console.error(JSSMS.Utils.toHex(a));return 0}}(),hasUsedSRAM:function(){return this.useSRAM},setSRAM:function(a){var b=a.length/PAGE_SIZE,c;for(c=0;c<b;c++)JSSMS.Utils.copyArrayElements(a,c*PAGE_SIZE,this.sram[c],0,PAGE_SIZE)},setStateMem:function(a){this.frameReg=a},getState:function(){var a=Array(8);a[0]=this.pc|this.sp<<16;a[1]=
(this.iff1?1:0)|(this.iff2?2:0)|(this.halt?4:0)|(this.EI_inst?8:0)|(this.interruptLine?16:0);a[2]=this.a|this.a2<<8|this.f<<16|this.f2<<24;a[3]=this.getBC()|this.getDE()<<16;a[4]=this.getHL()|this.r<<16|this.i<<24;a[5]=this.getIXHIXL()|this.getIYHIYL()<<16;this.exBC();this.exDE();this.exHL();a[6]=this.getBC()|this.getDE()<<16;a[7]=this.getHL()|this.im<<16|this.interruptVector<<24;this.exBC();this.exDE();this.exHL();return a},setState:function(a){var b=a[0];this.pc=b&65535;this.sp=b>>16&65535;b=a[1];
this.iff1=0!==(b&1);this.iff2=0!==(b&2);this.halt=0!==(b&4);this.EI_inst=0!==(b&8);this.interruptLine=0!==(b&16);b=a[2];this.a=b&255;this.a2=b>>8&255;this.f=b>>16&255;this.f2=b>>24&255;b=a[3];this.setBC(b&65535);this.setDE(b>>16&65535);b=a[4];this.setHL(b&65535);this.r=b>>16&255;this.i=b>>24&255;b=a[5];this.setIXHIXL(b&65535);this.setIYHIYL(b>>16&65535);this.exBC();this.exDE();this.exHL();b=a[6];this.setBC(b&65535);this.setDE(b>>16&65535);b=a[7];this.setHL(b&65535);this.im=b>>16&255;this.interruptVector=
b>>24&255;this.exBC();this.exDE();this.exHL()}};JSSMS.Debugger=function(){};
JSSMS.Debugger.prototype={instructions:[],resetDebug:function(){this.instructions=[];this.main.ui.updateStatus("Parsing instructions...");this.parseInstructions();this.main.ui.updateStatus("Instructions parsed")},parseInstructions:function(){JSSMS.Utils.console.time("Instructions parsing");var a=PAGE_SIZE*this.rom.length,b,c,e=0,d=[],g=[0,56,102];for(g.forEach(function(a){d.push(a)});d.length;)c=d.shift(),this.instructions[c]||(c>=a||65<=c>>10?JSSMS.Utils.console.log("Invalid address",JSSMS.Utils.toHex(c)):
(b=this.disassemble(c),this.instructions[c]=b,null!==b.nextAddress&&d.push(b.nextAddress),null!==b.target&&d.push(b.target)));for(g.forEach(function(a){this.instructions[a]&&(this.instructions[a].isJumpTarget=!0)},this);e<a;e++)this.instructions[e]&&(null!==this.instructions[e].nextAddress&&this.instructions[this.instructions[e].nextAddress]&&this.instructions[this.instructions[e].nextAddress].jumpTargetNb++,null!==this.instructions[e].target&&(this.instructions[this.instructions[e].target]?(this.instructions[this.instructions[e].target].isJumpTarget=
!0,this.instructions[this.instructions[e].target].jumpTargetNb++):JSSMS.Utils.console.log("Invalid target address",JSSMS.Utils.toHex(this.instructions[e].target))));JSSMS.Utils.console.timeEnd("Instructions parsing")},writeGraphViz:function(){JSSMS.Utils.console.time("DOT generation");for(var a=this.instructions,b=["digraph G {"],c=0,e=a.length;c<e;c++)a[c]&&(b.push(" "+c+' [label="'+a[c].label+'"];'),null!==a[c].target&&b.push(" "+c+" -> "+a[c].target+";"),null!==a[c].nextAddress&&b.push(" "+c+" -> "+
a[c].nextAddress+";"));b.push("}");b=b.join("\n");b=b.replace(/ 0 \[label="/,' 0 [style=filled,color="#CC0000",label="');JSSMS.Utils.console.timeEnd("DOT generation");return b},writeJavaScript:function(){function a(a){var b=0;switch(a[0]){case 203:b=OP_CB_STATES[a[1]];break;case 221:case 253:b=2==a.length?OP_DD_STATES[a[1]]:OP_INDEX_CB_STATES[a[2]];break;case 237:b=OP_ED_STATES[a[1]];break;default:b=OP_STATES[a[0]]}return b}function b(){d&&q.push("this.tstates -= "+e(d)+";");d=0}JSSMS.Utils.console.time("JavaScript generation");
for(var c=this.instructions,e=JSSMS.Utils.toHex,d=0,g=0,h=0,f=!1,k=1024,l=0,m=0,p=0,q=['"": {','"": function() {','throw "Bad address: " + JSSMS.Utils.toHex(this.pc);'],m=0,p=c.length;m<p;m++)if(c[m]){g<=k&&c[m].address>=k&&(q.push("this.pc = "+e(c[m].address)+";"),q.push("}"),q.push("},"),q.push(""+l+": {"),q.push('"": function() {'),q.push('throw "Bad address: " + JSSMS.Utils.toHex(this.pc);'),f=!0,l++,k=l*PAGE_SIZE);if(c[m].isJumpTarget||h!=c[m].address||f)b(),h&&!f&&q.push("this.pc = "+e(h)+";"),
q.push("},"),q.push(""+e(c[m].address)+": function(temp, location) {");q.push("// "+c[m].label);f="return;"==c[m].code.substr(-7);d+=a(c[m].opcodes);(/return;/.test(c[m].code)||/this\.tstates/.test(c[m].code))&&b();""!==c[m].code&&q.push(c[m].code);g=c[m].address;h=c[m].nextAddress}q.push("}");q.push("}");q=q.join("\n");JSSMS.Utils.console.timeEnd("JavaScript generation");return q},disassemble:function(a){var b=JSSMS.Utils.toHex,c=this.readRom8bit(a),e=[c],d="Unknown Opcode",g=a,h=null,f='throw "Unimplemented opcode '+
b(c)+'";',k="",l=0;a++;k={};switch(c){case 0:d="NOP";f="";break;case 1:k=b(this.readRom16bit(a));d="LD BC,"+k;f="this.setBC("+k+");";a+=2;break;case 2:d="LD (BC),A";f="this.writeMem(this.getBC(), this.a);";break;case 3:d="INC BC";f="this.incBC();";break;case 4:d="INC B";f="this.b = this.inc8(this.b);";break;case 5:d="DEC B";f="this.b = this.dec8(this.b);";break;case 6:k=b(this.readRom8bit(a));d="LD B,"+k;f="this.b = "+k+";";a++;break;case 7:d="RLCA";f="this.rlca_a();";break;case 8:d="EX AF AF'";f=
"this.exAF();";break;case 9:d="ADD HL,BC";f="this.setHL(this.add16(this.getHL(), this.getBC()));";break;case 10:d="LD A,(BC)";f="this.a = this.readMem(this.getBC());";break;case 11:d="DEC BC";f="this.decBC();";break;case 12:d="INC C";f="this.c = this.inc8(this.c);";break;case 13:d="DEC C";f="this.c = this.dec8(this.c);";break;case 14:k=b(this.readRom8bit(a));d="LD C,"+k;f="this.c = "+k+";";a++;break;case 15:d="RRCA";f="this.rrca_a();";break;case 16:h=a+this.signExtend(this.readRom8bit(a)+1);d="DJNZ ("+
b(h)+")";f="this.b = this.b - 0x01 & 0xFF;if (this.b != 0x00) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}";a++;break;case 17:k=b(this.readRom16bit(a));d="LD DE,"+k;f="this.setDE("+k+");";a+=2;break;case 18:d="LD (DE),A";f="this.writeMem(this.getDE(), this.a);";break;case 19:d="INC DE";f="this.incDE();";break;case 20:d="INC D";f="this.d = this.inc8(this.d);";break;case 21:d="DEC D";f="this.d = this.dec8(this.d);";break;case 22:k=b(this.readRom8bit(a));d="LD D,"+k;f="this.d = "+k+";";a++;break;
case 23:d="RLA";f="this.rla_a();";break;case 24:h=a+this.signExtend(this.readRom8bit(a)+1);d="JR ("+b(h)+")";f="this.pc = "+b(h)+"; return;";a=null;break;case 25:d="ADD HL,DE";f="this.setHL(this.add16(this.getHL(), this.getDE()));";break;case 26:d="LD A,(DE)";f="this.a = this.readMem(this.getDE());";break;case 27:d="DEC DE";f="this.decDE();";break;case 28:d="INC E";f="this.e = this.inc8(this.e);";break;case 29:d="DEC E";f="this.e = this.dec8(this.e);";break;case 30:k=b(this.readRom8bit(a));d="LD E,"+
k;f="this.e = "+k+";";a++;break;case 31:d="RRA";f="this.rra_a();";break;case 32:h=a+this.signExtend(this.readRom8bit(a)+1);d="JR NZ,("+b(h)+")";f="if (!((this.f & F_ZERO) != 0x00)) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}";a++;break;case 33:k=b(this.readRom16bit(a));d="LD HL,"+k;f="this.setHL("+k+");";a+=2;break;case 34:l=this.readRom16bit(a);k=b(l);d="LD ("+k+"),HL";f="this.writeMem("+k+", this.l);this.writeMem("+b(l+1)+", this.h);";a+=2;break;case 35:d="INC HL";f="this.incHL();";break;
case 36:d="INC H";f="this.h = this.inc8(this.h);";break;case 37:d="DEC H";f="this.h = this.dec8(this.h);";break;case 38:k=b(this.readRom8bit(a));d="LD H,"+k;f="this.h = "+k+";";a++;break;case 39:d="DAA";f="this.daa();";break;case 40:h=a+this.signExtend(this.readRom8bit(a)+1);d="JR Z,("+b(h)+")";f="if ((this.f & F_ZERO) != 0x00) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}";a++;break;case 41:d="ADD HL,HL";f="this.setHL(this.add16(this.getHL(), this.getHL()));";break;case 42:k=b(this.readRom16bit(a));
d="LD HL,("+k+")";f="this.setHL(this.readMemWord("+k+"));";a+=2;break;case 43:d="DEC HL";f="this.decHL();";break;case 44:d="INC L";f="this.l = this.inc8(this.l);";break;case 45:d="DEC L";f="this.l = this.dec8(this.l);";break;case 46:k=b(this.readRom8bit(a));d="LD L,"+k;f="this.l = "+k+";";a++;break;case 47:d="CPL";f="this.cpl_a();";break;case 48:h=a+this.signExtend(this.readRom8bit(a)+1);d="JR NC,("+b(h)+")";f="if (!((this.f & F_CARRY) != 0x00)) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}";
a++;break;case 49:k=b(this.readRom16bit(a));d="LD SP,"+k;f="this.sp = "+k+";";a+=2;break;case 50:k=b(this.readRom16bit(a));d="LD ("+k+"),A";f="this.writeMem("+k+", this.a);";a+=2;break;case 51:d="INC SP";f="this.sp++;";break;case 52:d="INC (HL)";f="this.incMem(this.getHL());";break;case 53:d="DEC (HL)";f="this.decMem(this.getHL());";break;case 54:k=b(this.readRom8bit(a));d="LD (HL),"+k;f="this.writeMem(this.getHL(), "+k+");";a++;break;case 55:d="SCF";f="this.f |= F_CARRY; this.f &= ~ F_NEGATIVE; this.f &= ~ F_HALFCARRY;";
break;case 56:h=a+this.signExtend(this.readRom8bit(a)+1);d="JR C,("+b(h)+")";f="if ((this.f & F_CARRY) != 0x00) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}";a++;break;case 57:d="ADD HL,SP";f="this.setHL(this.add16(this.getHL(), this.sp));";break;case 58:k=b(this.readRom16bit(a));d="LD A,("+k+")";f="this.a = this.readMem("+k+");";a+=2;break;case 59:d="DEC SP";f="this.sp--;";break;case 60:d="INC A";f="this.a = this.inc8(this.a);";break;case 61:d="DEC A";f="this.a = this.dec8(this.a);";break;case 62:k=
b(this.readRom8bit(a));d="LD A,"+k;f="this.a = "+k+";";a++;break;case 63:d="CCF";f="this.ccf();";break;case 64:d="LD B,B";f="";break;case 65:d="LD B,C";f="this.b = this.c;";break;case 66:d="LD B,D";f="this.b = this.d;";break;case 67:d="LD B,E";f="this.b = this.e;";break;case 68:d="LD B,H";f="this.b = this.h;";break;case 69:d="LD B,L";f="this.b = this.l;";break;case 70:d="LD B,(HL)";f="this.b = this.readMem(this.getHL());";break;case 71:d="LD B,A";f="this.b = this.a;";break;case 72:d="LD C,B";f="this.c = this.b;";
break;case 73:d="LD C,C";f="";break;case 74:d="LD C,D";f="this.c = this.d;";break;case 75:d="LD C,E";f="this.c = this.e;";break;case 76:d="LD C,H";f="this.c = this.h;";break;case 77:d="LD C,L";f="this.c = this.l;";break;case 78:d="LD C,(HL)";f="this.c = this.readMem(this.getHL());";break;case 79:d="LD C,A";f="this.c = this.a;";break;case 80:d="LD D,B";f="this.d = this.b;";break;case 81:d="LD D,C";f="this.d = this.c;";break;case 82:d="LD D,D";f="";break;case 83:d="LD D,E";f="this.d = this.e;";break;
case 84:d="LD D,H";f="this.d = this.h;";break;case 85:d="LD D,L";f="this.d = this.l;";break;case 86:d="LD D,(HL)";f="this.d = this.readMem(this.getHL());";break;case 87:d="LD D,A";f="this.d = this.a;";break;case 88:d="LD E,B";f="this.e = this.b;";break;case 89:d="LD E,C";f="this.e = this.c;";break;case 90:d="LD E,D";f="this.e = this.d;";break;case 91:d="LD E,E";f="";break;case 92:d="LD E,H";f="this.e = this.h;";break;case 93:d="LD E,L";f="this.e = this.l;";break;case 94:d="LD E,(HL)";f="this.e = this.readMem(this.getHL());";
break;case 95:d="LD E,A";f="this.e = this.a;";break;case 96:d="LD H,B";f="this.h = this.b;";break;case 97:d="LD H,C";f="this.h = this.c;";break;case 98:d="LD H,D";f="this.h = this.d;";break;case 99:d="LD H,E";f="this.h = this.e;";break;case 100:d="LD H,H";f="";break;case 101:d="LD H,L";f="this.h = this.l;";break;case 102:d="LD H,(HL)";f="this.h = this.readMem(this.getHL());";break;case 103:d="LD H,A";f="this.h = this.a;";break;case 104:d="LD L,B";f="this.l = this.b;";break;case 105:d="LD L,C";f="this.l = this.c;";
break;case 106:d="LD L,D";f="this.l = this.d;";break;case 107:d="LD L,E";f="this.l = this.e;";break;case 108:d="LD L,H";f="this.l = this.h;";break;case 109:d="LD L,L";f="";break;case 110:d="LD L,(HL)";f="this.l = this.readMem(this.getHL());";break;case 111:d="LD L,A";f="this.l = this.a;";break;case 112:d="LD (HL),B";f="this.writeMem(this.getHL(), this.b);";break;case 113:d="LD (HL),C";f="this.writeMem(this.getHL(), this.c);";break;case 114:d="LD (HL),D";f="this.writeMem(this.getHL(), this.d);";break;
case 115:d="LD (HL),E";f="this.writeMem(this.getHL(), this.e);";break;case 116:d="LD (HL),H";f="this.writeMem(this.getHL(), this.h);";break;case 117:d="LD (HL),L";f="this.writeMem(this.getHL(), this.l);";break;case 118:d="HALT";f=HALT_SPEEDUP?"this.tstates = 0x00;":"";f+="this.halt = true; this.pc = "+b(a-1)+"; return;";break;case 119:d="LD (HL),A";f="this.writeMem(this.getHL(), this.a);";break;case 120:d="LD A,B";f="this.a = this.b;";break;case 121:d="LD A,C";f="this.a = this.c;";break;case 122:d=
"LD A,D";f="this.a = this.d;";break;case 123:d="LD A,E";f="this.a = this.e;";break;case 124:d="LD A,H";f="this.a = this.h;";break;case 125:d="LD A,L";f="this.a = this.l;";break;case 126:d="LD A,(HL)";f="this.a = this.readMem(this.getHL());";break;case 127:d="LD A,A";f="";break;case 128:d="ADD A,B";f="this.add_a(this.b);";break;case 129:d="ADD A,C";f="this.add_a(this.c);";break;case 130:d="ADD A,D";f="this.add_a(this.d);";break;case 131:d="ADD A,E";f="this.add_a(this.e);";break;case 132:d="ADD A,H";
f="this.add_a(this.h);";break;case 133:d="ADD A,L";f="this.add_a(this.l);";break;case 134:d="ADD A,(HL)";f="this.add_a(this.readMem(this.getHL()));";break;case 135:d="ADD A,A";f="this.add_a(this.a);";break;case 136:d="ADC A,B";f="this.adc_a(this.b);";break;case 137:d="ADC A,C";f="this.adc_a(this.c);";break;case 138:d="ADC A,D";f="this.adc_a(this.d);";break;case 139:d="ADC A,E";f="this.adc_a(this.e);";break;case 140:d="ADC A,H";f="this.adc_a(this.h);";break;case 141:d="ADC A,L";f="this.adc_a(this.l);";
break;case 142:d="ADC A,(HL)";f="this.adc_a(this.readMem(this.getHL()));";break;case 143:d="ADC A,A";f="this.adc_a(this.a);";break;case 144:d="SUB A,B";f="this.sub_a(this.b);";break;case 145:d="SUB A,C";f="this.sub_a(this.c);";break;case 146:d="SUB A,D";f="this.sub_a(this.d);";break;case 147:d="SUB A,E";f="this.sub_a(this.e);";break;case 148:d="SUB A,H";f="this.sub_a(this.h);";break;case 149:d="SUB A,L";f="this.sub_a(this.l);";break;case 150:d="SUB A,(HL)";f="this.sub_a(this.readMem(this.getHL()));";
break;case 151:d="SUB A,A";f="this.sub_a(this.a);";break;case 152:d="SBC A,B";f="this.sbc_a(this.b);";break;case 153:d="SBC A,C";f="this.sbc_a(this.c);";break;case 154:d="SBC A,D";f="this.sbc_a(this.d);";break;case 155:d="SBC A,E";f="this.sbc_a(this.e);";break;case 156:d="SBC A,H";f="this.sbc_a(this.h);";break;case 157:d="SBC A,L";f="this.sbc_a(this.l);";break;case 158:d="SBC A,(HL)";f="this.sbc_a(this.readMem(this.getHL()));";break;case 159:d="SBC A,A";f="this.sbc_a(this.a);";break;case 160:d="AND A,B";
f="this.f = this.SZP_TABLE[this.a &= this.b] | F_HALFCARRY;";break;case 161:d="AND A,C";f="this.f = this.SZP_TABLE[this.a &= this.c] | F_HALFCARRY;";break;case 162:d="AND A,D";f="this.f = this.SZP_TABLE[this.a &= this.d] | F_HALFCARRY;";break;case 163:d="AND A,E";f="this.f = this.SZP_TABLE[this.a &= this.e] | F_HALFCARRY;";break;case 164:d="AND A,H";f="this.f = this.SZP_TABLE[this.a &= this.h] | F_HALFCARRY;";break;case 165:d="AND A,L";f="this.f = this.SZP_TABLE[this.a &= this.l] | F_HALFCARRY;";
break;case 166:d="AND A,(HL)";f="this.f = this.SZP_TABLE[this.a &= this.readMem(this.getHL())] | F_HALFCARRY;";break;case 167:d="AND A,A";f="this.f = this.SZP_TABLE[this.a] | F_HALFCARRY;";break;case 168:d="XOR A,B";f="this.f = this.SZP_TABLE[this.a ^= this.b];";break;case 169:d="XOR A,C";f="this.f = this.SZP_TABLE[this.a ^= this.c];";break;case 170:d="XOR A,D";f="this.f = this.SZP_TABLE[this.a ^= this.d];";break;case 171:d="XOR A,E";f="this.f = this.SZP_TABLE[this.a ^= this.e];";break;case 172:d=
"XOR A,H";f="this.f = this.SZP_TABLE[this.a ^= this.h];";break;case 173:d="XOR A,L";f="this.f = this.SZP_TABLE[this.a ^= this.l];";break;case 174:d="XOR A,(HL)";f="this.f = this.SZP_TABLE[this.a ^= this.readMem(this.getHL())];";break;case 175:d="XOR A,A";f="this.a = "+b(0)+"; this.f = this.SZP_TABLE[0x00];";break;case 176:d="OR A,B";f="this.f = this.SZP_TABLE[this.a |= this.b];";break;case 177:d="OR A,C";f="this.f = this.SZP_TABLE[this.a |= this.c];";break;case 178:d="OR A,D";f="this.f = this.SZP_TABLE[this.a |= this.d];";
break;case 179:d="OR A,E";f="this.f = this.SZP_TABLE[this.a |= this.e];";break;case 180:d="OR A,H";f="this.f = this.SZP_TABLE[this.a |= this.h];";break;case 181:d="OR A,L";f="this.f = this.SZP_TABLE[this.a |= this.l];";break;case 182:d="OR A,(HL)";f="this.f = this.SZP_TABLE[this.a |= this.readMem(this.getHL())];";break;case 183:d="OR A,A";f="this.f = this.SZP_TABLE[this.a];";break;case 184:d="CP A,B";f="this.cp_a(this.b);";break;case 185:d="CP A,C";f="this.cp_a(this.c);";break;case 186:d="CP A,D";
f="this.cp_a(this.d);";break;case 187:d="CP A,E";f="this.cp_a(this.e);";break;case 188:d="CP A,H";f="this.cp_a(this.h);";break;case 189:d="CP A,L";f="this.cp_a(this.l);";break;case 190:d="CP A,(HL)";f="this.cp_a(this.readMem(this.getHL()));";break;case 191:d="CP A,A";f="this.cp_a(this.a);";break;case 192:d="RET NZ";f="if ((this.f & F_ZERO) === 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 193:d="POP BC";f="this.setBC(this.readMemWord(this.sp)); this.sp += 0x02;";
break;case 194:h=this.readRom16bit(a);d="JP NZ,("+b(h)+")";f="if ((this.f & F_ZERO) === 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 195:h=this.readRom16bit(a);d="JP ("+b(h)+")";f="this.pc = "+b(h)+"; return;";a=null;break;case 196:h=this.readRom16bit(a);d="CALL NZ ("+b(h)+")";f="if ((this.f & F_ZERO) === 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 197:d="PUSH BC";f="this.push2(this.b, this.c);";break;case 198:k=b(this.readRom8bit(a));d="ADD A,"+
k;f="this.add_a("+k+");";a++;break;case 199:h=0;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 200:d="RET Z";f="if ((this.f & F_ZERO) != 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 201:d="RET";f="this.pc = this.readMemWord(this.sp); this.sp += 0x02; return;";a=null;break;case 202:h=this.readRom16bit(a);d="JP Z,("+b(h)+")";f="if ((this.f & F_ZERO) != 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 203:k=this.getCB(a);
d=k.inst;f=k.code;e=e.concat(k.opcodes);a=k.nextAddress;break;case 204:h=this.readRom16bit(a);d="CALL Z ("+b(h)+")";f="if ((this.f & F_ZERO) != 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 205:h=this.readRom16bit(a);d="CALL ("+b(h)+")";f="this.push1("+b(a+2)+"); this.pc = "+b(h)+"; return;";a+=2;break;case 206:k=b(this.readRom8bit(a));d="ADC ,"+k;f="this.adc_a("+k+");";a++;break;case 207:h=8;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+
"; return;";break;case 208:d="RET NC";f="if ((this.f & F_CARRY) === 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 209:d="POP DE";f="this.setDE(this.readMemWord(this.sp)); this.sp += 0x02;";break;case 210:h=this.readRom16bit(a);d="JP NC,("+b(h)+")";f="if ((this.f & F_CARRY) === 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 211:k=this.readRom8bit(a);d="OUT ("+b(k)+"),A";f=this.peepholePortOut(k);a++;break;case 212:h=this.readRom16bit(a);d=
"CALL NC ("+b(h)+")";f="if ((this.f & F_CARRY) === 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 213:d="PUSH DE";f="this.push2(this.d, this.e);";break;case 214:k=b(this.readRom8bit(a));d="SUB "+k;f="this.sub_a("+k+");";a++;break;case 215:h=16;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 216:d="RET C";f="if ((this.f & F_CARRY) != 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";
break;case 217:d="EXX";f="this.exBC(); this.exDE(); this.exHL();";break;case 218:h=this.readRom16bit(a);d="JP C,("+b(h)+")";f="if ((this.f & F_CARRY) != 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 219:k=this.readRom8bit(a);d="IN A,("+b(k)+")";f=this.peepholePortIn(k);a++;break;case 220:h=this.readRom16bit(a);d="CALL C ("+b(h)+")";f="if ((this.f & F_CARRY) != 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 221:k=this.getIndexOpIX(a);d=k.inst;
f=k.code;e=e.concat(k.opcodes);a=k.nextAddress;break;case 222:k=b(this.readRom8bit(a));d="SBC A,"+k;f="this.sbc_a("+k+");";a++;break;case 223:h=24;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 224:d="RET PO";f="if ((this.f & F_PARITY) === 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 225:d="POP HL";f="this.setHL(this.readMemWord(this.sp)); this.sp += 0x02;";break;case 226:h=this.readRom16bit(a);d="JP PO,("+b(h)+
")";f="if ((this.f & F_PARITY) === 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 227:d="EX (SP),HL";f="temp = this.h;this.h = this.readMem(this.sp + 0x01);this.writeMem(this.sp + 0x01, temp);temp = this.l;this.l = this.readMem(this.sp);this.writeMem(this.sp, temp);";break;case 228:h=this.readRom16bit(a);d="CALL PO ("+b(h)+")";f="if ((this.f & F_PARITY) === 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 229:d="PUSH HL";f="this.push2(this.h, this.l);";
break;case 230:k=b(this.readRom8bit(a));d="AND ("+k+")";f="this.f = this.SZP_TABLE[this.a &= "+k+"] | F_HALFCARRY;";a++;break;case 231:h=32;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 232:d="RET PE";f="if ((this.f & F_PARITY) != 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 233:d="JP (HL)";f="this.pc = this.getHL(); return;";a=null;break;case 234:h=this.readRom16bit(a);d="JP PE,("+b(h)+")";f="if ((this.f & F_PARITY) != 0x00) {this.pc = "+
b(h)+";return;}";a+=2;break;case 235:d="EX DE,HL";f="temp = this.d;this.d = this.h;this.h = temp;temp = this.e;this.e = this.l;this.l = temp;";break;case 236:h=this.readRom16bit(a);d="CALL PE ("+b(h)+")";f="if ((this.f & F_PARITY) != 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 237:k=this.getED(a);h=k.target;d=k.inst;f=k.code;e=e.concat(k.opcodes);a=k.nextAddress;break;case 238:k=b(this.readRom8bit(a));d="XOR "+k;f="this.f = this.SZP_TABLE[this.a ^= "+
k+"];";a++;break;case 239:h=40;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 240:d="RET P";f="if ((this.f & F_SIGN) === 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";break;case 241:d="POP AF";f="this.setAF(this.readMemWord(this.sp)); this.sp += 0x02;";break;case 242:h=this.readRom16bit(a);d="JP P,("+b(h)+")";f="if ((this.f & F_SIGN) === 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 243:d="DI";f="this.iff1 = false; this.iff2 = false; this.EI_inst = true;";
break;case 244:h=this.readRom16bit(a);d="CALL P ("+b(h)+")";f="if ((this.f & F_SIGN) === 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 245:d="PUSH AF";f="this.push2(this.a, this.f);";break;case 246:k=b(this.readRom8bit(a));d="OR "+k;f="this.f = this.SZP_TABLE[this.a |= "+k+"];";a++;break;case 247:h=48;d="RST "+b(h);f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;";break;case 248:d="RET M";f="if ((this.f & F_SIGN) != 0x00) {this.tstates -= 0x06;this.pc = this.readMemWord(this.sp);this.sp += 0x02;return;}";
break;case 249:d="LD SP,HL";f="this.sp = this.getHL()";break;case 250:h=this.readRom16bit(a);d="JP M,("+b(h)+")";f="if ((this.f & F_SIGN) != 0x00) {this.pc = "+b(h)+";return;}";a+=2;break;case 251:d="EI";f="this.iff1 = true; this.iff2 = true; this.EI_inst = true;";break;case 252:h=this.readRom16bit(a);d="CALL M ("+b(h)+")";f="if ((this.f & F_SIGN) != 0x00) {this.tstates -= 0x07;this.push1("+b(a+2)+");this.pc = "+b(h)+";return;}";a+=2;break;case 253:k=this.getIndexOpIY(a);d=k.inst;f=k.code;e=e.concat(k.opcodes);
a=k.nextAddress;break;case 254:k=b(this.readRom8bit(a));d="CP "+k;f="this.cp_a("+k+");";a++;break;case 255:h=56,d="RST "+b(h),f="this.push1("+b(a)+"); this.pc = "+b(h)+"; return;"}return Instruction({opcode:c,opcodes:e,inst:d,code:f,address:g,nextAddress:a,target:h})},getCB:function(a){var b=this.readRom8bit(a),c=[b],e="Unimplemented 0xCB prefixed opcode",d=a,g='throw "Unimplemented 0xCB prefixed opcode";';a++;switch(b){case 0:e="RLC B";g="this.b = this.rlc(this.b);";break;case 1:e="RLC C";g="this.c = this.rlc(this.c);";
break;case 2:e="RLC D";g="this.d = this.rlc(this.d);";break;case 3:e="RLC E";g="this.e = this.rlc(this.e);";break;case 4:e="RLC H";g="this.h = this.rlc(this.h);";break;case 5:e="RLC L";g="this.l = this.rlc(this.l);";break;case 6:e="RLC (HL)";g="this.writeMem(this.getHL(), this.rlc(this.readMem(this.getHL())));";break;case 7:e="RLC A";g="this.a = this.rlc(this.a);";break;case 8:e="RRC B";g="this.b = this.rrc(this.b);";break;case 9:e="RRC C";g="this.c = this.rrc(this.c);";break;case 10:e="RRC D";g=
"this.d = this.rrc(this.d);";break;case 11:e="RRC E";g="this.e = this.rrc(this.e);";break;case 12:e="RRC H";g="this.h = this.rrc(this.h);";break;case 13:e="RRC L";g="this.l = this.rrc(this.l);";break;case 14:e="RRC (HL)";g="this.writeMem(this.getHL(), this.rrc(this.readMem(this.getHL())));";break;case 15:e="RRC A";g="this.a = this.rrc(this.a);";break;case 16:e="RL B";g="this.b = this.rl(this.b);";break;case 17:e="RL C";g="this.c = this.rl(this.c);";break;case 18:e="RL D";g="this.d = this.rl(this.d);";
break;case 19:e="RL E";g="this.e = this.rl(this.e);";break;case 20:e="RL H";g="this.h = this.rl(this.h);";break;case 21:e="RL L";g="this.l = this.rl(this.l);";break;case 22:e="RL (HL)";g="this.writeMem(this.getHL(), this.rl(this.readMem(this.getHL())));";break;case 23:e="RL A";g="this.a = this.rl(this.a);";break;case 24:e="RR B";g="this.b = this.rr(this.b);";break;case 25:e="RR C";g="this.c = this.rr(this.c);";break;case 26:e="RR D";g="this.d = this.rr(this.d);";break;case 27:e="RR E";g="this.e = this.rr(this.e);";
break;case 28:e="RR H";g="this.h = this.rr(this.h);";break;case 29:e="RR L";g="this.l = this.rr(this.l);";break;case 30:e="RR (HL)";g="this.writeMem(this.getHL(), this.rr(this.readMem(this.getHL())));";break;case 31:e="RR A";g="this.a = this.rr(this.a);";break;case 32:e="SLA B";g="this.b = this.sla(this.b);";break;case 33:e="SLA C";g="this.c = this.sla(this.c);";break;case 34:e="SLA D";g="this.d = this.sla(this.d);";break;case 35:e="SLA E";g="this.e = this.sla(this.e);";break;case 36:e="SLA H";g=
"this.h = this.sla(this.h);";break;case 37:e="SLA L";g="this.l = this.sla(this.l);";break;case 38:e="SLA (HL)";g="this.writeMem(this.getHL(), this.sla(this.readMem(this.getHL())));";break;case 39:e="SLA A";g="this.a = this.sla(this.a);";break;case 40:e="SRA B";g="this.b = this.sra(this.b);";break;case 41:e="SRA C";g="this.c = this.sra(this.c);";break;case 42:e="SRA D";g="this.d = this.sra(this.d);";break;case 43:e="SRA E";g="this.e = this.sra(this.e);";break;case 44:e="SRA H";g="this.h = this.sra(this.h);";
break;case 45:e="SRA L";g="this.l = this.sra(this.l);";break;case 46:e="SRA (HL)";g="this.writeMem(this.getHL(), this.sra(this.readMem(this.getHL())));";break;case 47:e="SRA A";g="this.a = this.sra(this.a);";break;case 48:e="SLL B";g="this.b = this.sll(this.b);";break;case 49:e="SLL C";g="this.c = this.sll(this.c);";break;case 50:e="SLL D";g="this.d = this.sll(this.d);";break;case 51:e="SLL E";g="this.e = this.sll(this.e);";break;case 52:e="SLL H";g="this.h = this.sll(this.h);";break;case 53:e="SLL L";
g="this.l = this.sll(this.l);";break;case 54:e="SLL (HL)";g="this.writeMem(this.getHL(), this.sll(this.readMem(this.getHL())));";break;case 55:e="SLL A";g="this.a = this.sll(this.a);";break;case 56:e="SRL B";g="this.b = this.srl(this.b);";break;case 57:e="SRL C";g="this.c = this.srl(this.c);";break;case 58:e="SRL D";g="this.d = this.srl(this.d);";break;case 59:e="SRL E";g="this.e = this.srl(this.e);";break;case 60:e="SRL H";g="this.h = this.srl(this.h);";break;case 61:e="SRL L";g="this.l = this.srl(this.l);";
break;case 62:e="SRL (HL)";g="this.writeMem(this.getHL(), this.srl(this.readMem(this.getHL())));";break;case 63:e="SRL A";g="this.a = this.srl(this.a);";break;case 64:e="BIT 0,B";g="this.bit(this.b & BIT_0);";break;case 65:e="BIT 0,C";g="this.bit(this.c & BIT_0);";break;case 66:e="BIT 0,D";g="this.bit(this.d & BIT_0);";break;case 67:e="BIT 0,E";g="this.bit(this.e & BIT_0);";break;case 68:e="BIT 0,H";g="this.bit(this.h & BIT_0);";break;case 69:e="BIT 0,L";g="this.bit(this.l & BIT_0);";break;case 70:e=
"BIT 0,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_0);";break;case 71:e="BIT 0,A";g="this.bit(this.a & BIT_0);";break;case 72:e="BIT 1,B";g="this.bit(this.b & BIT_1);";break;case 73:e="BIT 1,C";g="this.bit(this.c & BIT_1);";break;case 74:e="BIT 1,D";g="this.bit(this.d & BIT_1);";break;case 75:e="BIT 1,E";g="this.bit(this.e & BIT_1);";break;case 76:e="BIT 1,H";g="this.bit(this.h & BIT_1);";break;case 77:e="BIT 1,L";g="this.bit(this.l & BIT_1);";break;case 78:e="BIT 1,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_1);";
break;case 79:e="BIT 1,A";g="this.bit(this.a & BIT_1);";break;case 80:e="BIT 2,B";g="this.bit(this.b & BIT_2);";break;case 81:e="BIT 2,C";g="this.bit(this.c & BIT_2);";break;case 82:e="BIT 2,D";g="this.bit(this.d & BIT_2);";break;case 83:e="BIT 2,E";g="this.bit(this.e & BIT_2);";break;case 84:e="BIT 2,H";g="this.bit(this.h & BIT_2);";break;case 85:e="BIT 2,L";g="this.bit(this.l & BIT_2);";break;case 86:e="BIT 2,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_2);";break;case 87:e="BIT 2,A";g="this.bit(this.a & BIT_2);";
break;case 88:e="BIT 3,B";g="this.bit(this.b & BIT_3);";break;case 89:e="BIT 3,C";g="this.bit(this.c & BIT_3);";break;case 90:e="BIT 3,D";g="this.bit(this.d & BIT_3);";break;case 91:e="BIT 3,E";g="this.bit(this.e & BIT_3);";break;case 92:e="BIT 3,H";g="this.bit(this.h & BIT_3);";break;case 93:e="BIT 3,L";g="this.bit(this.l & BIT_3);";break;case 94:e="BIT 3,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_3);";break;case 95:e="BIT 3,A";g="this.bit(this.a & BIT_3);";break;case 96:e="BIT 4,B";g="this.bit(this.b & BIT_4);";
break;case 97:e="BIT 4,C";g="this.bit(this.c & BIT_4);";break;case 98:e="BIT 4,D";g="this.bit(this.d & BIT_4);";break;case 99:e="BIT 4,E";g="this.bit(this.e & BIT_4);";break;case 100:e="BIT 4,H";g="this.bit(this.h & BIT_4);";break;case 101:e="BIT 4,L";g="this.bit(this.l & BIT_4);";break;case 102:e="BIT 4,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_4);";break;case 103:e="BIT 4,A";g="this.bit(this.a & BIT_4);";break;case 104:e="BIT 5,B";g="this.bit(this.b & BIT_5);";break;case 105:e="BIT 5,C";
g="this.bit(this.c & BIT_5);";break;case 106:e="BIT 5,D";g="this.bit(this.d & BIT_5);";break;case 107:e="BIT 5,E";g="this.bit(this.e & BIT_5);";break;case 108:e="BIT 5,H";g="this.bit(this.h & BIT_5);";break;case 109:e="BIT 5,L";g="this.bit(this.l & BIT_5);";break;case 110:e="BIT 5,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_5);";break;case 111:e="BIT 5,A";g="this.bit(this.a & BIT_5);";break;case 112:e="BIT 6,B";g="this.bit(this.b & BIT_6);";break;case 113:e="BIT 6,C";g="this.bit(this.c & BIT_6);";
break;case 114:e="BIT 6,D";g="this.bit(this.d & BIT_6);";break;case 115:e="BIT 6,E";g="this.bit(this.e & BIT_6);";break;case 116:e="BIT 6,H";g="this.bit(this.h & BIT_6);";break;case 117:e="BIT 6,L";g="this.bit(this.l & BIT_6);";break;case 118:e="BIT 6,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_6);";break;case 119:e="BIT 6,A";g="this.bit(this.a & BIT_6);";break;case 120:e="BIT 7,B";g="this.bit(this.b & BIT_7);";break;case 121:e="BIT 7,C";g="this.bit(this.c & BIT_7);";break;case 122:e="BIT 7,D";
g="this.bit(this.d & BIT_7);";break;case 123:e="BIT 7,E";g="this.bit(this.e & BIT_7);";break;case 124:e="BIT 7,H";g="this.bit(this.h & BIT_7);";break;case 125:e="BIT 7,L";g="this.bit(this.l & BIT_7);";break;case 126:e="BIT 7,(HL)";g="this.bit(this.readMem(this.getHL()) & BIT_7);";break;case 127:e="BIT 7,A";g="this.bit(this.a & BIT_7);";break;case 128:e="RES 0,B";g="this.b &= ~BIT_0;";break;case 129:e="RES 0,C";g="this.c &= ~BIT_0;";break;case 130:e="RES 0,D";g="this.d &= ~BIT_0;";break;case 131:e=
"RES 0,E";g="this.e &= ~BIT_0;";break;case 132:e="RES 0,H";g="this.h &= ~BIT_0;";break;case 133:e="RES 0,L";g="this.l &= ~BIT_0;";break;case 134:e="RES 0,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_0);";break;case 135:e="RES 0,A";g="this.a &= ~BIT_0;";break;case 136:e="RES 1,B";break;case 137:e="RES 1,C";break;case 138:e="RES 1,D";break;case 139:e="RES 1,E";break;case 140:e="RES 1,H";break;case 141:e="RES 1,L";break;case 142:e="RES 1,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_1);";
break;case 143:e="RES 1,A";break;case 144:e="RES 2,B";break;case 145:e="RES 2,C";break;case 146:e="RES 2,D";break;case 147:e="RES 2,E";break;case 148:e="RES 2,H";break;case 149:e="RES 2,L";break;case 150:e="RES 2,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_2);";break;case 151:e="RES 2,A";break;case 152:e="RES 3,B";break;case 153:e="RES 3,C";break;case 154:e="RES 3,D";break;case 155:e="RES 3,E";break;case 156:e="RES 3,H";break;case 157:e="RES 3,L";break;case 158:e="RES 3,(HL)";
g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_3);";break;case 159:e="RES 3,A";g="this.a &= ~BIT_3;";break;case 160:e="RES 4,B";break;case 161:e="RES 4,C";break;case 162:e="RES 4,D";break;case 163:e="RES 4,E";break;case 164:e="RES 4,H";break;case 165:e="RES 4,L";break;case 166:e="RES 4,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_4);";break;case 167:e="RES 4,A";g="this.a &= ~BIT_4;";break;case 168:e="RES 5,B";break;case 169:e="RES 5,C";break;case 170:e=
"RES 5,D";break;case 171:e="RES 5,E";break;case 172:e="RES 5,H";break;case 173:e="RES 5,L";break;case 174:e="RES 5,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_5);";break;case 175:e="RES 5,A";break;case 176:e="RES 6,B";break;case 177:e="RES 6,C";break;case 178:e="RES 6,D";break;case 179:e="RES 6,E";break;case 180:e="RES 6,H";break;case 181:e="RES 6,L";break;case 182:e="RES 6,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_6);";break;case 183:e="RES 6,A";
g="this.a &= ~BIT_6;";break;case 184:e="RES 7,B";g="this.b &= ~BIT_7;";break;case 185:e="RES 7,C";g="this.c &= ~BIT_7;";break;case 186:e="RES 7,D";g="this.d &= ~BIT_7;";break;case 187:e="RES 7,E";g="this.e &= ~BIT_7;";break;case 188:e="RES 7,H";g="this.h &= ~BIT_7;";break;case 189:e="RES 7,L";g="this.l &= ~BIT_7;";break;case 190:e="RES 7,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) & ~BIT_7);";break;case 191:e="RES 7,A";g="this.a &= ~BIT_7;";break;case 192:e="SET 0,B";g="this.b |= BIT_0;";
break;case 193:e="SET 0,C";g="this.c |= BIT_0;";break;case 194:e="SET 0,D";g="this.d |= BIT_0;";break;case 195:e="SET 0,E";g="this.e |= BIT_0;";break;case 196:e="SET 0,H";g="this.h |= BIT_0;";break;case 197:e="SET 0,L";g="this.l |= BIT_0;";break;case 198:e="SET 0,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_0);";break;case 199:e="SET 0,A";g="this.a |= BIT_0;";break;case 200:e="SET 1,B";break;case 201:e="SET 1,C";break;case 202:e="SET 1,D";break;case 203:e="SET 1,E";break;
case 204:e="SET 1,H";break;case 205:e="SET 1,L";break;case 206:e="SET 1,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_1);";break;case 207:e="SET 1,A";break;case 208:e="SET 2,B";break;case 209:e="SET 2,C";break;case 210:e="SET 2,D";break;case 211:e="SET 2,E";break;case 212:e="SET 2,H";break;case 213:e="SET 2,L";break;case 214:e="SET 2,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_2)";break;case 215:e="SET 2,A";break;case 216:e="SET 3,B";break;case 217:e=
"SET 3,C";break;case 218:e="SET 3,D";break;case 219:e="SET 3,E";break;case 220:e="SET 3,H";break;case 221:e="SET 3,L";break;case 222:e="SET 3,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_3);";break;case 223:e="SET 3,A";break;case 224:e="SET 4,B";break;case 225:e="SET 4,C";break;case 226:e="SET 4,D";break;case 227:e="SET 4,E";break;case 228:e="SET 4,H";break;case 229:e="SET 4,L";break;case 230:e="SET 4,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_4);";
break;case 231:e="SET 4,A";g="this.a |= BIT_4;";break;case 232:e="SET 5,B";break;case 233:e="SET 5,C";break;case 234:e="SET 5,D";break;case 235:e="SET 5,E";break;case 236:e="SET 5,H";break;case 237:e="SET 5,L";break;case 238:e="SET 5,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_5);";break;case 239:e="SET 5,A";g="this.a |= BIT_5;";break;case 240:e="SET 6,B";g="this.b |= BIT_6;";break;case 241:e="SET 6,C";g="this.c |= BIT_6;";break;case 242:e="SET 6,D";g="this.d |= BIT_6;";
break;case 243:e="SET 6,E";g="this.e |= BIT_6;";break;case 244:e="SET 6,H";g="this.h |= BIT_6;";break;case 245:e="SET 6,L";g="this.l |= BIT_6;";break;case 246:e="SET 6,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_6);";break;case 247:e="SET 6,A";g="this.a |= BIT_6;";break;case 248:e="SET 7,B";g="this.b |= BIT_7;";break;case 249:e="SET 7,C";g="this.c |= BIT_7;";break;case 250:e="SET 7,D";g="this.d |= BIT_7;";break;case 251:e="SET 7,E";g="this.e |= BIT_7;";break;case 252:e="SET 7,H";
g="this.h |= BIT_7;";break;case 253:e="SET 7,L";g="this.l |= BIT_7;";break;case 254:e="SET 7,(HL)";g="this.writeMem(this.getHL(), this.readMem(this.getHL()) | BIT_7);";break;case 255:e="SET 7,A",g="this.a |= BIT_7;"}return{opcode:b,opcodes:c,inst:e,code:g,address:d,nextAddress:a}},getED:function(a){var b=JSSMS.Utils.toHex,c=this.readRom8bit(a),e=[c],d="Unimplemented 0xED prefixed opcode",g=a,h=null,f='throw "Unimplemented 0xED prefixed opcode";',k="",l=0;a++;switch(c){case 64:d="IN B,(C)";f="this.b = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.b];";
break;case 65:d="OUT (C),B";f="this.port.out(this.c, this.b);";break;case 66:d="SBC HL,BC";f="this.sbc16(this.getBC());";break;case 67:l=this.readRom16bit(a);k=b(l);d="LD ("+k+"),BC";f="this.writeMem("+k+", this.c);this.writeMem("+b(l+1)+", this.b);";a+=2;break;case 68:case 76:case 84:case 92:case 100:case 108:case 116:case 124:d="NEG";f="temp = this.a;this.a = 0x00;this.sub_a(temp);";break;case 69:case 77:case 85:case 93:case 101:case 109:case 117:case 125:d="RETN / RETI";f="this.pc = this.readMemWord(this.sp);this.sp += 0x02;this.iff1 = this.iff2;return;";
a=null;break;case 70:case 78:case 102:case 110:d="IM 0";f="this.im = 0x00;";break;case 71:d="LD I,A";f="this.i = this.a;";break;case 72:d="IN C,(C)";f="this.c = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.c];";break;case 73:d="OUT (C),C";f="this.port.out(this.c, this.c);";break;case 74:d="ADC HL,BC";f="this.adc16(this.getBC());";break;case 75:k=b(this.readRom16bit(a));d="LD BC,("+k+")";f="this.setBC(this.readMemWord("+k+"));";a+=2;break;case 79:d="LD R,A";f="this.r = this.a;";
break;case 80:d="IN D,(C)";f="this.d = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.d];";break;case 81:d="OUT (C),D";f="this.port.out(this.c, this.d);";break;case 82:d="SBC HL,DE";f="this.sbc16(this.getDE());";break;case 83:l=this.readRom16bit(a);k=b(l);d="LD ("+k+"),DE";f="this.writeMem("+k+", this.e);this.writeMem("+b(l+1)+", this.d);";a+=2;break;case 86:case 118:d="IM 1";f="this.im = 0x01;";break;case 87:d="LD A,I";f="this.a = this.i;this.f = (this.f & F_CARRY) | this.SZ_TABLE[this.a] | (this.iff2 ? F_PARITY : 0);";
break;case 88:d="IN E,(C)";f="this.e = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.e];";break;case 89:d="OUT (C),E";f="this.port.out(this.c, this.e);";break;case 90:d="ADC HL,DE";f="this.adc16(this.getDE());";break;case 91:k=b(this.readRom16bit(a));d="LD DE,("+k+")";f="this.setDE(this.readMemWord("+k+"));";a+=2;break;case 95:d="LD A,R";f=REFRESH_EMULATION?"this.a = this.r;":"this.a = JSSMS.Utils.rndInt(0xFF);";f+="this.f = this.f & F_CARRY | this.SZ_TABLE[this.a] | (this.iff2 ? F_PARITY : 0x00);";
break;case 96:d="IN H,(C)";f="this.h = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.h];";break;case 97:d="OUT (C),H";f="this.port.out(this.c, this.h);";break;case 98:d="SBC HL,HL";f="this.sbc16(this.getHL());";break;case 99:l=this.readRom16bit(a);k=b(l);d="LD ("+k+"),HL";f="this.writeMem("+k+", this.l);this.writeMem("+b(l+1)+", this.h);";a+=2;break;case 103:d="RRD";f="var location = this.getHL();temp = this.readMem(location);this.writeMem(location, (temp >> 4) | ((this.a & 0x0F) << 4));this.a = (this.a & 0xF0) | (temp & 0x0F);this.f = this.f & F_CARRY | this.SZP_TABLE[this.a];";
break;case 104:d="IN L,(C)";f="this.l = this.port.in_(this.c);this.f = (this.f & F_CARRY) | this.SZP_TABLE[this.l];";break;case 105:d="OUT (C),L";f="this.port.out(this.c, this.l);";break;case 106:d="ADC HL,HL";f="this.adc16(this.getHL());";break;case 107:k=b(this.readRom16bit(a));d="LD HL,("+k+")";f="this.setHL(this.readMemWord("+k+"));";a+=2;break;case 111:d="RLD";f="var location = this.getHL();temp = this.readMem(location);this.writeMem(location, (temp & 0x0F) << 4 | (this.a & 0x0F));this.a = (this.a & 0xF0) | (temp >> 4);this.f = this.f & F_CARRY | this.SZP_TABLE[this.a];";
break;case 113:d="OUT (C),0";f="this.port.out(this.c, 0);";break;case 114:d="SBC HL,SP";f="this.sbc16(this.sp);";break;case 115:l=this.readRom16bit(a);k=b(l);d="LD ("+k+"),SP";f="this.writeMem("+k+", this.sp & 0xFF);this.writeMem("+b(l+1)+", this.sp >> 8);";a+=2;break;case 120:d="IN A,(C)";f="this.a = this.port.in_(this.c);this.f = this.f & F_CARRY | this.SZP_TABLE[this.a];";break;case 121:d="OUT (C),A";f="this.port.out(this.c, this.a);";break;case 122:d="ADC HL,SP";f="this.adc16(this.sp);";break;
case 123:k=b(this.readRom16bit(a));d="LD SP,("+k+")";f="this.sp = this.readMemWord("+k+");";a+=2;break;case 160:d="LDI";f="temp = this.readMem(this.getHL());this.writeMem(this.getDE(), temp);this.decBC();this.incDE();this.incHL();temp = (temp + this.a) & 0xFF;this.f = (this.f & 0xC1) | (this.getBC() ? F_PARITY : 0) | (temp & 0x08) | ((temp & 0x02) ? 0x20 : 0);";break;case 161:d="CPI";f="temp = (this.f & F_CARRY) | F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.incHL();this.decBC();temp |= (this.getBC() === 0x00 ? 0x00 : F_PARITY);this.f = (this.f & 0xF8) | temp;";
break;case 162:d="INI";f="temp = this.port.in_(this.c);this.writeMem(this.getHL(), temp);this.b = this.dec8(this.b);this.incHL();if ((temp & 0x80) === 0x80) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";break;case 163:d="OUTI";f="temp = this.readMem(this.getHL());this.port.out(this.c, temp);this.incHL();this.b = this.dec8(this.b);if (this.l + temp > 0xFF) {this.f |= F_CARRY; this.f |= F_HALFCARRY;} else {this.f &= ~ F_CARRY; this.f &= ~ F_HALFCARRY;}if ((temp & 0x80) === 0x80) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";
break;case 168:d="LDD";break;case 169:d="CPD";break;case 170:d="IND";f="temp = this.port.in_(this.c);this.writeMem(this.getHL(), temp);this.b = this.dec8(this.b);this.decHL();if ((temp & 0x80) != 0x00) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";break;case 171:d="OUTD";f="temp = this.readMem(this.getHL());this.port.out(this.c, temp);this.decHL();this.b = this.dec8(this.b);if (this.l + temp > 0xFF) {this.f |= F_CARRY; this.f |= F_HALFCARRY;} else {this.f &= ~ F_CARRY; this.f &= ~ F_HALFCARRY;}if ((temp & 0x80) === 0x80) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";
break;case 176:d="LDIR";f="this.writeMem(this.getDE(), this.readMem(this.getHL()));this.incDE();this.incHL();this.decBC();";ACCURATE_INTERRUPT_EMULATION?(h=a-2,f+="if (this.getBC() != 0x00) {this.tstates -= 0x05;this.f |= F_PARITY;return;} else {"):f+="for (;this.getBC() != 0x00; this.f |= F_PARITY, this.tstates -= 5) {this.writeMem(this.getDE(), this.readMem(this.getHL()));this.incDE();this.incHL();this.decBC();}if (!(this.getBC() != 0x00)) {";f+="this.f &= ~ F_PARITY;}this.f &= ~ F_NEGATIVE; this.f &= ~ F_HALFCARRY;";
break;case 177:d="CPIR";f="temp = (this.f & F_CARRY) | F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.incHL();this.decBC();temp |= (this.getBC() === 0x00 ? 0x00 : F_PARITY);";ACCURATE_INTERRUPT_EMULATION?(h=a-2,f+="if ((temp & F_PARITY) != 0x00 && (this.f & F_ZERO) === 0x00) {this.tstates -= 0x05;this.pc = "+b(h)+";return;}"):f+="for (;(temp & F_PARITY) != 0x00 && (this.f & F_ZERO) === 0x00; this.tstates -= 5) {temp = (this.f & F_CARRY) | F_NEGATIVE;this.cp_a(this.readMem(this.getHL()));this.incHL();this.decBC();temp |= (this.getBC() === 0x00 ? 0x00 : F_PARITY);}";
f+="this.f = (this.f & 0xF8) | temp;";break;case 178:h=a-2;d="INIR";f="temp = this.port.in_(this.c);this.writeMem(this.getHL(), temp);this.b = this.dec8(this.b);this.incHL();if (this.b != 0x00) {this.tstates -= 0x05;return;}if ((temp & 0x80) === 0x80) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";break;case 179:d="OTIR";f="temp = this.readMem(this.getHL());this.port.out(this.c, temp);this.b = this.dec8(this.b);this.incHL();";ACCURATE_INTERRUPT_EMULATION?(h=a-2,f+="if (this.b != 0x00) {this.tstates -= 0x05;return;}"):
f+="for (;this.b != 0x00; this.tstates -= 5) {temp = this.readMem(this.getHL());this.port.out(this.c, temp);this.b = this.dec8(this.b);this.incHL();}";f+="if (this.l + temp > 0xFF) {this.f |= F_CARRY; this.f |= F_HALFCARRY;} else {this.f &= ~ F_CARRY; this.f &= ~ F_HALFCARRY;}if ((temp & 0x80) != 0x00) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";break;case 184:d="LDDR";break;case 185:d="CPDR";break;case 186:h=a-2;d="INDR";f="temp = this.port.in_(this.c);this.writeMem(this.getHL(), temp);this.b = this.dec8(this.b);this.decHL();if (this.b != 0x00) {this.tstates -= 0x05;return;}if ((temp & 0x80) != 0x00) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}";
break;case 187:h=a-2,d="OTDR",f="temp = this.readMem(this.getHL());this.port.out(this.c, temp);this.b = this.dec8(this.b);this.decHL();if (this.b != 0x00) {this.tstates -= 0x05;return;}if (this.l + temp > 0xFF) {this.f |= F_CARRY; this.f |= F_HALFCARRY;} else {this.f &= ~ F_CARRY; this.f &= ~ F_HALFCARRY;}if ((temp & 0x80) != 0x00) {this.f |= F_NEGATIVE;} else {this.f &= ~ F_NEGATIVE;}"}return{opcode:c,opcodes:e,inst:d,code:f,address:g,nextAddress:a,target:h}},getIndex:function(a,b){var c=JSSMS.Utils.toHex,
e=this.readRom8bit(b),d=[e],g="Unimplemented 0xDD or 0xFD prefixed opcode",h=b,f='throw "Unimplemented 0xDD or 0xFD prefixed opcode";',k="",l=0;b++;l=0;k={};switch(e){case 9:g="ADD "+a+",BC";f="this.set"+a+"(this.add16(this.get"+a+"(), this.getBC()));";break;case 25:g="ADD "+a+",DE";f="this.set"+a+"(this.add16(this.get"+a+"(), this.getDE()));";break;case 33:k=c(this.readRom16bit(b));g="LD "+a+","+k;f="this.set"+a+"("+k+");";b+=2;break;case 34:l=this.readRom16bit(b);k=c(l);g="LD ("+k+"),"+a;f="this.writeMem("+
k+", this."+a.toLowerCase()+"L);this.writeMem("+c(l+1)+", this."+a.toLowerCase()+"H);";b+=2;break;case 35:g="INC "+a;f="this.inc"+a+"();";break;case 36:g="INC "+a+"H *";break;case 37:g="DEC "+a+"H *";break;case 38:g="LD "+a+"H,"+c(this.readRom8bit(b))+" *";b++;break;case 41:g="ADD "+a+"  "+a;break;case 42:l=this.readRom16bit(b);g="LD "+a+" ("+c(l)+")";f="this.ixL = this.readMem("+c(l)+");this.ixH = this.readMem("+c(l+1)+");";b+=2;break;case 43:g="DEC "+a;f="this.dec"+a+"();";break;case 44:g="INC "+
a+"L *";break;case 45:g="DEC "+a+"L *";break;case 46:g="LD "+a+"L,"+c(this.readRom8bit(b));b++;break;case 52:l=this.readRom8bit(b);g="INC ("+a+"+"+c(l)+")";f="this.incMem(this.get"+a+"() + "+c(l)+");";b++;break;case 53:l=this.readRom8bit(b);g="DEC ("+a+"+"+c(l)+")";f="this.decMem(this.get"+a+"() + "+c(l)+");";b++;break;case 54:l=this.readRom8bit(b);k=c(this.readRom8bit(b+1));g="LD ("+a+"+"+c(l)+"),"+k;f="this.writeMem(this.get"+a+"() + "+c(l)+", "+k+");";b+=2;break;case 57:g="ADD "+a+" SP";f="this.set"+
a+"(this.add16(this.get"+a+"(), this.sp));";break;case 68:g="LD B,"+a+"H *";break;case 69:g="LD B,"+a+"L *";break;case 70:l=this.readRom8bit(b);g="LD B,("+a+"+"+c(l)+")";f="this.b = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 76:g="LD C,"+a+"H *";break;case 77:g="LD C,"+a+"L *";break;case 78:l=this.readRom8bit(b);g="LD C,("+a+"+"+c(l)+")";f="this.c = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 84:g="LD D,"+a+"H *";break;case 85:g="LD D,"+a+"L *";break;case 86:l=this.readRom8bit(b);
g="LD D,("+a+"+"+c(l)+")";f="this.d = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 92:g="LD E,"+a+"H *";break;case 93:g="LD E,"+a+"L *";break;case 94:l=this.readRom8bit(b);g="LD E,("+a+"+"+c(l)+")";f="this.e = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 96:g="LD "+a+"H,B *";break;case 97:g="LD "+a+"H,C *";break;case 98:g="LD "+a+"H,D *";break;case 99:g="LD "+a+"H,E *";break;case 100:g="LD "+a+"H,"+a+"H*";break;case 101:g="LD "+a+"H,"+a+"L *";break;case 102:l=this.readRom8bit(b);
g="LD H,("+a+"+"+c(l)+")";f="this.h = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 103:g="LD "+a+"H,A *";break;case 104:g="LD "+a+"L,B *";break;case 105:g="LD "+a+"L,C *";break;case 106:g="LD "+a+"L,D *";break;case 107:g="LD "+a+"L,E *";break;case 108:g="LD "+a+"L,"+a+"H *";break;case 109:g="LD "+a+"L,"+a+"L *";f="";break;case 110:l=this.readRom8bit(b);g="LD L,("+a+"+"+c(l)+")";f="this.l = this.readMem(this.get"+a+"() + "+c(l)+");";b++;break;case 111:g="LD "+a+"L,A *";f="this."+a.toLowerCase()+
"L = this.a;";break;case 112:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),B";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.b);";b++;break;case 113:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),C";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.c);";b++;break;case 114:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),D";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.d);";b++;break;case 115:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),E";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.e);";b++;
break;case 116:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),H";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.h);";b++;break;case 117:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),L";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.l);";b++;break;case 119:l=this.readRom8bit(b);g="LD ("+a+"+"+c(l)+"),A";f="this.writeMem(this.get"+a+"() + "+c(l)+", this.a);";b++;break;case 124:g="LD A,"+a+"H *";break;case 125:g="LD A,"+a+"L *";break;case 126:l=this.readRom8bit(b);g="LD A,("+a+"+"+c(l)+")";f="this.a = this.readMem(this.get"+
a+"() + "+c(l)+");";b++;break;case 132:g="ADD A,"+a+"H *";break;case 133:g="ADD A,"+a+"L *";break;case 134:l=this.readRom8bit(b);g="ADD A,("+a+"+"+c(l)+")";f="this.add_a(this.readMem(this.get"+a+"() + "+c(l)+"));";b++;break;case 140:g="ADC A,"+a+"H *";break;case 141:g="ADC A,"+a+"L *";break;case 142:l=this.readRom8bit(b);g="ADC A,("+a+"+"+c(l)+")";f="this.adc_a(this.readMem(this.get"+a+"() + "+c(l)+"));";b++;break;case 148:g="SUB "+a+"H *";break;case 149:g="SUB "+a+"L *";break;case 150:l=this.readRom8bit(b);
g="SUB A,("+a+"+"+c(l)+")";f="this.sub_a(this.readMem(this.get"+a+"() + "+c(l)+"));";b++;break;case 156:g="SBC A,"+a+"H *";break;case 157:g="SBC A,"+a+"L *";break;case 158:l=this.readRom8bit(b);g="SBC A,("+a+"+"+c(l)+")";f="this.sbc_a(this.readMem(this.get"+a+"() + "+c(l)+"));";b++;break;case 164:g="AND "+a+"H *";f="this.f = this.SZP_TABLE[this.a &= this."+a.toLowerCase()+"H];";break;case 165:g="AND "+a+"L *";f="this.f = this.SZP_TABLE[this.a &= this."+a.toLowerCase()+"L];";break;case 166:l=this.readRom8bit(b);
g="AND A,("+a+"+"+c(l)+")";f="this.f = this.SZP_TABLE[this.a &= this.readMem(this.get"+a+"() + "+c(l)+")] | F_HALFCARRY;";b++;break;case 172:g="XOR A "+a+"H*";f="this.f = this.SZP_TABLE[this.a |= this."+a.toLowerCase()+"H];";break;case 173:g="XOR A "+a+"L*";f="this.f = this.SZP_TABLE[this.a |= this."+a.toLowerCase()+"L];";break;case 174:l=this.readRom8bit(b);g="XOR A,("+a+"+"+c(l)+")";f="this.f = this.SZP_TABLE[this.a ^= this.readMem(this.get"+a+"() + "+c(l)+")];";b++;break;case 180:g="OR A "+a+"H*";
f="this.f = this.SZP_TABLE[this.a |= this."+a.toLowerCase()+"H];";break;case 181:g="OR A "+a+"L*";f="this.f = this.SZP_TABLE[this.a |= this."+a.toLowerCase()+"L];";break;case 182:l=this.readRom8bit(b);g="OR A,("+a+"+"+c(l)+")";f="this.f = this.SZP_TABLE[this.a |= this.readMem(this.get"+a+"() + "+c(l)+")];";b++;break;case 188:g="CP "+a+"H *";f="this.cp_a(this."+a.toLowerCase()+"H);";break;case 189:g="CP "+a+"L *";f="this.cp_a(this."+a.toLowerCase()+"L);";break;case 190:l=this.readRom8bit(b);g="CP ("+
a+"+"+c(l)+")";f="this.cp_a(this.readMem(this.get"+a+"() + "+c(l)+"));";b++;break;case 203:k=this.getIndexCB(a,b);g=k.inst;f=k.code;d=d.concat(k.opcodes);b=k.nextAddress;break;case 225:g="POP "+a;f="this.set"+a+"(this.readMemWord(this.sp)); this.sp += 0x02;";break;case 227:g="EX SP,("+a+")";f="temp = this.get"+a+"();this.set"+a+"(this.readMemWord(this.sp));this.writeMem(this.sp, temp & 0xFF);this.writeMem(this.sp + 1, temp >> 8);";break;case 229:g="PUSH "+a;f="this.push2(this."+a.toLowerCase()+"H, this."+
a.toLowerCase()+"L);";break;case 233:g="JP ("+a+")";f="this.pc = this.get"+a+"(); return;";b=null;break;case 249:g="LD SP,"+a,f="this.sp = this.get"+a+"();"}return{opcode:e,opcodes:d,inst:g,code:f,address:h,nextAddress:b}},getIndexCB:function(a,b){var c=JSSMS.Utils.toHex,e=b,c="location = this.get"+a+"() + "+c(this.readRom8bit(b++))+" & 0xFFFF;",d=this.readRom8bit(b),g=[d],h="Unimplemented 0xDDCB or 0xFDCB prefixed opcode",f='throw "Unimplemented 0xDDCB or 0xFDCB prefixed opcode";';b++;switch(d){case 0:h=
"LD B,RLC ("+a+")";f=c+"this.b = this.rlc(this.readMem(location)); this.writeMem(location, this.b);";break;case 1:h="LD C,RLC ("+a+")";f=c+"this.c = this.rlc(this.readMem(location)); this.writeMem(location, this.c);";break;case 2:h="LD D,RLC ("+a+")";f=c+"this.d = this.rlc(this.readMem(location)); this.writeMem(location, this.d);";break;case 3:h="LD E,RLC ("+a+")";break;case 4:h="LD H,RLC ("+a+")";break;case 5:h="LD L,RLC ("+a+")";break;case 6:h="RLC ("+a+")";f=c+"this.writeMem(location, this.rlc(this.readMem(location)));";
break;case 7:h="LD A,RLC ("+a+")";f=c+"this.a = this.rlc(this.readMem(location)); this.writeMem(location, this.a);";break;case 8:h="LD B,RRC ("+a+")";break;case 9:h="LD C,RRC ("+a+")";break;case 10:h="LD D,RRC ("+a+")";break;case 11:h="LD E,RRC ("+a+")";break;case 12:h="LD H,RRC ("+a+")";break;case 13:h="LD L,RRC ("+a+")";break;case 14:h="RRC ("+a+")";break;case 15:h="LD A,RRC ("+a+")";break;case 16:h="LD B,RL ("+a+")";break;case 17:h="LD C,RL ("+a+")";break;case 18:h="LD D,RL ("+a+")";break;case 19:h=
"LD E,RL ("+a+")";break;case 20:h="LD H,RL ("+a+")";break;case 21:h="LD L,RL ("+a+")";break;case 22:h="RL ("+a+")";break;case 23:h="LD A,RL ("+a+")";break;case 24:h="LD B,RR ("+a+")";break;case 25:h="LD C,RR ("+a+")";break;case 26:h="LD D,RR ("+a+")";break;case 27:h="LD E,RR ("+a+")";break;case 28:h="LD H,RR ("+a+")";break;case 29:h="LD L,RR ("+a+")";f=c+"this.l = this.rr(this.readMem(location)); this.writeMem(location, this.l);";break;case 30:h="RR ("+a+")";break;case 31:h="LD A,RR ("+a+")";f=c+
"this.a = this.rr(this.readMem(location)); this.writeMem(location, this.a);";break;case 32:h="LD B,SLA ("+a+")";break;case 33:h="LD C,SLA ("+a+")";break;case 34:h="LD D,SLA ("+a+")";break;case 35:h="LD E,SLA ("+a+")";break;case 36:h="LD H,SLA ("+a+")";break;case 37:h="LD L,SLA ("+a+")";break;case 38:h="SLA ("+a+")";break;case 39:h="LD A,SLA ("+a+")";break;case 40:h="LD B,SRA ("+a+")";break;case 41:h="LD C,SRA ("+a+")";break;case 42:h="LD D,SRA ("+a+")";break;case 43:h="LD E,SRA ("+a+")";break;case 44:h=
"LD H,SRA ("+a+")";break;case 45:h="LD L,SRA ("+a+")";break;case 46:h="SRA ("+a+")";break;case 47:h="LD A,SRA ("+a+")";break;case 48:h="LD B,SLL ("+a+")";break;case 49:h="LD C,SLL ("+a+")";break;case 50:h="LD D,SLL ("+a+")";break;case 51:h="LD E,SLL ("+a+")";break;case 52:h="LD H,SLL ("+a+")";break;case 53:h="LD L,SLL ("+a+")";break;case 54:h="SLL ("+a+") *";break;case 55:h="LD A,SLL ("+a+")";break;case 56:h="LD B,SRL ("+a+")";break;case 57:h="LD C,SRL ("+a+")";break;case 58:h="LD D,SRL ("+a+")";
break;case 59:h="LD E,SRL ("+a+")";break;case 60:h="LD H,SRL ("+a+")";break;case 61:h="LD L,SRL ("+a+")";break;case 62:h="SRL ("+a+")";break;case 63:h="LD A,SRL ("+a+")";break;case 64:case 65:case 66:case 67:case 68:case 69:case 70:case 71:h="BIT 0,("+a+")";break;case 72:case 73:case 74:case 75:case 76:case 77:case 78:case 79:h="BIT 1,("+a+")";break;case 80:case 81:case 82:case 83:case 84:case 85:case 86:case 87:h="BIT 2,("+a+")";break;case 88:case 89:case 90:case 91:case 92:case 93:case 94:case 95:h=
"BIT 3,("+a+")";break;case 96:case 97:case 98:case 99:case 100:case 101:case 102:case 103:h="BIT 4,("+a+")";break;case 104:case 105:case 106:case 107:case 108:case 109:case 110:case 111:h="BIT 5,("+a+")";break;case 112:case 113:case 114:case 115:case 116:case 117:case 118:case 119:h="BIT 6,("+a+")";break;case 120:case 121:case 122:case 123:case 124:case 125:case 126:case 127:h="BIT 7,("+a+")";break;case 128:case 129:case 130:case 131:case 132:case 133:case 134:case 135:h="RES 0,("+a+")";break;case 136:case 137:case 138:case 139:case 140:case 141:case 142:case 143:h=
"RES 1,("+a+")";break;case 144:case 145:case 146:case 147:case 148:case 149:case 150:case 151:h="RES 2,("+a+")";break;case 152:case 153:case 154:case 155:case 156:case 157:case 158:case 159:h="RES 3,("+a+")";break;case 160:case 161:case 162:case 163:case 164:case 165:case 166:case 167:h="RES 4,("+a+")";break;case 168:case 169:case 170:case 171:case 172:case 173:case 174:case 175:h="RES 5,("+a+")";break;case 176:case 177:case 178:case 179:case 180:case 181:case 182:case 183:h="RES 6,("+a+")";break;
case 184:case 185:case 186:case 187:case 188:case 189:case 190:case 191:h="RES 7,("+a+")";break;case 192:case 193:case 194:case 195:case 196:case 197:case 198:case 199:h="SET 0,("+a+")";break;case 200:case 201:case 202:case 203:case 204:case 205:case 206:case 207:h="SET 1,("+a+")";break;case 208:case 209:case 210:case 211:case 212:case 213:case 214:case 215:h="SET 2,("+a+")";break;case 216:case 217:case 218:case 219:case 220:case 221:case 222:case 223:h="SET 3,("+a+")";break;case 224:case 225:case 226:case 227:case 228:case 229:case 230:case 231:h=
"SET 4,("+a+")";break;case 232:case 233:case 234:case 235:case 236:case 237:case 238:case 239:h="SET 5,("+a+")";break;case 240:case 241:case 242:case 243:case 244:case 245:case 246:case 247:h="SET 6,("+a+")";break;case 248:case 249:case 250:case 251:case 252:case 253:case 254:case 255:h="SET 7,("+a+")"}b++;return{opcode:d,opcodes:g,inst:h,code:f,address:e,nextAddress:b}},getIndexOpIX:function(a){return this.getIndex("IX",a)},getIndexOpIY:function(a){return this.getIndex("IY",a)},readRom8bit:function(a){return SUPPORT_DATAVIEW?
this.rom[a>>14].getUint8(a&16383):this.rom[a>>14][a&16383]&255},readRom16bit:function(a){return SUPPORT_DATAVIEW?16383>(a&16383)?this.rom[a>>14].getUint16(a&16383,LITTLE_ENDIAN):this.rom[a>>14].getUint8(a&16383)|this.rom[++a>>14].getUint8(a&16383)<<8:this.rom[a>>14][a&16383]&255|(this.rom[++a>>14][a&16383]&255)<<8},peepholePortOut:function(a){if(this.main.is_gg&&7>a)return"";switch(a&193){case 1:if(LIGHTGUN)return"var value = this.a;this.port.oldTH = (this.port.getTH(PORT_A) != 0x00 || this.port.getTH(PORT_B) != 0x00);this.port.writePort(PORT_A, value);this.port.writePort(PORT_B, value >> 2);if (!this.port.oldTH && (this.port.getTH(PORT_A) != 0x00 || this.port.getTH(PORT_B) != 0x00)) {this.port.hCounter = this.port.getHCount();}";
a="var value = this.a;this.port.ioPorts[0] = (value & 0x20) << 1;this.port.ioPorts[1] = (value & 0x80);";0===this.port.europe&&(a+="this.port.ioPorts[0] = ~this.port.ioPorts[0];this.port.ioPorts[1] = ~this.port.ioPorts[1];");return a;case 128:return"this.vdp.dataWrite(this.a);";case 129:return"this.vdp.controlWrite(this.a);";case 64:case 65:if(this.main.soundEnabled)return"this.psg.write(this.a);"}return""},peepholePortIn:function(a){if(this.main.is_gg&&7>a)switch(a){case 0:return"this.a = (this.port.keyboard.ggstart & 0xBF) | this.port.europe;";
case 1:case 2:case 3:case 4:case 5:return"this.a = 0x00;";case 6:return"this.a = 0xFF;"}switch(a&193){case 64:return"this.a = this.vdp.getVCount();";case 65:return"this.a = this.port.hCounter;";case 128:return"this.a = this.vdp.dataRead();";case 129:return"this.a = this.vdp.controlRead();";case 192:return"this.a = this.port.keyboard.controller1;";case 193:return LIGHTGUN?"if (this.port.keyboard.lightgunClick)this.port.lightPhaserSync();this.a = (this.port.keyboard.controller2 & 0x3F) | (this.port.getTH(PORT_A) != 0x00 ? 0x40 : 0x00) | (this.port.getTH(PORT_B) != 0x00 ? 0x80 : 0x00);":
"this.a = (this.port.keyboard.controller2 & 0x3F) | this.port.ioPorts[0] | this.port.ioPorts[1];"}return"this.a = 0xFF;"}};function Instruction(a){var b=JSSMS.Utils.toHex,c={address:0,hexAddress:"",opcode:0,opcodes:[],inst:"",code:"",nextAddress:null,target:null,isJumpTarget:!1,jumpTargetNb:0,label:""},e,d="";for(e in c)void 0!==a[e]&&(c[e]=a[e]);c.hexAddress=b(c.address);c.opcodes.length&&(d=c.opcodes.map(b).join(" ")+" ");c.label=c.hexAddress+" "+d+c.inst;return c};var KEY_UP=1,KEY_DOWN=2,KEY_LEFT=4,KEY_RIGHT=8,KEY_FIRE1=16,KEY_FIRE2=32,KEY_START=64;JSSMS.Keyboard=function(a){this.main=a;this.lightgunY=this.lightgunX=this.ggstart=this.controller2=this.controller1=0;this.lightgunEnabled=this.lightgunClick=!1};
JSSMS.Keyboard.prototype={reset:function(){this.ggstart=this.controller2=this.controller1=255;LIGHTGUN&&(this.lightgunClick=!1);this.pause_button=!1},keydown:function(a){switch(a.keyCode){case 38:this.controller1&=~KEY_UP;break;case 40:this.controller1&=~KEY_DOWN;break;case 37:this.controller1&=~KEY_LEFT;break;case 39:this.controller1&=~KEY_RIGHT;break;case 88:this.controller1&=~KEY_FIRE1;break;case 90:this.controller1&=~KEY_FIRE2;break;case 13:this.main.is_sms?this.main.pause_button=!0:this.ggstart&=
-129;break;case 104:this.controller2&=~KEY_UP;break;case 98:this.controller2&=~KEY_DOWN;break;case 100:this.controller2&=~KEY_LEFT;break;case 102:this.controller2&=~KEY_RIGHT;break;case 103:this.controller2&=~KEY_FIRE1;break;case 105:this.controller2&=~KEY_FIRE2;break;case 97:this.controller2&=~KEY_START;break;default:return}a.preventDefault()},keyup:function(a){switch(a.keyCode){case 38:this.controller1|=KEY_UP;break;case 40:this.controller1|=KEY_DOWN;break;case 37:this.controller1|=KEY_LEFT;break;
case 39:this.controller1|=KEY_RIGHT;break;case 88:this.controller1|=KEY_FIRE1;break;case 90:this.controller1|=KEY_FIRE2;break;case 13:this.main.is_sms||(this.ggstart|=128);break;case 104:this.controller2|=KEY_UP;break;case 98:this.controller2|=KEY_DOWN;break;case 100:this.controller2|=KEY_LEFT;break;case 102:this.controller2|=KEY_RIGHT;break;case 103:this.controller2|=KEY_FIRE1;break;case 105:this.controller2|=KEY_FIRE2;break;case 97:this.controller2|=KEY_START;break;default:return}a.preventDefault()}};var SCALE=8,NO_ANTIALIAS=Number.MIN_VALUE,SHIFT_RESET=32768,FEEDBACK_PATTERN=9,PSG_VOLUME=[25,20,16,13,10,8,6,5,4,3,3,2,2,1,1,0],HI_BOUNDARY=127,LO_BOUNDARY=-128;JSSMS.SN76489=function(a){this.main=a;this.clockFrac=this.clock=0;this.reg=Array(8);this.regLatch=0;this.freqCounter=Array(4);this.freqPolarity=Array(4);this.freqPos=Array(3);this.noiseFreq=16;this.noiseShiftReg=SHIFT_RESET;this.outputChannel=Array(4)};
JSSMS.SN76489.prototype={init:function(a,b){this.clock=(a<<SCALE)/16/b;this.regLatch=this.clockFrac=0;this.noiseFreq=16;this.noiseShiftReg=SHIFT_RESET;for(var c=0;4>c;c++)this.reg[c<<1]=1,this.reg[(c<<1)+1]=15,this.freqCounter[c]=0,this.freqPolarity[c]=1,3!=c&&(this.freqPos[c]=NO_ANTIALIAS)},write:function(a){0!==(a&128)?(this.regLatch=a>>4&7,this.reg[this.regLatch]=this.reg[this.regLatch]&1008|a&15):this.reg[this.regLatch]=0===this.regLatch||2==this.regLatch||4==this.regLatch?this.reg[this.regLatch]&
15|(a&63)<<4:a&15;switch(this.regLatch){case 0:case 2:case 4:0===this.reg[this.regLatch]&&(this.reg[this.regLatch]=1);break;case 6:this.noiseFreq=16<<(this.reg[6]&3),this.noiseShiftReg=SHIFT_RESET}},update:function(a,b){for(var c=[],e=0,d=0;e<b;e++){for(d=0;3>d;d++)this.outputChannel[d]=this.freqPos[d]!=NO_ANTIALIAS?PSG_VOLUME[this.reg[(d<<1)+1]]*this.freqPos[d]>>SCALE:PSG_VOLUME[this.reg[(d<<1)+1]]*this.freqPolarity[d];this.outputChannel[3]=PSG_VOLUME[this.reg[7]]*(this.noiseShiftReg&1)<<1;d=this.outputChannel[0]+
this.outputChannel[1]+this.outputChannel[2]+this.outputChannel[3];d>HI_BOUNDARY?d=HI_BOUNDARY:d<LO_BOUNDARY&&(d=LO_BOUNDARY);c[a+e]=d;this.clockFrac+=this.clock;var g=this.clockFrac>>SCALE,h=g<<SCALE;this.clockFrac-=h;this.freqCounter[0]-=g;this.freqCounter[1]-=g;this.freqCounter[2]-=g;this.freqCounter[3]=128==this.noiseFreq?this.freqCounter[2]:this.freqCounter[3]-g;for(d=0;3>d;d++){var f=this.freqCounter[d];if(0>=f){var k=this.reg[d<<1];6<k?(this.freqPos[d]=(h-this.clockFrac+(2<<SCALE)*f<<SCALE)*
this.freqPolarity[d]/(h+this.clockFrac),this.freqPolarity[d]=-this.freqPolarity[d]):(this.freqPolarity[d]=1,this.freqPos[d]=NO_ANTIALIAS);this.freqCounter[d]+=k*(g/k+1)}else this.freqPos[d]=NO_ANTIALIAS}0>=this.freqCounter[3]&&(this.freqPolarity[3]=-this.freqPolarity[3],128!=this.noiseFreq&&(this.freqCounter[3]+=this.noiseFreq*(g/this.noiseFreq+1)),1==this.freqPolarity[3]&&(d=0,d=0!==(this.reg[6]&4)?0!==(this.noiseShiftReg&FEEDBACK_PATTERN)&&0!==(this.noiseShiftReg&FEEDBACK_PATTERN^FEEDBACK_PATTERN)?
1:0:this.noiseShiftReg&1,this.noiseShiftReg=this.noiseShiftReg>>1|d<<15))}return c}};var NTSC=0,PAL=1,SMS_X_PIXELS=342,SMS_Y_PIXELS_NTSC=262,SMS_Y_PIXELS_PAL=313,SMS_WIDTH=256,SMS_HEIGHT=192,GG_WIDTH=160,GG_HEIGHT=144,GG_X_OFFSET=48,GG_Y_OFFSET=24,STATUS_VINT=128,STATUS_OVERFLOW=64,STATUS_COLLISION=32,STATUS_HINT=4,BGT_LENGTH=1792,SPRITES_PER_LINE=8,SPRITE_COUNT=0,SPRITE_X=1,SPRITE_Y=2,SPRITE_N=3,TOTAL_TILES=512,TILE_SIZE=8;
JSSMS.Vdp=function(a){this.main=a;var b=0;this.videoMode=NTSC;this.VRAM=new JSSMS.Utils.Uint8Array(16384);this.CRAM=new JSSMS.Utils.Uint8Array(96);for(b=0;96>b;b++)this.CRAM[b]=255;this.vdpreg=new JSSMS.Utils.Uint8Array(16);this.status=0;this.firstByte=!1;this.counter=this.line=this.readBuffer=this.operation=this.location=this.commandByte=0;this.bgPriority=new JSSMS.Utils.Uint8Array(SMS_WIDTH);VDP_SPRITE_COLLISIONS&&(this.spriteCol=new JSSMS.Utils.Uint8Array(SMS_WIDTH));this.vScrollLatch=this.bgt=
0;this.display=a.ui.canvasImageData.data;this.main_JAVA_R=new JSSMS.Utils.Uint8Array(64);this.main_JAVA_G=new JSSMS.Utils.Uint8Array(64);this.main_JAVA_B=new JSSMS.Utils.Uint8Array(64);this.GG_JAVA_R=new JSSMS.Utils.Uint8Array(256);this.GG_JAVA_G=new JSSMS.Utils.Uint8Array(256);this.GG_JAVA_B=new JSSMS.Utils.Uint8Array(16);this.sat=this.h_end=this.h_start=0;this.isSatDirty=!1;this.lineSprites=Array(SMS_HEIGHT);for(b=0;b<SMS_HEIGHT;b++)this.lineSprites[b]=new JSSMS.Utils.Uint8Array(1+3*SPRITES_PER_LINE);
this.tiles=Array(TOTAL_TILES);this.isTileDirty=new JSSMS.Utils.Uint8Array(TOTAL_TILES);this.maxDirty=this.minDirty=0;this.createCachedImages();this.generateConvertedPals()};
JSSMS.Vdp.prototype={reset:function(){var a;this.firstByte=!0;for(a=this.operation=this.status=this.counter=this.location=0;16>a;a++)this.vdpreg[a]=0;this.vdpreg[2]=14;this.vdpreg[5]=126;this.vScrollLatch=0;this.main.cpu.interruptLine=!1;this.isSatDirty=!0;this.minDirty=TOTAL_TILES;this.maxDirty=-1;for(a=0;16384>a;a++)this.VRAM[a]=0;for(a=0;a<SMS_WIDTH*SMS_HEIGHT*4;a+=4)this.display[a]=0,this.display[a+1]=0,this.display[a+2]=0,this.display[a+3]=255},forceFullRedraw:function(){this.bgt=(this.vdpreg[2]&
14)<<10;this.minDirty=0;this.maxDirty=TOTAL_TILES-1;for(var a=0;a<TOTAL_TILES;a++)this.isTileDirty[a]=1;this.sat=(this.vdpreg[5]&-130)<<7;this.isSatDirty=!0},getVCount:function(){if(this.videoMode==NTSC){if(218<this.line)return this.line-6}else if(242<this.line)return this.line-57;return this.line},controlRead:function(){this.firstByte=!0;var a=this.status;this.status=0;this.main.cpu.interruptLine=!1;return a},controlWrite:function(a){if(this.firstByte)this.firstByte=!1,this.commandByte=a,this.location=
this.location&16128|a;else if(this.firstByte=!0,this.operation=a>>6&3,this.location=this.commandByte|a<<8,0===this.operation)this.readBuffer=this.VRAM[this.location++&16383]&255;else if(2==this.operation){a&=15;switch(a){case 0:ACCURATE_INTERRUPT_EMULATION&&0!==(this.status&STATUS_HINT)&&(this.main.cpu.interruptLine=0!==(this.commandByte&16));break;case 1:0!==(this.status&STATUS_VINT)&&0!==(this.commandByte&32)&&(this.main.cpu.interruptLine=!0);(this.commandByte&3)!=(this.vdpreg[a]&3)&&(this.isSatDirty=
!0);break;case 2:this.bgt=(this.commandByte&14)<<10;break;case 5:var b=this.sat;this.sat=(this.commandByte&-130)<<7;b!=this.sat&&(this.isSatDirty=!0)}this.vdpreg[a]=this.commandByte}},dataRead:function(){this.firstByte=!0;var a=this.readBuffer;this.readBuffer=this.VRAM[this.location++&16383]&255;return a},dataWrite:function(a){var b=0;this.firstByte=!0;switch(this.operation){case 0:case 1:case 2:b=this.location&16383;if(a!=(this.VRAM[b]&255)){if(b>=this.sat&&b<this.sat+64)this.isSatDirty=!0;else if(b>=
this.sat+128&&b<this.sat+256)this.isSatDirty=!0;else{var c=b>>5;this.isTileDirty[c]=1;c<this.minDirty&&(this.minDirty=c);c>this.maxDirty&&(this.maxDirty=c)}this.VRAM[b]=a}break;case 3:this.main.is_sms?(b=3*(this.location&31),this.CRAM[b]=this.main_JAVA_R[a],this.CRAM[b+1]=this.main_JAVA_G[a],this.CRAM[b+2]=this.main_JAVA_B[a]):(b=3*((this.location&63)>>1),0===(this.location&1)?(this.CRAM[b]=this.GG_JAVA_R[a],this.CRAM[b+1]=this.GG_JAVA_G[a]):this.CRAM[b+2]=this.GG_JAVA_B[a])}ACCURATE&&(this.readBuffer=
a);this.location++},interrupts:function(a){192>=a?(ACCURATE_INTERRUPT_EMULATION||192!=a||(this.status|=STATUS_VINT),0===this.counter?(this.counter=this.vdpreg[10],this.status|=STATUS_HINT):this.counter--,0!==(this.status&STATUS_HINT)&&0!==(this.vdpreg[0]&16)&&(this.main.cpu.interruptLine=!0)):(this.counter=this.vdpreg[10],0!==(this.status&STATUS_VINT)&&0!==(this.vdpreg[1]&32)&&224>a&&(this.main.cpu.interruptLine=!0),ACCURATE&&a==this.main.no_of_scanlines-1&&(this.vScrollLatch=this.vdpreg[9]))},setVBlankFlag:function(){this.status|=
STATUS_VINT},drawLine:function(a){var b=0,c=0,e=0;if(!this.main.is_gg||!(a<GG_Y_OFFSET||a>=GG_Y_OFFSET+GG_HEIGHT)){if(VDP_SPRITE_COLLISIONS)for(b=0;b<SMS_WIDTH;b++)this.spriteCol[b]=!1;if(0!==(this.vdpreg[1]&64)){if(-1!=this.maxDirty&&this.decodeTiles(),this.drawBg(a),this.isSatDirty&&this.decodeSat(),0!==this.lineSprites[a][SPRITE_COUNT]&&this.drawSprite(a),this.main.is_sms&&0!==(this.vdpreg[0]&32))for(c=4*(a<<8),e=3*((this.vdpreg[7]&15)+16),b=0;8>b;b++)this.display[c+b]=this.CRAM[e],this.display[c+
b+1]=this.CRAM[e+1],this.display[c+b+2]=this.CRAM[e+2]}else this.drawBGColour(a)}},drawBg:function(a){var b=0,c=0,e=0,d=0,g=this.vdpreg[8],h=ACCURATE?this.vScrollLatch:this.vdpreg[9];16>a&&0!==(this.vdpreg[0]&64)&&(g=0);var f=this.vdpreg[0]&128,k=32-(g>>3)+this.h_start,l=a+h>>3;27<l&&(l-=28);for(var h=(a+(h&7)&7)<<3,m=a<<8,p=this.h_start;p<this.h_end;p++){var b=this.bgt+((k&31)<<1)+(l<<6),q=this.VRAM[b+1],r=(q&8)<<1,s=(p<<3)+(g&7),t=0===(q&4)?h:56-h,u=this.tiles[(this.VRAM[b]&255)+((q&1)<<8)];if(0===
(q&2))for(b=0;8>b&&s<SMS_WIDTH;b++,s++)c=u[b+t],e=4*(s+m),d=3*(c+r),this.bgPriority[s]=0!==(q&16)&&0!==c,this.display[e]=this.CRAM[d],this.display[e+1]=this.CRAM[d+1],this.display[e+2]=this.CRAM[d+2];else for(b=7;0<=b&&s<SMS_WIDTH;b--,s++)c=u[b+t],e=4*(s+m),d=3*(c+r),this.bgPriority[s]=0!==(q&16)&&0!==c,this.display[e]=this.CRAM[d],this.display[e+1]=this.CRAM[d+1],this.display[e+2]=this.CRAM[d+2];k++;0!==f&&23==p&&(l=a>>3,h=(a&7)<<3)}},drawSprite:function(a){for(var b=0,c=0,e=0,d=0,g=this.lineSprites[a],
h=Math.min(SPRITES_PER_LINE,g[SPRITE_COUNT]),f=this.vdpreg[1]&1,k=a<<8,l=3*h;d<h;d++){var m=g[l--]|(this.vdpreg[6]&4)<<6,p=g[l--],q=g[l--]-(this.vdpreg[0]&8),b=a-p>>f;0!==(this.vdpreg[1]&2)&&(m&=-2);m=this.tiles[m+((b&8)>>3)];p=0;0>q&&(p=-q,q=0);var r=p+((b&7)<<3);if(0===f)for(;8>p&&q<SMS_WIDTH;p++,q++)b=m[r++],0===b||this.bgPriority[q]||(c=4*(q+k),e=3*(b+16),this.display[c]=this.CRAM[e],this.display[c+1]=this.CRAM[e+1],this.display[c+2]=this.CRAM[e+2],VDP_SPRITE_COLLISIONS&&(this.spriteCol[q]?this.status|=
STATUS_COLLISION:this.spriteCol[q]=!0));else for(;8>p&&q<SMS_WIDTH;p++,q+=2)b=m[r++],0===b||this.bgPriority[q]||(c=4*(q+k),e=3*(b+16),this.display[c]=this.CRAM[e],this.display[c+1]=this.CRAM[e+1],this.display[c+2]=this.CRAM[e+2],VDP_SPRITE_COLLISIONS&&(this.spriteCol[q]?this.status|=STATUS_COLLISION:this.spriteCol[q]=!0)),0===b||this.bgPriority[q+1]||(c=4*(q+k+1),e=3*(b+16),this.display[c]=this.CRAM[e],this.display[c+1]=this.CRAM[e+1],this.display[c+2]=this.CRAM[e+2],VDP_SPRITE_COLLISIONS&&(this.spriteCol[q+
1]?this.status|=STATUS_COLLISION:this.spriteCol[q+1]=!0))}g[SPRITE_COUNT]>=SPRITES_PER_LINE&&(this.status|=STATUS_OVERFLOW)},drawBGColour:function(a){a<<=8;var b=4*(a+4*SMS_WIDTH),c=3*((this.vdpreg[7]&15)+16);for(a*=4;a<b;a+=4)this.display[a]=this.CRAM[c],this.display[a+1]=this.CRAM[c+1],this.display[a+2]=this.CRAM[c+2]},decodeTiles:function(){for(var a=this.minDirty;a<=this.maxDirty;a++)if(this.isTileDirty[a]){this.isTileDirty[a]=0;for(var b=this.tiles[a],c=0,e=a<<5,d=0;d<TILE_SIZE;d++)for(var g=
this.VRAM[e++],h=this.VRAM[e++],f=this.VRAM[e++],k=this.VRAM[e++],l=128;0!==l;l>>=1){var m=0;0!==(g&l)&&(m|=1);0!==(h&l)&&(m|=2);0!==(f&l)&&(m|=4);0!==(k&l)&&(m|=8);b[c++]=m}}this.minDirty=TOTAL_TILES;this.maxDirty=-1},decodeSat:function(){this.isSatDirty=!1;for(var a=0;a<this.lineSprites.length;a++)this.lineSprites[a][SPRITE_COUNT]=0;a=0===(this.vdpreg[1]&2)?8:16;1==(this.vdpreg[1]&1)&&(a<<=1);for(var b=0;64>b;b++){var c=this.VRAM[this.sat+b]&255;if(208==c)break;c++;240<c&&(c-=256);for(var e=c;e<
SMS_HEIGHT;e++)if(e-c<a){var d=this.lineSprites[e];if(!d||d[SPRITE_COUNT]>=SPRITES_PER_LINE)break;var g=3*d[SPRITE_COUNT]+SPRITE_X,h=this.sat+(b<<1)+128;d[g++]=this.VRAM[h++]&255;d[g++]=c;d[g++]=this.VRAM[h]&255;d[SPRITE_COUNT]++}}},createCachedImages:function(){for(var a=0;a<TOTAL_TILES;a++)this.tiles[a]=new JSSMS.Utils.Uint8Array(TILE_SIZE*TILE_SIZE)},generateConvertedPals:function(){var a,b,c,e;for(a=0;64>a;a++)b=a&3,c=a>>2&3,e=a>>4&3,this.main_JAVA_R[a]=85*b&255,this.main_JAVA_G[a]=85*c&255,this.main_JAVA_B[a]=
85*e&255;for(a=0;256>a;a++)c=a&15,e=a>>4&15,this.GG_JAVA_R[a]=(c<<4|c)&255,this.GG_JAVA_G[a]=(e<<4|e)&255;for(a=0;16>a;a++)this.GG_JAVA_B[a]=(a<<4|a)&255},getState:function(){var a=Array(51);a[0]=this.videoMode|this.status<<8|(this.firstByte?65536:0)|this.commandByte<<24;a[1]=this.location|this.operation<<16|this.readBuffer<<24;a[2]=this.counter|this.vScrollLatch<<8|this.line<<16;JSSMS.Utils.copyArrayElements(this.vdpreg,0,a,3,16);JSSMS.Utils.copyArrayElements(this.CRAM,0,a,19,96);return a},setState:function(a){var b=
a[0];this.videoMode=b&255;this.status=b>>8&255;this.firstByte=0!==(b>>16&255);this.commandByte=b>>24&255;b=a[1];this.location=b&65535;this.operation=b>>16&255;this.readBuffer=b>>24&255;b=a[2];this.counter=b&255;this.vScrollLatch=b>>8&255;this.line=b>>16&65535;JSSMS.Utils.copyArrayElements(a,3,this.vdpreg,0,16);JSSMS.Utils.copyArrayElements(a,19,this.CRAM,0,96);this.forceFullRedraw()}};JSSMS.DummyUI=function(a){this.main=a;this.reset=function(){};this.updateStatus=function(){};this.writeFrame=function(){};this.updateDisassembly=function(){};this.canvasImageData={data:[]}};
window.$&&($.fn.JSSMSUI=function(a){var b=this,c=function(e){function c(a){return function(b){h.main.keyboard.controller1&=~a;b.preventDefault()}}function g(a){return function(b){h.main.keyboard.controller1|=a;b.preventDefault()}}this.main=e;if("[object OperaMini]"==Object.prototype.toString.call(window.operamini))$(b).html('<div class="alert alert-error"><strong>Oh no!</strong> Your browser can\'t run this emulator. Try the latest version of Firefox, Google Chrome, Opera or Safari!</div>');else{var h=
this;e=$("<div></div>");var f=$('<div id="screen"></div>'),k=$('<div class="gamepad"><div class="direction"><div class="up"></div><div class="right"></div><div class="left"></div><div class="down"></div></div><div class="buttons"><div class="start"></div><div class="fire1"></div><div class="fire2"></div></div></div>'),l=$('<div id="controls"></div>'),m=JSSMS.Utils.getPrefix(["fullscreenEnabled","mozFullScreenEnabled","webkitCancelFullScreen"]),p=JSSMS.Utils.getPrefix(["requestAnimationFrame","msRequestAnimationFrame",
"mozRequestAnimationFrame","webkitRequestAnimationFrame"],window),q;if(p)this.requestAnimationFrame=window[p].bind(window);else{var r=0;this.requestAnimationFrame=function(a){var b=JSSMS.Utils.getTimestamp(),b=Math.max(0,1E3/60-(b-r));window.setTimeout(function(){r=JSSMS.Utils.getTimestamp();a()},b)}}this.screen=$("<canvas width="+SMS_WIDTH+" height="+SMS_HEIGHT+" moz-opaque></canvas>");this.canvasContext=this.screen[0].getContext("2d");this.canvasContext.webkitImageSmoothingEnabled=!1;this.canvasContext.mozImageSmoothingEnabled=
!1;this.canvasContext.imageSmoothingEnabled=!1;if(this.canvasContext.getImageData){this.canvasImageData=this.canvasContext.getImageData(0,0,SMS_WIDTH,SMS_HEIGHT);this.gamepad={u:{e:$(".up",k),k:KEY_UP},r:{e:$(".right",k),k:KEY_RIGHT},d:{e:$(".down",k),k:KEY_DOWN},l:{e:$(".left",k),k:KEY_LEFT},1:{e:$(".fire1",k),k:KEY_FIRE1},2:{e:$(".fire2",k),k:KEY_FIRE2}};p=$(".start",k);this.romContainer=$('<div id="romSelector"></div>');this.romSelect=$("<select></select>").change(function(){h.loadROM()});this.buttons=
Object.create(null);this.buttons.start=$('<input type="button" value="Start" class="btn btn-primary" disabled="disabled">').click(function(){h.main.isRunning?(h.main.stop(),h.updateStatus("Paused"),h.buttons.start.attr("value","Start")):(h.main.start(),h.buttons.start.attr("value","Pause"))});this.buttons.reset=$('<input type="button" value="Reset" class="btn" disabled="disabled">').click(function(){h.main.reloadRom()?(h.main.reset(),h.main.vdp.forceFullRedraw(),h.main.start()):$(this).attr("disabled",
"disabled")});ENABLE_DEBUGGER&&(this.dissambler=$('<div id="dissambler"></div>'),$(b).after(this.dissambler),this.buttons.nextStep=$('<input type="button" value="Next step" class="btn" disabled="disabled">').click(function(){h.main.nextStep()}));this.main.soundEnabled&&(this.buttons.sound=$('<input type="button" value="Enable sound" class="btn" disabled="disabled">').click(function(){h.main.soundEnabled?(h.main.soundEnabled=!1,h.buttons.sound.attr("value","Enable sound")):(h.main.soundEnabled=!0,
h.buttons.sound.attr("value","Disable sound"))}));m?this.buttons.fullscreen=$('<input type="button" value="Go fullscreen" class="btn">').click(function(){var a=f[0];a.requestFullscreen?a.requestFullscreen():a.mozRequestFullScreen?a.mozRequestFullScreen():a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT)}):(this.zoomed=!1,this.buttons.zoom=$('<input type="button" value="Zoom in" class="btn hidden-phone">').click(function(){h.zoomed?(h.screen.animate({width:SMS_WIDTH+"px",height:SMS_HEIGHT+"px"},
function(){$(this).removeAttr("style")}),h.buttons.zoom.attr("value","Zoom in")):(h.screen.animate({width:2*SMS_WIDTH+"px",height:2*SMS_HEIGHT+"px"}),h.buttons.zoom.attr("value","Zoom out"));h.zoomed=!h.zoomed}));for(q in this.buttons)this.buttons[q].appendTo(l);this.log=$('<div id="status"></div>');this.screen.appendTo(f);k.appendTo(f);f.appendTo(e);this.romContainer.appendTo(e);l.appendTo(e);this.log.appendTo(e);e.appendTo($(b));void 0!==a&&this.setRoms(a);$(document).bind("keydown",function(a){h.main.keyboard.keydown(a)}).bind("keyup",
function(a){h.main.keyboard.keyup(a)});for(q in this.gamepad)this.gamepad[q].e.on("mousedown touchstart",c(this.gamepad[q].k)).on("mouseup touchend",g(this.gamepad[q].k));p.on("mousedown touchstart",function(a){h.main.is_sms?h.main.pause_button=!0:h.main.keyboard.ggstart&=-129;a.preventDefault()}).on("mouseup touchend",function(a){h.main.is_sms||(h.main.keyboard.ggstart|=128);a.preventDefault()})}else $(b).html('<div class="alert alert-error"><strong>Oh no!</strong> Your browser doesn\'t support writing pixels directly to the <code>&lt;canvas&gt;</code> tag. Try the latest version of Firefox, Google Chrome, Opera or Safari!</div>')}};
c.prototype={reset:function(){this.screen[0].width=SMS_WIDTH;this.screen[0].height=SMS_HEIGHT;this.log.empty();ENABLE_DEBUGGER&&this.dissambler.empty()},setRoms:function(a){var b,c,h,f,k=0;this.romSelect.children().remove();$("<option>Select a ROM...</option>").appendTo(this.romSelect);for(b in a){if(a.hasOwnProperty(b)){c=$("<optgroup></optgroup>").attr("label",b);h=a[b].length;for(f=0;f<h;f++)$("<option>"+a[b][f][0]+"</option>").attr("value",a[b][f][1]).appendTo(c);c.appendTo(this.romSelect)}k++}k&&
this.romSelect.appendTo(this.romContainer)},loadROM:function(){var a=this;this.updateStatus("Downloading...");$.ajax({url:encodeURI(this.romSelect.val()),xhr:function(){var b=$.ajaxSettings.xhr();void 0!==b.overrideMimeType&&b.overrideMimeType("text/plain; charset=x-user-defined");return a.xhr=b},complete:function(b,c){var h;"error"==c?a.updateStatus("The selected ROM file could not be loaded."):(h=b.responseText,a.main.stop(),a.main.readRomDirectly(h,a.romSelect.val()),a.main.reset(),a.main.vdp.forceFullRedraw(),
a.enable())}})},enable:function(){this.buttons.start.removeAttr("disabled");this.buttons.start.attr("value","Start");this.buttons.reset.removeAttr("disabled");ENABLE_DEBUGGER&&this.buttons.nextStep.removeAttr("disabled");this.main.soundEnabled&&(this.buttons.sound?this.buttons.sound.attr("value","Disable sound"):this.buttons.sound.attr("value","Enable sound"))},updateStatus:function(a){this.log.text(a)},writeAudio:function(a){},writeFrame:function(){var a=JSSMS.Utils.getPrefix(["hidden","mozHidden",
"webkitHidden","msHidden"]);return a?function(){document[a]||this.canvasContext.putImageData(this.canvasImageData,0,0)}:function(){this.canvasContext.putImageData(this.canvasImageData,0,0)}}(),updateDisassembly:function(a){for(var b=this.main.cpu.instructions,c=b.length,h="",f=8>a?0:a-8,k=0;16>k&&f<=c;f++)b[f]&&(h+="<div"+(b[f].address==a?' class="current"':"")+">"+b[f].hexAddress+(b[f].isJumpTarget?":":" ")+"<code>"+b[f].inst+"</code></div>",k++);this.dissambler.html(h)}};return c});var IO_TR_DIRECTION=0,IO_TH_DIRECTION=1,IO_TR_OUTPUT=2,IO_TH_OUTPUT=3,IO_TH_INPUT=4,PORT_A=0,PORT_B=5;JSSMS.Ports=function(a){this.main=a;this.vdp=a.vdp;this.psg=a.psg;this.keyboard=a.keyboard;this.europe=64;this.hCounter=0;this.ioPorts=[]};
JSSMS.Ports.prototype={reset:function(){LIGHTGUN?(this.ioPorts=Array(10),this.ioPorts[PORT_A+IO_TH_INPUT]=1,this.ioPorts[PORT_B+IO_TH_INPUT]=1):this.ioPorts=Array(2)},out:function(a,b){if(!(this.main.is_gg&&7>a))switch(a&193){case 1:LIGHTGUN?(this.oldTH=0!==this.getTH(PORT_A)||0!==this.getTH(PORT_B),this.writePort(PORT_A,b),this.writePort(PORT_B,b>>2),this.oldTH||0===this.getTH(PORT_A)&&0===this.getTH(PORT_B)||(this.hCounter=this.getHCount())):(this.ioPorts[0]=(b&32)<<1,this.ioPorts[1]=b&128,0===
this.europe&&(this.ioPorts[0]=~this.ioPorts[0],this.ioPorts[1]=~this.ioPorts[1]));break;case 128:this.vdp.dataWrite(b);break;case 129:this.vdp.controlWrite(b);break;case 64:case 65:this.main.soundEnabled&&this.psg.write(b)}},in_:function(a){if(this.main.is_gg&&7>a)switch(a){case 0:return this.keyboard.ggstart&191|this.europe;case 1:case 2:case 3:case 4:case 5:return 0;case 6:return 255}switch(a&193){case 64:return this.vdp.getVCount();case 65:return this.hCounter;case 128:return this.vdp.dataRead();
case 129:return this.vdp.controlRead();case 192:return this.keyboard.controller1;case 193:return LIGHTGUN?(this.keyboard.lightgunClick&&this.lightPhaserSync(),this.keyboard.controller2&63|(0!==this.getTH(PORT_A)?64:0)|(0!==this.getTH(PORT_B)?128:0)):this.keyboard.controller2&63|this.ioPorts[0]|this.ioPorts[1]}return 255},writePort:function(a,b){this.ioPorts[a+IO_TR_DIRECTION]=b&1;this.ioPorts[a+IO_TH_DIRECTION]=b&2;this.ioPorts[a+IO_TR_OUTPUT]=b&16;this.ioPorts[a+IO_TH_OUTPUT]=0===this.europe?~b&
32:b&32},getTH:function(a){return 0===this.ioPorts[a+IO_TH_DIRECTION]?this.ioPorts[a+IO_TH_OUTPUT]:this.ioPorts[a+IO_TH_INPUT]},setTH:function(a,b){this.ioPorts[a+IO_TH_DIRECTION]=1;this.ioPorts[a+IO_TH_INPUT]=b?1:0},getHCount:function(){var a=Math.round(this.main.cpu.getCycle()*SMS_X_PIXELS/this.main.cyclesPerLine)-8>>1;147<a&&(a+=85);return a&255},X_RANGE:48,Y_RANGE:4,lightPhaserSync:function(){var a=this.getTH(PORT_A),b=this.getHCount(),c=this.keyboard.lightgunX-(b<<1),e=this.keyboard.lightgunY-
this.vdp.line;e>-this.Y_RANGE&&e<this.Y_RANGE&&c>-this.X_RANGE&&c<this.X_RANGE?(this.setTH(PORT_A,!1),a!=this.getTH(PORT_A)&&(this.hCounter=20+(this.keyboard.lightgunX>>1))):(this.setTH(PORT_A,!0),a!=this.getTH(PORT_A)&&(this.hCounter=b))},setDomestic:function(a){this.europe=a?64:0},isDomestic:function(){return 0!==this.europe}};var Bytecode=function(){function a(a,b){this.address=a;this.page=b;this.opcode=[];this.target=this.nextAddress=this.operand=null;this.isJumpTarget=this.canEnd=this.isFunctionEnder=!1;this.jumpTargetNb=0;this.ast=null}var b=JSSMS.Utils.toHex;a.prototype={get hexOpcode(){return this.opcode.length?this.opcode.map(b).join(" "):""},get label(){var a=this.name?this.name.replace(/(nn|n|PC\+e|d)/,b(this.target||this.operand||0)):"";return b(this.address+this.page*PAGE_SIZE)+" "+this.hexOpcode+" "+a}};return a}();var Parser=function(){function a(a,c){c.page=a.page;c.seek(a.address+16384*c.page);var d=c.getUint8(),k=null,l=null,m=!1,p=!1;a.opcode.push(d);switch(d){case 0:break;case 1:k=c.getUint16();break;case 2:break;case 3:break;case 4:break;case 5:break;case 6:k=c.getUint8();break;case 7:break;case 8:break;case 9:break;case 10:break;case 11:break;case 12:break;case 13:break;case 14:k=c.getUint8();break;case 15:break;case 16:l=c.position+c.getInt8();p=!0;break;case 17:k=c.getUint16();break;case 18:break;
case 19:break;case 20:break;case 21:break;case 22:k=c.getUint8();break;case 23:break;case 24:l=c.position+c.getInt8();c.seek(null);m=!0;break;case 25:break;case 26:break;case 27:break;case 28:break;case 29:break;case 30:k=c.getUint8();break;case 31:break;case 32:l=c.position+c.getInt8();p=!0;break;case 33:k=c.getUint16();break;case 34:k=c.getUint16();break;case 35:break;case 36:break;case 37:break;case 38:k=c.getUint8();break;case 39:break;case 40:l=c.position+c.getInt8();p=!0;break;case 41:break;
case 42:k=c.getUint16();break;case 43:break;case 44:break;case 45:break;case 46:k=c.getUint8();break;case 47:break;case 48:l=c.position+c.getInt8();p=!0;break;case 49:k=c.getUint16();break;case 50:k=c.getUint16();break;case 51:break;case 52:break;case 53:break;case 54:k=c.getUint8();break;case 55:break;case 56:l=c.position+c.getInt8();p=!0;break;case 57:break;case 58:k=c.getUint16();break;case 59:break;case 60:break;case 61:break;case 62:k=c.getUint8();break;case 63:break;case 64:break;case 65:break;
case 66:break;case 67:break;case 68:break;case 69:break;case 70:break;case 71:break;case 72:break;case 73:break;case 74:break;case 75:break;case 76:break;case 77:break;case 78:break;case 79:break;case 80:break;case 81:break;case 82:break;case 83:break;case 84:break;case 85:break;case 86:break;case 87:break;case 88:break;case 89:break;case 90:break;case 91:break;case 92:break;case 93:break;case 94:break;case 95:break;case 96:break;case 97:break;case 98:break;case 99:break;case 100:break;case 101:break;
case 102:break;case 103:break;case 104:break;case 105:break;case 106:break;case 107:break;case 108:break;case 109:break;case 110:break;case 111:break;case 112:break;case 113:break;case 114:break;case 115:break;case 116:break;case 117:break;case 118:m=!0;break;case 119:break;case 120:break;case 121:break;case 122:break;case 123:break;case 124:break;case 125:break;case 126:break;case 127:break;case 128:break;case 129:break;case 130:break;case 131:break;case 132:break;case 133:break;case 134:break;case 135:break;
case 136:break;case 137:break;case 138:break;case 139:break;case 140:break;case 141:break;case 142:break;case 143:break;case 144:break;case 145:break;case 146:break;case 147:break;case 148:break;case 149:break;case 150:break;case 151:break;case 152:break;case 153:break;case 154:break;case 155:break;case 156:break;case 157:break;case 158:break;case 159:break;case 160:break;case 161:break;case 162:break;case 163:break;case 164:break;case 165:break;case 166:break;case 167:break;case 168:break;case 169:break;
case 170:break;case 171:break;case 172:break;case 173:break;case 174:break;case 175:break;case 176:break;case 177:break;case 178:break;case 179:break;case 180:break;case 181:break;case 182:break;case 183:break;case 184:break;case 185:break;case 186:break;case 187:break;case 188:break;case 189:break;case 190:break;case 191:break;case 192:p=!0;break;case 193:break;case 194:l=c.getUint16();p=!0;break;case 195:l=c.getUint16();c.seek(null);m=!0;break;case 196:l=c.getUint16();p=!0;break;case 197:break;
case 198:k=c.getUint8();break;case 199:l=0;m=!0;break;case 200:p=!0;break;case 201:c.seek(null);m=!0;break;case 202:l=c.getUint16();p=!0;break;case 203:return d=c.getUint8(),a.opcode.push(d),a.nextAddress=c.position,a;case 204:l=c.getUint16();p=!0;break;case 205:l=c.getUint16();m=!0;break;case 206:k=c.getUint8();break;case 207:l=8;m=!0;break;case 208:p=!0;break;case 209:break;case 210:l=c.getUint16();p=!0;break;case 211:k=c.getUint8();break;case 212:l=c.getUint16();p=!0;break;case 213:break;case 214:k=
c.getUint8();break;case 215:l=16;m=!0;break;case 216:p=!0;break;case 217:break;case 218:l=c.getUint16();p=!0;break;case 219:k=c.getUint8();break;case 220:l=c.getUint16();p=!0;break;case 221:return b(a,c);case 222:k=c.getUint8();break;case 223:l=24;m=!0;break;case 224:p=!0;break;case 225:break;case 226:l=c.getUint16();p=!0;break;case 227:break;case 228:l=c.getUint16();p=!0;break;case 229:break;case 230:k=c.getUint8();break;case 231:l=32;m=!0;break;case 232:p=!0;break;case 233:c.seek(null);m=!0;break;
case 234:l=c.getUint16();p=!0;break;case 235:break;case 236:l=c.getUint16();p=!0;break;case 237:d=c.getUint8();l=k=null;p=m=!1;a.opcode.push(d);switch(d){case 64:break;case 65:break;case 66:break;case 67:k=c.getUint16();break;case 68:case 76:case 84:case 92:case 100:case 108:case 116:case 124:break;case 69:case 77:case 85:case 93:case 101:case 109:case 117:case 125:c.seek(null);m=!0;break;case 70:case 78:case 102:case 110:break;case 71:break;case 72:break;case 73:break;case 74:break;case 75:k=c.getUint16();
break;case 79:break;case 80:break;case 81:break;case 82:break;case 83:k=c.getUint16();break;case 86:case 118:break;case 87:break;case 88:break;case 89:break;case 90:break;case 91:k=c.getUint16();break;case 95:break;case 96:break;case 97:break;case 98:break;case 99:k=c.getUint16();break;case 103:break;case 104:break;case 105:break;case 106:break;case 107:k=c.getUint16();break;case 111:break;case 113:break;case 114:break;case 115:k=c.getUint16();break;case 120:break;case 121:break;case 122:break;case 123:k=
c.getUint16();break;case 160:break;case 161:break;case 162:break;case 163:break;case 168:break;case 169:break;case 170:break;case 171:break;case 176:l=c.position-2;p=!0;break;case 177:l=c.position-2;p=!0;break;case 178:l=c.position-2;p=!0;break;case 179:l=c.position-2;p=!0;break;case 184:break;case 185:break;case 186:l=c.position-2;p=!0;break;case 187:l=c.position-2;p=!0;break;default:JSSMS.Utils.console.error("Unexpected opcode","0xED "+e(d))}a.nextAddress=c.position;a.operand=k;a.target=l;a.isFunctionEnder=
m;a.canEnd=p;return a;case 238:k=c.getUint8();break;case 239:l=40;m=!0;break;case 240:p=!0;break;case 241:break;case 242:l=c.getUint16();p=!0;break;case 243:break;case 244:l=c.getUint16();p=!0;break;case 245:break;case 246:k=c.getUint8();break;case 247:l=48;m=!0;break;case 248:p=!0;break;case 249:break;case 250:l=c.getUint16();p=!0;break;case 251:break;case 252:l=c.getUint16();p=!0;break;case 253:return b(a,c);case 254:k=c.getUint8();break;case 255:l=56;m=!0;break;default:JSSMS.Utils.console.error("Unexpected opcode",
e(d))}a.nextAddress=c.position;a.operand=k;a.target=l;a.isFunctionEnder=m;a.canEnd=p;return a}function b(a,b){var c=b.getUint8(),d=null,l=!1;a.opcode.push(c);switch(c){case 9:break;case 25:break;case 33:d=b.getUint16();break;case 34:d=b.getUint16();break;case 35:break;case 36:break;case 37:break;case 38:d=b.getUint8();break;case 41:break;case 42:d=b.getUint16();break;case 43:break;case 44:break;case 45:break;case 46:d=b.getUint8();break;case 52:d=b.getUint8();break;case 53:d=b.getUint8();break;case 54:d=
b.getUint16();break;case 57:break;case 68:break;case 69:break;case 70:d=b.getUint8();break;case 76:break;case 77:break;case 78:d=b.getUint8();break;case 84:break;case 85:break;case 86:d=b.getUint8();break;case 92:break;case 93:break;case 94:d=b.getUint8();break;case 96:break;case 97:break;case 98:break;case 99:break;case 100:break;case 101:break;case 102:d=b.getUint8();break;case 103:break;case 104:break;case 105:break;case 106:break;case 107:break;case 108:break;case 109:break;case 110:d=b.getUint8();
break;case 111:break;case 112:d=b.getUint8();break;case 113:d=b.getUint8();break;case 114:d=b.getUint8();break;case 115:d=b.getUint8();break;case 116:d=b.getUint8();break;case 117:d=b.getUint8();break;case 119:d=b.getUint8();break;case 124:break;case 125:break;case 126:d=b.getUint8();break;case 132:break;case 133:break;case 134:d=b.getUint8();break;case 140:break;case 141:break;case 142:d=b.getUint8();break;case 148:break;case 149:break;case 150:d=b.getUint8();break;case 156:break;case 157:break;
case 158:d=b.getUint8();break;case 164:break;case 165:break;case 166:d=b.getUint8();break;case 172:break;case 173:break;case 174:d=b.getUint8();break;case 180:break;case 181:break;case 182:d=b.getUint8();break;case 188:break;case 189:break;case 190:d=b.getUint8();break;case 203:return c=b.getUint8(),d=b.getUint8(),a.opcode.push(d),a.nextAddress=b.position,a.operand=c,a;case 225:break;case 227:break;case 229:break;case 233:b.seek(null);l=!0;break;case 249:break;default:JSSMS.Utils.console.error("Unexpected opcode",
"0xDD/0xFD "+e(c))}a.nextAddress=b.position;a.operand=d;a.isFunctionEnder=l;return a}function c(a){this.rom=a;this.pos=null;this.page=0}var e=JSSMS.Utils.toHex,d=function(a,b){this.stream=new c(a);this.frameReg=b;this.addresses=Array(a.length);this.entryPoints=[];this.bytecodes=Array(a.length);for(var d=0;d<a.length;d++)this.addresses[d]=[],this.bytecodes[d]=[]};d.prototype={addEntryPoint:function(a){this.entryPoints.push(a);this.addAddress(a.address)},parse:function(b){JSSMS.Utils.console.time("Parsing");
var c,d;void 0===b?(c=0,d=this.stream.length-1):(c=0,d=16383);for(b=0;b<this.addresses.length;b++)for(;this.addresses[b].length;){var k=this.addresses[b].shift().address%16384;if(k<c||k>d)JSSMS.Utils.console.error("Address out of bound",e(k));else if(!this.bytecodes[b][k]){var l=new Bytecode(k,b);this.bytecodes[b][k]=a(l,this.stream);null!==this.bytecodes[b][k].nextAddress&&this.bytecodes[b][k].nextAddress>=c&&this.bytecodes[b][k].nextAddress<=d&&this.addAddress(this.bytecodes[b][k].nextAddress);
null!==this.bytecodes[b][k].target&&this.bytecodes[b][k].target>=c&&this.bytecodes[b][k].target<=d&&this.addAddress(this.bytecodes[b][k].target)}}this.bytecodes[0][1023]?this.bytecodes[0][1023].isFunctionEnder=!0:this.bytecodes[0][1022]&&(this.bytecodes[0][1022].isFunctionEnder=!0);c=d=c=0;for(d=this.entryPoints.length;c<d;c++)b=this.entryPoints[c].address,k=this.entryPoints[c].romPage,this.bytecodes[k][b].isJumpTarget=!0,this.bytecodes[k][b].jumpTargetNb++;for(b=0;b<this.bytecodes.length;b++)for(c=
0,d=this.bytecodes[b].length;c<d;c++)this.bytecodes[b][c]&&(null!==this.bytecodes[b][c].nextAddress&&this.bytecodes[b][this.bytecodes[b][c].nextAddress]&&this.bytecodes[b][this.bytecodes[b][c].nextAddress].jumpTargetNb++,null!==this.bytecodes[b][c].target&&(k=~~(this.bytecodes[b][c].target/16384),l=this.bytecodes[b][c].target%16384,this.bytecodes[k]&&this.bytecodes[k][l]?(this.bytecodes[k][l].isJumpTarget=!0,this.bytecodes[k][l].jumpTargetNb++):JSSMS.Utils.console.log("Invalid target address",e(this.bytecodes[b][c].target))));
JSSMS.Utils.console.timeEnd("Parsing")},parseFromAddress:function(b){var c=b.address%16384;b=b.romPage;var d=16384*b,e=16384*(b+1),l=[],m,p=!0,q=0;1024>c&&0===b&&(d=0,e=1024);do{this.bytecodes[b][c]?m=this.bytecodes[b][c]:(m=new Bytecode(c,b),this.bytecodes[b][c]=a(m,this.stream));if(m.canEnd&&!p)break;c=m.nextAddress%16384;l.push(m);p=!1;q=c+16384*b}while(null!==c&&q>=d&&q<e&&!m.isFunctionEnder);return l},writeGraphViz:function(){JSSMS.Utils.console.time("DOT generation");for(var a=this.bytecodes,
b=["digraph G {"],c=0,d=a.length;c<d;c++)a[c]&&(b.push(" "+c+' [label="'+a[c].label+'"];'),null!==a[c].target&&b.push(" "+c+" -> "+a[c].target+";"),null!==a[c].nextAddress&&b.push(" "+c+" -> "+a[c].nextAddress+";"));b.push("}");b=b.join("\n");b=b.replace(/ 0 \[label="/,' 0 [style=filled,color="#CC0000",label="');JSSMS.Utils.console.timeEnd("DOT generation");return b},addAddress:function(a){var b=~~(a/16384),c=this.frameReg[b];this.addresses[c].push({address:a%16384,romPage:c,memPage:b})}};c.prototype=
{get position(){return this.pos},get length(){return this.rom.length*PAGE_SIZE},seek:function(a){this.pos=a},getUint8:function(){var a=0,a=this.page,b=this.pos&16383,a=SUPPORT_DATAVIEW?this.rom[a].getUint8(b):this.rom[a][b]&255;this.pos++;return a},getInt8:function(){var a=0,a=this.page,b=this.pos&16383;SUPPORT_DATAVIEW?a=this.rom[a].getInt8(b):(a=this.rom[a][b]&255,128<=a&&(a-=256));this.pos++;return a+1},getUint16:function(){var a=0,a=this.page,b=this.pos&16383,a=SUPPORT_DATAVIEW?16383>(b&16383)?
this.rom[a].getUint16(b,LITTLE_ENDIAN):this.rom[a].getUint8(b)|this.rom[++a].getUint8(b)<<8:this.rom[a][b]&255|(this.rom[++a][b]&255)<<8;this.pos+=2;return a}};return d}();var BIT_TABLE=[1,2,4,8,16,32,64,128],n={IfStatement:function(a,b,c){void 0===c&&(c=null);return{type:"IfStatement",test:a,consequent:b,alternate:c}},BlockStatement:function(a){void 0===a&&(a=[]);Array.isArray(a)||(a=[a]);return{type:"BlockStatement",body:a}},ExpressionStatement:function(a){return{type:"ExpressionStatement",expression:a}},ReturnStatement:function(a){void 0===a&&(a=null);return{type:"ReturnStatement",argument:a}},VariableDeclaration:function(a,b){return{type:"VariableDeclaration",declarations:[{type:"VariableDeclarator",
id:{type:"Identifier",name:a},init:b}],kind:"var"}},Identifier:function(a){return{type:"Identifier",name:a}},Literal:function(a){return"number"==typeof a?{type:"Literal",value:a,raw:DEBUG?JSSMS.Utils.toHex(a):""+a}:{type:"Literal",value:a,raw:""+a}},CallExpression:function(a,b){void 0===b&&(b=[]);Array.isArray(b)||(b=[b]);return{type:"CallExpression",callee:n.Identifier(a),arguments:b}},AssignmentExpression:function(a,b,c){return{type:"AssignmentExpression",operator:a,left:b,right:c}},BinaryExpression:function(a,
b,c){return{type:"BinaryExpression",operator:a,left:b,right:c}},UnaryExpression:function(a,b){return{type:"UnaryExpression",operator:a,argument:b}},MemberExpression:function(a,b){return{type:"MemberExpression",computed:!0,object:a,property:b}},ArrayExpression:function(a){return{type:"ArrayExpression",elements:a}},ConditionalExpression:function(a,b,c){return{type:"ConditionalExpression",test:a,consequent:b,alternate:c}},LogicalExpression:function(a,b,c){return{type:"LogicalExpression",operator:a,left:b,
right:c}},Register:function(a){return{type:"Register",name:a}},Bit:function(a){return n.Literal(BIT_TABLE[a])}},o={SET16:function(a,b,c){return"Literal"==c.type?[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.BinaryExpression(">>",c,n.Literal(8)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.BinaryExpression("&",c,n.Literal(255))))]:[n.VariableDeclaration("val",c),n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.BinaryExpression(">>",n.Identifier("val"),
n.Literal(8)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.BinaryExpression("&",n.Identifier("val"),n.Literal(255))))]},EX:function(a,b){return SUPPORT_DESTRUCTURING?[n.ExpressionStatement(n.AssignmentExpression("=",n.ArrayExpression([n.Register(a),n.Register(b)]),n.ArrayExpression([n.Register(b),n.Register(a)])))]:[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.Register(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.Register(b))),
n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.Identifier("temp")))]},NOOP:function(){return function(){}},LD8:function(a,b,c){return void 0===b&&void 0===c?function(b){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.Literal(b)))}:"i"==b&&void 0===c?function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.Register("i"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",
n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.MemberExpression(n.Identifier("SZ_TABLE"),n.Register(a))),n.ConditionalExpression(n.Identifier("iff2"),n.Literal(F_PARITY),n.Literal(0)))))]}:"r"==b&&void 0===c?function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),REFRESH_EMULATION?n.Register("r"):n.CallExpression("JSSMS.Utils.rndInt",n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",
n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.MemberExpression(n.Identifier("SZ_TABLE"),n.Register(a))),n.ConditionalExpression(n.Identifier("iff2"),n.Literal(F_PARITY),n.Literal(0)))))]}:void 0===c?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.Register(b)))}:"n"==b&&"n"==c?function(b){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),o.READ_MEM8(n.Literal(b))))}:function(){return n.ExpressionStatement(n.AssignmentExpression("=",
n.Register(a),o.READ_MEM8(n.CallExpression("get"+(b+c).toUpperCase()))))}},LD8_D:function(a,b,c){return function(e){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(e)))))}},LD16:function(a,b,c,e){if(void 0===c&&void 0===e)return function(c){return o.SET16(a,b,n.Literal(c))};if("n"==c&&"n"==e)return function(c){return o.SET16(a,b,o.READ_MEM16(n.Literal(c)))};JSSMS.Utils.console.error("Wrong parameters number")},
LD_WRITE_MEM:function(a,b,c,e){return void 0===c&&void 0===e?function(c){return n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c)]))}:"n"==a&&"n"==b&&void 0===e?function(a){return n.ExpressionStatement(n.CallExpression("writeMem",[n.Literal(a),n.Register(c)]))}:"n"==a&&"n"==b?function(a){return[n.ExpressionStatement(n.CallExpression("writeMem",[n.Literal(a),n.Register(e)])),n.ExpressionStatement(n.CallExpression("writeMem",[n.Literal(a+1),
n.Register(c)]))]}:function(){return n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("get"+(a+b).toUpperCase()),n.Register(c)]))}},LD_SP:function(a,b){return void 0===a&&void 0===b?function(a){return n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("sp"),n.Literal(a)))}:function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("sp"),n.CallExpression("get"+(a+b).toUpperCase())))}},LD_NN:function(a,b){return void 0===b?function(b){return[n.ExpressionStatement(n.CallExpression("writeMem",
n.Literal(b),n.BinaryExpression("&",n.Identifier(a),n.Literal(255)))),n.ExpressionStatement(n.CallExpression("writeMem",n.Literal(b+1),n.BinaryExpression(">>",n.Identifier(a),n.Literal(8))))]}:function(c){return[n.ExpressionStatement(n.CallExpression("writeMem",[n.Literal(c),n.Register(b)])),n.ExpressionStatement(n.CallExpression("writeMem",[n.Literal(c+1),n.Register(a)]))]}},INC8:function(a,b){return void 0===b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.CallExpression("inc8",
n.Register(a))))}:"s"==a&&"p"==b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("sp"),n.BinaryExpression("+",n.Identifier("sp"),n.Literal(1))))}:function(){return n.ExpressionStatement(n.CallExpression("incMem",n.CallExpression("getHL")))}},INC16:function(a,b){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.BinaryExpression("&",n.BinaryExpression("+",n.Register(b),n.Literal(1)),n.Literal(255)))),n.IfStatement(n.BinaryExpression("==",
n.Register(b),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.BinaryExpression("&",n.BinaryExpression("+",n.Register(a),n.Literal(1)),n.Literal(255))))]))]}},DEC8:function(a,b){return void 0===b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.CallExpression("dec8",n.Register(a))))}:"s"==a&&"p"==b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("sp"),n.BinaryExpression("-",n.Identifier("sp"),
n.Literal(1))))}:function(){return n.ExpressionStatement(n.CallExpression("decMem",n.CallExpression("getHL")))}},DEC16:function(a,b){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.BinaryExpression("&",n.BinaryExpression("-",n.Register(b),n.Literal(1)),n.Literal(255)))),n.IfStatement(n.BinaryExpression("==",n.Register(b),n.Literal(255)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.BinaryExpression("&",n.BinaryExpression("-",
n.Register(a),n.Literal(1)),n.Literal(255))))]))]}},ADD16:function(a,b,c,e){return void 0===e?function(){return o.SET16(a,b,n.CallExpression("add16",[n.CallExpression("get"+(a+b).toUpperCase()),n.Register(c)]))}:function(){return o.SET16(a,b,n.CallExpression("add16",[n.CallExpression("get"+(a+b).toUpperCase()),n.CallExpression("get"+(c+e).toUpperCase())]))}},RLCA:function(){return function(){return n.ExpressionStatement(n.CallExpression("rlca_a"))}},RRCA:function(){return function(){return n.ExpressionStatement(n.CallExpression("rrca_a"))}},
RLA:function(){return function(){return n.ExpressionStatement(n.CallExpression("rla_a"))}},RRA:function(){return function(){return n.ExpressionStatement(n.CallExpression("rra_a"))}},DAA:function(){return function(){return n.ExpressionStatement(n.CallExpression("daa"))}},CPL:function(){return function(){return n.ExpressionStatement(n.CallExpression("cpl_a"))}},SCF:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_CARRY))),n.ExpressionStatement(n.AssignmentExpression("&=",
n.Register("f"),n.UnaryExpression("~",n.Literal(F_NEGATIVE)))),n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_HALFCARRY))))]}},CCF:function(){return function(){return n.ExpressionStatement(n.CallExpression("ccf"))}},ADD:function(a,b){return void 0===a&&void 0===b?function(a){return n.ExpressionStatement(n.CallExpression("add_a",n.Literal(a)))}:void 0===b?function(){return n.ExpressionStatement(n.CallExpression("add_a",n.Register(a)))}:function(){return n.ExpressionStatement(n.CallExpression("add_a",
o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase()))))}},ADC:function(a,b){return void 0===a&&void 0===b?function(a){return n.ExpressionStatement(n.CallExpression("adc_a",n.Literal(a)))}:void 0===b?function(){return n.ExpressionStatement(n.CallExpression("adc_a",n.Register(a)))}:function(){return n.ExpressionStatement(n.CallExpression("adc_a",o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase()))))}},SUB:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return n.ExpressionStatement(n.CallExpression("sub_a",
n.Literal(a)))}:void 0===b?function(){return n.ExpressionStatement(n.CallExpression("sub_a",n.Register(a)))}:function(){return n.ExpressionStatement(n.CallExpression("sub_a",o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase()))))}},SBC:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return n.ExpressionStatement(n.CallExpression("sbc_a",n.Literal(a)))}:void 0===b?function(){return n.ExpressionStatement(n.CallExpression("sbc_a",n.Register(a)))}:function(){return n.ExpressionStatement(n.CallExpression("sbc_a",
o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase()))))}},AND:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return[n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("a"),n.Literal(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a")),n.Literal(F_HALFCARRY))))]}:"a"!=a&&void 0===b?function(){return[n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("a"),n.Register(a))),
n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a")),n.Literal(F_HALFCARRY))))]}:"a"==a&&void 0===b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a")),n.Literal(F_HALFCARRY))))}:function(){return[n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("a"),o.READ_MEM8(n.CallExpression("get"+
(a+b).toUpperCase())))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a")),n.Literal(F_HALFCARRY))))]}},XOR:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return[n.ExpressionStatement(n.AssignmentExpression("^=",n.Register("a"),n.Literal(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}:"a"!=a&&void 0===
b?function(){return[n.ExpressionStatement(n.AssignmentExpression("^=",n.Register("a"),n.Register(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}:"a"==a&&void 0===b?function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register("a"),n.Literal(0))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Literal(0))))]}:function(){return[n.ExpressionStatement(n.AssignmentExpression("^=",
n.Register("a"),o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase())))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}},OR:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return[n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("a"),n.Literal(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}:"a"!=a&&void 0===
b?function(){return[n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("a"),n.Register(a))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}:"a"==a&&void 0===b?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))}:function(){return[n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("a"),o.READ_MEM8(n.CallExpression("get"+
(a+b).toUpperCase())))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}},CP:function(a,b){return void 0===a&&void 0===b?function(a){return n.ExpressionStatement(n.CallExpression("cp_a",n.Literal(a)))}:void 0===b?function(){return n.ExpressionStatement(n.CallExpression("cp_a",n.Register(a)))}:function(){return n.ExpressionStatement(n.CallExpression("cp_a",o.READ_MEM8(n.CallExpression("get"+(a+b).toUpperCase()))))}},
POP:function(a,b){return function(){return[].concat(o.SET16(a,b,o.READ_MEM16(n.Identifier("sp"))),n.ExpressionStatement(n.AssignmentExpression("+=",n.Identifier("sp"),n.Literal(2))))}},PUSH:function(a,b){return function(){return n.ExpressionStatement(n.CallExpression("pushUint8",[n.Register(a),n.Register(b)]))}},JR:function(a){return function(b,c){return n.IfStatement(a,n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(5))),n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("pc"),n.BinaryExpression("+",n.Literal(c%16384),n.BinaryExpression("*",n.Identifier("page"),n.Literal(16384))))),n.ReturnStatement()]))}},DJNZ:function(){return function(a,b){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register("b"),n.BinaryExpression("&",n.BinaryExpression("-",n.Register("b"),n.Literal(1)),n.Literal(255)))),o.JR(n.BinaryExpression("!=",n.Register("b"),n.Literal(0)))(void 0,b)]}},JRNZ:function(){return function(a,b){return o.JR(n.UnaryExpression("!",n.BinaryExpression("!=",
n.BinaryExpression("&",n.Register("f"),n.Literal(F_ZERO)),n.Literal(0))))(void 0,b)}},JRZ:function(){return function(a,b){return o.JR(n.BinaryExpression("!=",n.BinaryExpression("&",n.Register("f"),n.Literal(F_ZERO)),n.Literal(0)))(void 0,b)}},JRNC:function(){return function(a,b){return o.JR(n.UnaryExpression("!",n.BinaryExpression("!=",n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.Literal(0))))(void 0,b)}},JRC:function(){return function(a,b){return o.JR(n.BinaryExpression("!=",n.BinaryExpression("&",
n.Register("f"),n.Literal(F_CARRY)),n.Literal(0)))(void 0,b)}},RET:function(a,b){return void 0===a&&void 0===b?function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),o.READ_MEM16(n.Identifier("sp")))),n.ExpressionStatement(n.AssignmentExpression("+=",n.Identifier("sp"),n.Literal(2)))]}:function(c,e,d){return n.IfStatement(n.BinaryExpression(a,n.BinaryExpression("&",n.Register("f"),n.Literal(b)),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",
n.Identifier("tstates"),n.Literal(6))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),o.READ_MEM16(n.Identifier("sp")))),n.ExpressionStatement(n.AssignmentExpression("+=",n.Identifier("sp"),n.Literal(2))),n.ReturnStatement()]))}},JP:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.Literal(b)))]}:"h"==a&&"l"==b?function(a,b,d){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),
n.CallExpression("getHL")))]}:function(c,e){return n.IfStatement(n.BinaryExpression(a,n.BinaryExpression("&",n.Register("f"),n.Literal(b)),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.Literal(e))),n.ReturnStatement()]))}},CALL:function(a,b){return void 0===a&&void 0===b?function(a,b,d){return[n.ExpressionStatement(n.CallExpression("push",n.BinaryExpression("+",n.Literal(d%16384),n.BinaryExpression("*",n.Identifier("page"),n.Literal(16384))))),
n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.Literal(b))),n.ReturnStatement()]}:function(c,e,d){return n.IfStatement(n.BinaryExpression(a,n.BinaryExpression("&",n.Register("f"),n.Literal(b)),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(7))),n.ExpressionStatement(n.CallExpression("push",n.BinaryExpression("+",n.Literal(d%16384),n.BinaryExpression("*",n.Identifier("page"),n.Literal(16384))))),n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("pc"),n.Literal(e))),n.ReturnStatement()]))}},RST:function(a){return function(b,c,e){return[n.ExpressionStatement(n.CallExpression("push",n.BinaryExpression("+",n.Literal(e%16384),n.BinaryExpression("*",n.Identifier("page"),n.Literal(16384))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.Literal(a))),n.ReturnStatement()]}},DI:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("iff1"),n.Literal(!1))),n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("iff2"),n.Literal(!1))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("EI_inst"),n.Literal(!0)))]}},EI:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("iff1"),n.Literal(!0))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("iff2"),n.Literal(!0))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("EI_inst"),n.Literal(!0)))]}},OUT:function(a,b){return void 0===b?function(b,e,d){return n.ExpressionStatement(n.CallExpression("port.out",
[n.Literal(b),n.Register(a)]))}:function(){return n.ExpressionStatement(n.CallExpression("port.out",[n.Register(a),n.Register(b)]))}},IN:function(a,b){return void 0===b?function(b,e,d){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.CallExpression("port.in_",n.Literal(b))))}:function(c,e,d){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Register(a),n.CallExpression("port.in_",n.Register(b)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",
n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register(a)))))]}},EX_AF:function(){return function(){return[].concat(o.EX("a","a2"),o.EX("f","f2"))}},EXX:function(){return function(){return[].concat(o.EX("b","b2"),o.EX("c","c2"),o.EX("d","d2"),o.EX("e","e2"),o.EX("h","h2"),o.EX("l","l2"))}},EX_DE_HL:function(){return function(){return[].concat(o.EX("d","h"),o.EX("e","l"))}},EX_SP_HL:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("temp"),n.Register("h"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("h"),o.READ_MEM8(n.BinaryExpression("+",n.Identifier("sp"),n.Literal(1))))),n.ExpressionStatement(n.CallExpression("writeMem",[n.BinaryExpression("+",n.Identifier("sp"),n.Literal(1)),n.Identifier("temp")])),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.Register("l"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("l"),o.READ_MEM8(n.Identifier("sp")))),n.ExpressionStatement(n.CallExpression("writeMem",
[n.Identifier("sp"),n.Identifier("temp")]))]}},HALT:function(){return function(a,b,c){a=[];HALT_SPEEDUP&&a.push(n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("tstates"),n.Literal(0))));return a.concat([n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("halt"),n.Literal(!0))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.BinaryExpression("+",n.Literal((c-1)%16384),n.BinaryExpression("*",n.Identifier("page"),n.Literal(16384))))),n.ReturnStatement()])}},
RLC:generateCBFunctions("rlc"),RRC:generateCBFunctions("rrc"),RL:generateCBFunctions("rl"),RR:generateCBFunctions("rr"),SLA:generateCBFunctions("sla"),SRA:generateCBFunctions("sra"),SLL:generateCBFunctions("sll"),SRL:generateCBFunctions("srl"),BIT:function(a,b,c){return void 0===c?function(){return n.ExpressionStatement(n.CallExpression("bit",n.BinaryExpression("&",n.Register(b),n.Bit(a))))}:"h"==b&&"l"==c?function(){return n.ExpressionStatement(n.CallExpression("bit",n.BinaryExpression("&",o.READ_MEM8(n.CallExpression("get"+
(b+c).toUpperCase())),n.Bit(a))))}:function(e,d,g){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("location"),n.BinaryExpression("&",n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(e)),n.Literal(65535)))),n.ExpressionStatement(n.CallExpression("bit",n.BinaryExpression("&",o.READ_MEM8(n.Identifier("location")),n.Bit(a))))]}},RES:function(a,b,c){return void 0===c?function(){return n.ExpressionStatement(n.AssignmentExpression("&=",n.Register(b),n.UnaryExpression("~",
n.Bit(a))))}:"h"==b&&"l"==c?function(){return n.ExpressionStatement(n.CallExpression("writeMem",n.CallExpression("get"+(b+c).toUpperCase()),n.BinaryExpression("&",o.READ_MEM8(n.CallExpression("get"+(b+c).toUpperCase())),n.UnaryExpression("~",n.Bit(a)))))}:function(e,d,g){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("location"),n.BinaryExpression("&",n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(e)),n.Literal(65535)))),n.ExpressionStatement(n.CallExpression("writeMem",
[n.Identifier("location"),n.BinaryExpression("&",o.READ_MEM8(n.Identifier("location")),n.UnaryExpression("~",n.Bit(a)))]))]}},SET:function(a,b,c){return void 0===c?function(){return n.ExpressionStatement(n.AssignmentExpression("|=",n.Register(b),n.Bit(a)))}:"h"==b&&"l"==c?function(){return n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("get"+(b+c).toUpperCase()),n.BinaryExpression("|",o.READ_MEM8(n.CallExpression("get"+(b+c).toUpperCase())),n.Bit(a))]))}:function(e,d,g){return[n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("location"),n.BinaryExpression("&",n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(e)),n.Literal(65535)))),n.ExpressionStatement(n.CallExpression("writeMem",[n.Identifier("location"),n.BinaryExpression("|",o.READ_MEM8(n.Identifier("location")),n.Bit(a))]))]}},LD_X:function(a,b,c){return void 0===c?function(c,d,g){return[n.ExpressionStatement(n.CallExpression("writeMem",[n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c&255)),n.Literal(c>>
8)]))]}:function(e,d,g){return[n.ExpressionStatement(n.CallExpression("writeMem",[n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(e)),n.Register(a)]))]}},INC_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.CallExpression("incMem",n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c))))]}},DEC_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.CallExpression("decMem",n.BinaryExpression("+",n.CallExpression("get"+
(a+b).toUpperCase()),n.Literal(c))))]}},ADD_X:function(a,b){return function(c,e,d){return n.ExpressionStatement(n.CallExpression("add_a",o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c)))))}},ADC_X:function(a,b){return function(c,e,d){return n.ExpressionStatement(n.CallExpression("adc_a",o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c)))))}},SUB_X:function(a,b){return function(c,e,d){return n.ExpressionStatement(n.CallExpression("sub_a",
o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c)))))}},SBC_X:function(a,b){return function(c,e,d){return n.ExpressionStatement(n.CallExpression("sbc_a",o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c)))))}},AND_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("a"),o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c))))),
n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a")),n.Literal(F_HALFCARRY))))]}},XOR_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.AssignmentExpression("^=",n.Register("a"),o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),
n.Register("a"))))]}},OR_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("a"),o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+(a+b).toUpperCase()),n.Literal(c))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.MemberExpression(n.Identifier("SZP_TABLE"),n.Register("a"))))]}},CP_X:function(a,b){return function(c){return n.ExpressionStatement(n.CallExpression("cp_a",o.READ_MEM8(n.BinaryExpression("+",n.CallExpression("get"+
(a+b).toUpperCase()),n.Literal(c)))))}},EX_SP_X:function(a,b){return function(){return[].concat(n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.CallExpression("get"+(a+b).toUpperCase()))),o.SET16(a,b,o.READ_MEM16(n.Identifier("sp"))),n.ExpressionStatement(n.CallExpression("writeMem",[n.Identifier("sp"),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(255))])),n.ExpressionStatement(n.CallExpression("writeMem",[n.BinaryExpression("+",n.Identifier("sp"),n.Literal(1)),n.BinaryExpression(">>",
n.Identifier("sp"),n.Literal(8))])))}},JP_X:function(a,b){return function(c,e,d){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),n.CallExpression("get"+(a+b).toUpperCase())))]}},ADC16:function(a,b){return function(c,e,d){return[void 0===b?n.VariableDeclaration("value",n.Identifier(a)):n.VariableDeclaration("value",n.BinaryExpression("|",n.BinaryExpression("<<",n.Register(a),n.Literal(8)),n.Register(b))),n.VariableDeclaration("val",n.BinaryExpression("|",n.BinaryExpression("<<",
n.Register("h"),n.Literal(8)),n.Register("l"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("+",n.BinaryExpression("+",n.Identifier("val"),n.Identifier("value")),n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("&",n.BinaryExpression(">>",n.BinaryExpression("^",n.BinaryExpression("^",
n.Identifier("val"),n.Identifier("temp")),n.Identifier("value")),n.Literal(8)),n.Literal(16)),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),n.Literal(16)),n.Literal(1))),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),n.Literal(8)),n.Literal(128))),n.ConditionalExpression(n.BinaryExpression("!=",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(65535)),n.Literal(0)),n.Literal(0),n.Literal(64))),n.BinaryExpression(">>",n.BinaryExpression("&",n.BinaryExpression("&",
n.BinaryExpression("^",n.BinaryExpression("^",n.Identifier("value"),n.Identifier("val")),n.Literal(32768)),n.BinaryExpression("^",n.Identifier("value"),n.Identifier("temp"))),n.Literal(32768)),n.Literal(13))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("h"),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),n.Literal(8)),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("l"),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(255))))]}},
SBC16:function(a,b){return function(c,e,d){return[void 0===b?n.VariableDeclaration("value",n.Identifier(a)):n.VariableDeclaration("value",n.BinaryExpression("|",n.BinaryExpression("<<",n.Register(a),n.Literal(8)),n.Register(b))),n.VariableDeclaration("val",n.BinaryExpression("|",n.BinaryExpression("<<",n.Register("h"),n.Literal(8)),n.Register("l"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("-",n.BinaryExpression("-",n.Identifier("val"),n.Identifier("value")),
n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("&",n.BinaryExpression(">>",n.BinaryExpression("^",n.BinaryExpression("^",n.Identifier("val"),n.Identifier("temp")),n.Identifier("value")),n.Literal(8)),n.Literal(16)),n.Literal(2)),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),
n.Literal(16)),n.Literal(1))),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),n.Literal(8)),n.Literal(128))),n.ConditionalExpression(n.BinaryExpression("!=",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(65535)),n.Literal(0)),n.Literal(0),n.Literal(64))),n.BinaryExpression(">>",n.BinaryExpression("&",n.BinaryExpression("&",n.BinaryExpression("^",n.Identifier("value"),n.Identifier("val")),n.BinaryExpression("^",n.Identifier("val"),n.Identifier("temp"))),n.Literal(32768)),
n.Literal(13))))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("h"),n.BinaryExpression("&",n.BinaryExpression(">>",n.Identifier("temp"),n.Literal(8)),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("l"),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(255))))]}},NEG:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.Register("a"))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("a"),
n.Literal(0))),n.ExpressionStatement(n.CallExpression("sub_a",n.Identifier("temp")))]}},RETN_RETI:function(){return function(){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("pc"),o.READ_MEM16(n.Identifier("sp")))),n.ExpressionStatement(n.AssignmentExpression("+=",n.Identifier("sp"),n.Literal(2))),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("iff1"),n.Identifier("iff2")))]}},IM:function(a){return function(){return n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("im"),n.Literal(a)))}},INI:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.CallExpression("port.in_",n.Register("c")))),n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("getHL"),n.Identifier("temp")])),o.DEC8("b")(),n.ExpressionStatement(n.CallExpression("incHL")),n.IfStatement(n.BinaryExpression("==",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(128)),n.Literal(128)),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("|=",
n.Register("f"),n.Literal(F_NEGATIVE)))),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_NEGATIVE))))))]}},OUTI:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("port.out",[n.Register("c"),n.Identifier("temp")])),o.DEC8("b")(),n.ExpressionStatement(n.CallExpression("incHL")),n.IfStatement(n.BinaryExpression(">",
n.BinaryExpression("+",n.Register("l"),n.Identifier("temp")),n.Literal(255)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_CARRY))),n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_HALFCARRY)))]),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_CARRY)))),n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_HALFCARRY))))])),
n.IfStatement(n.BinaryExpression("==",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(128)),n.Literal(128)),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_NEGATIVE)))),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_NEGATIVE))))))]}},OUTD:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),
n.ExpressionStatement(n.CallExpression("port.out",[n.Register("c"),n.Identifier("temp")])),o.DEC8("b")(),n.ExpressionStatement(n.CallExpression("decHL")),n.IfStatement(n.BinaryExpression(">",n.BinaryExpression("+",n.Register("l"),n.Identifier("temp")),n.Literal(255)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_CARRY))),n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_HALFCARRY)))]),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("&=",
n.Register("f"),n.UnaryExpression("~",n.Literal(F_CARRY)))),n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_HALFCARRY))))])),n.IfStatement(n.BinaryExpression("==",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(128)),n.Literal(128)),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_NEGATIVE)))),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",
n.Literal(F_NEGATIVE))))))]}},LDI:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("getDE"),n.Identifier("temp")])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("incDE")),n.ExpressionStatement(n.CallExpression("incHL")),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),
n.BinaryExpression("&",n.BinaryExpression("+",n.Identifier("temp"),n.Register("a")),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(193)),n.ConditionalExpression(n.CallExpression("getBC"),n.Literal(F_PARITY),n.Literal(0))),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_BIT3))),n.ConditionalExpression(n.BinaryExpression("&",n.Identifier("temp"),
n.Literal(F_NEGATIVE)),n.Literal(32),n.Literal(0)))))]}},CPI:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.Literal(F_NEGATIVE)))),n.ExpressionStatement(n.CallExpression("cp_a",[o.READ_MEM8(n.CallExpression("getHL"))])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("incHL")),n.ExpressionStatement(n.AssignmentExpression("|=",
n.Identifier("temp"),n.ConditionalExpression(n.BinaryExpression("==",n.CallExpression("getBC"),n.Literal(0)),n.Literal(0),n.Literal(F_PARITY)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(248)),n.Identifier("temp"))))]}},LDD:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("writeMem",
[n.CallExpression("getDE"),n.Identifier("temp")])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("decDE")),n.ExpressionStatement(n.CallExpression("decHL")),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("&",n.BinaryExpression("+",n.Identifier("temp"),n.Register("a")),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",
n.BinaryExpression("&",n.Register("f"),n.Literal(193)),n.ConditionalExpression(n.CallExpression("getBC"),n.Literal(F_PARITY),n.Literal(0))),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_BIT3))),n.ConditionalExpression(n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_NEGATIVE)),n.Literal(32),n.Literal(0)))))]}},LDIR:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("writeMem",
[n.CallExpression("getDE"),n.Identifier("temp")])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("incDE")),n.ExpressionStatement(n.CallExpression("incHL")),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("&",n.BinaryExpression("+",n.Identifier("temp"),n.Register("a")),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",
n.BinaryExpression("&",n.Register("f"),n.Literal(193)),n.ConditionalExpression(n.CallExpression("getBC"),n.Literal(F_PARITY),n.Literal(0))),n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_BIT3))),n.ConditionalExpression(n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_NEGATIVE)),n.Literal(32),n.Literal(0))))),n.IfStatement(n.BinaryExpression("!=",n.CallExpression("getBC"),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(5))),
n.ReturnStatement()]))]}},CPIR:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(F_CARRY)),n.Literal(F_NEGATIVE)))),n.ExpressionStatement(n.CallExpression("cp_a",[o.READ_MEM8(n.CallExpression("getHL"))])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("incHL")),n.ExpressionStatement(n.AssignmentExpression("|=",n.Identifier("temp"),
n.ConditionalExpression(n.BinaryExpression("==",n.CallExpression("getBC"),n.Literal(0)),n.Literal(0),n.Literal(F_PARITY)))),n.IfStatement(n.LogicalExpression("&&",n.BinaryExpression("!=",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_PARITY)),n.Literal(0)),n.BinaryExpression("==",n.BinaryExpression("&",n.Register("f"),n.Literal(F_ZERO)),n.Literal(0))),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(5))),n.ExpressionStatement(n.AssignmentExpression("=",
n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(248)),n.Identifier("temp")))),n.ReturnStatement()])),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(248)),n.Identifier("temp"))))]}},OTIR:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("port.out",
[n.Register("c"),n.Identifier("temp")])),o.DEC8("b")(),n.ExpressionStatement(n.CallExpression("incHL")),n.IfStatement(n.BinaryExpression(">",n.BinaryExpression("+",n.Register("l"),n.Identifier("temp")),n.Literal(255)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_CARRY))),n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_HALFCARRY)))]),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",
n.Literal(F_CARRY)))),n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_HALFCARRY))))])),n.IfStatement(n.BinaryExpression("!=",n.BinaryExpression("&",n.Identifier("temp"),n.Literal(128)),n.Literal(0)),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("|=",n.Register("f"),n.Literal(F_NEGATIVE)))),n.BlockStatement(n.ExpressionStatement(n.AssignmentExpression("&=",n.Register("f"),n.UnaryExpression("~",n.Literal(F_NEGATIVE)))))),n.IfStatement(n.BinaryExpression("!=",
n.Register("b"),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(5))),n.ReturnStatement()]))]}},LDDR:function(){return function(a,b,c){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),o.READ_MEM8(n.CallExpression("getHL")))),n.ExpressionStatement(n.CallExpression("writeMem",[n.CallExpression("getDE"),n.Identifier("temp")])),n.ExpressionStatement(n.CallExpression("decBC")),n.ExpressionStatement(n.CallExpression("decDE")),
n.ExpressionStatement(n.CallExpression("decHL")),n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("temp"),n.BinaryExpression("&",n.BinaryExpression("+",n.Identifier("temp"),n.Register("a")),n.Literal(255)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register("f"),n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("|",n.BinaryExpression("&",n.Register("f"),n.Literal(193)),n.ConditionalExpression(n.CallExpression("getBC"),n.Literal(F_PARITY),n.Literal(0))),n.BinaryExpression("&",
n.Identifier("temp"),n.Literal(F_BIT3))),n.ConditionalExpression(n.BinaryExpression("&",n.Identifier("temp"),n.Literal(F_NEGATIVE)),n.Literal(32),n.Literal(0))))),n.IfStatement(n.BinaryExpression("!=",n.CallExpression("getBC"),n.Literal(0)),n.BlockStatement([n.ExpressionStatement(n.AssignmentExpression("-=",n.Identifier("tstates"),n.Literal(5))),n.ReturnStatement()]))]}},LD_RLC:generateIndexCBFunctions("rlc"),LD_RRC:generateIndexCBFunctions("rrc"),LD_RL:generateIndexCBFunctions("rl"),LD_RR:generateIndexCBFunctions("rr"),
LD_SLA:generateIndexCBFunctions("sla"),LD_SRA:generateIndexCBFunctions("sra"),LD_SLL:generateIndexCBFunctions("sll"),LD_SRL:generateIndexCBFunctions("srl"),READ_MEM8:function(a){return n.CallExpression("readMem",a)},READ_MEM16:function(a){return n.CallExpression("readMemWord",a)}};
function generateCBFunctions(a){return function(b,c){return void 0===c?function(){return n.ExpressionStatement(n.AssignmentExpression("=",n.Register(b),n.CallExpression(a,n.Register(b))))}:function(){return n.ExpressionStatement(n.CallExpression("writeMem",n.CallExpression("get"+(b+c).toUpperCase()),n.CallExpression(a,o.READ_MEM8(n.CallExpression("get"+(b+c).toUpperCase())))))}}}
function generateIndexCBFunctions(a){return function(b,c,e){return void 0===e?function(d,e,h){return[n.ExpressionStatement(n.AssignmentExpression("=",n.Identifier("location"),n.BinaryExpression("&",n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(d)),n.Literal(65535)))),n.ExpressionStatement(n.CallExpression("writeMem",[n.Identifier("location"),n.CallExpression(a,o.READ_MEM8(n.Identifier("location")))]))]}:function(d,g,h){return[n.ExpressionStatement(n.AssignmentExpression("=",
n.Identifier("location"),n.BinaryExpression("&",n.BinaryExpression("+",n.CallExpression("get"+(b+c).toUpperCase()),n.Literal(d)),n.Literal(65535)))),n.ExpressionStatement(n.AssignmentExpression("=",n.Register(e),n.CallExpression(a,o.READ_MEM8(n.Identifier("location"))))),n.ExpressionStatement(n.CallExpression("writeMem",[n.Identifier("location"),n.Register(e)]))]}}};var opcodeTableCB=[],opcodeTableDDCB=[],opcodeTableFDCB=[],regs={B:["b"],C:["c"],D:["d"],E:["e"],H:["h"],L:["l"],"(HL)":["h","l"],A:["a"]};
"RLC RRC RL RR SLA SRA SLL SRL".split(" ").forEach(function(a){for(var b in regs)opcodeTableCB.push({name:a+" "+b,ast:o[a].apply(null,regs[b])}),"(HL)"!=b?(opcodeTableDDCB.push({name:"LD "+b+","+a+" (IX)",ast:o["LD_"+a].apply(null,["ixH","ixL"].concat(regs[b]))}),opcodeTableFDCB.push({name:"LD "+b+","+a+" (IY)",ast:o["LD_"+a].apply(null,["iyH","iyL"].concat(regs[b]))})):(opcodeTableDDCB.push({name:a+" (IX)",ast:o["LD_"+a]("ixH","ixL")}),opcodeTableFDCB.push({name:a+" (IY)",ast:o["LD_"+a]("iyH","iyL")}))});
["BIT","RES","SET"].forEach(function(a){for(var b=0;8>b;b++){for(var c in regs)opcodeTableCB.push({name:a+" "+b+","+c,ast:o[a].apply(null,[b].concat(regs[c]))});for(var e=0;8>e;e++)opcodeTableDDCB.push({name:a+" "+b+" (IX)",ast:o[a].apply(null,[b].concat(["ixH","ixL"]))}),opcodeTableFDCB.push({name:a+" "+b+" (IY)",ast:o[a].apply(null,[b].concat(["iyH","iyL"]))})}});function generateIndexTable(a){var b=a.substring(1,2).toLowerCase(),c="i"+b+"H",b="i"+b+"L";return{9:{name:"ADD "+a+",BC",ast:o.ADD16(c,b,"b","c")},25:{name:"ADD "+a+",DE",ast:o.ADD16(c,b,"d","e")},33:{name:"LD "+a+",nn",ast:o.LD16(c,b)},34:{name:"LD (nn),"+a,ast:o.LD_NN(c,b)},35:{name:"INC "+a,ast:o.INC16(c,b)},42:{name:"LD "+a+",(nn)",ast:o.LD16(c,b,"n","n")},43:{name:"DEC "+a,ast:o.DEC16(c,b)},52:{name:"INC ("+a+"+d)",ast:o.INC_X(c,b)},53:{name:"DEC ("+a+"+d)",ast:o.DEC_X(c,b)},54:{name:"LD ("+
a+"+d),n",ast:o.LD_X(c,b)},57:{name:"ADD "+a+",SP",ast:o.ADD16(c,b,"sp")},70:{name:"LD B,("+a+"+d)",ast:o.LD8_D("b",c,b)},78:{name:"LD C,("+a+"+d)",ast:o.LD8_D("c",c,b)},84:{name:" LD D,"+a+"H *",ast:o.LD8("d",c)},86:{name:"LD D,("+a+"+d)",ast:o.LD8_D("d",c,b)},93:{name:"LD E,"+a+"L *",ast:o.LD8("e",b)},94:{name:"LD E,("+a+"+d)",ast:o.LD8_D("e",c,b)},96:{name:"LD "+a+"H,B",ast:o.LD8(c,"b")},97:{name:"LD "+a+"H,C",ast:o.LD8(c,"c")},98:{name:"LD "+a+"H,D",ast:o.LD8(c,"d")},99:{name:"LD "+a+"H,E",ast:o.LD8(c,
"e")},100:{name:"LD "+a+"H,"+a+"H",ast:o.NOOP()},101:{name:"LD "+a+"H,"+a+"L *",ast:o.LD8_D(c,b)},102:{name:"LD H,("+a+"+d)",ast:o.LD8_D("h",c,b)},103:{name:"LD "+a+"H,A",ast:o.LD8(c,"a")},104:{name:"LD "+a+"L,B",ast:o.LD8(b,"b")},105:{name:"LD "+a+"L,C",ast:o.LD8(b,"c")},106:{name:"LD "+a+"L,D",ast:o.LD8(b,"d")},107:{name:"LD "+a+"L,E",ast:o.LD8(b,"e")},108:{name:"LD "+a+"L,"+a+"H",ast:o.LD8_D(b,c)},109:{name:"LD "+a+"L,"+a+"L *",ast:o.NOOP()},110:{name:"LD L,("+a+"+d)",ast:o.LD8_D("l",c,b)},111:{name:"LD "+
a+"L,A *",ast:o.LD8(b,"a")},112:{name:"LD ("+a+"+d),B",ast:o.LD_X("b",c,b)},113:{name:"LD ("+a+"+d),C",ast:o.LD_X("c",c,b)},114:{name:"LD ("+a+"+d),D",ast:o.LD_X("d",c,b)},115:{name:"LD ("+a+"+d),E",ast:o.LD_X("e",c,b)},116:{name:"LD ("+a+"+d),H",ast:o.LD_X("h",c,b)},117:{name:"LD ("+a+"+d),L",ast:o.LD_X("l",c,b)},118:{name:"LD ("+a+"+d),B",ast:o.LD_X("b",c,b)},119:{name:"LD ("+a+"+d),A",ast:o.LD_X("a",c,b)},126:{name:"LD A,("+a+"+d)",ast:o.LD8_D("a",c,b)},124:{name:"LD A,"+a+"H",ast:o.LD8("a",c)},
125:{name:"LD A,"+a+"L",ast:o.LD8("a",b)},132:{name:"ADD A,"+a+"H",ast:o.ADD(b)},133:{name:"ADD A,"+a+"L",ast:o.ADD(b)},134:{name:"ADD A,("+a+"+d)",ast:o.ADD_X(c,b)},140:{name:"ADC A,"+a+"H",ast:o.ADC(b)},141:{name:"ADC A,"+a+"L",ast:o.ADC(b)},142:{name:"ADC A,("+a+"+d)",ast:o.ADC_X(c,b)},148:{name:"SUB A,"+a+"H",ast:o.SUB(b)},149:{name:"SUB A,"+a+"L",ast:o.SUB(b)},150:{name:"SUB A,("+a+"+d)",ast:o.SUB_X(c,b)},156:{name:"SBC A,"+a+"H",ast:o.SBC(b)},157:{name:"SBC A,"+a+"L",ast:o.SBC(b)},158:{name:"SBC A,("+
a+"+d)",ast:o.SBC_X(c,b)},166:{name:"AND A,("+a+"+d)",ast:o.AND_X(c,b)},174:{name:"XOR A,("+a+"+d)",ast:o.XOR_X(c,b)},182:{name:"OR A,("+a+"+d)",ast:o.OR_X(c,b)},190:{name:"CP ("+a+"+d)",ast:o.CP_X(c,b)},203:"IX"==a?opcodeTableDDCB:opcodeTableFDCB,225:{name:"POP "+a,ast:o.POP(c,b)},227:{name:"EX SP,("+a+")",ast:o.EX_SP_X(c,b)},229:{name:"PUSH "+a,ast:o.PUSH(c,b)},233:{name:"JP ("+a+")",ast:o.JP_X(c,b)},249:{name:"LD SP,"+a,ast:o.LD_SP(c,b)}}};var opcodeTableED={64:{name:"IN B,(C)",ast:o.IN("b","c")},66:{name:"SBC HL,BC",ast:o.SBC16("b","c")},65:{name:"OUT (C),B",ast:o.OUT("c","b")},67:{name:"LD (nn),BC",ast:o.LD_NN("b","c")},68:{name:"NEG",ast:o.NEG()},69:{name:"RETN / RETI",ast:o.RETN_RETI()},70:{name:"IM 0",ast:o.IM(0)},72:{name:"IN C,(C)",ast:o.IN("c","c")},73:{name:"OUT (C),C",ast:o.OUT("c","c")},74:{name:"ADC HL,BC",ast:o.ADC16("b","c")},75:{name:"LD BC,(nn)",ast:o.LD16("b","c","n","n")},76:{name:"NEG",ast:o.NEG()},77:{name:"RETN / RETI",
ast:o.RETN_RETI()},78:{name:"IM 0",ast:o.IM(0)},79:{name:"LD R,A",ast:o.LD8("r","a")},80:{name:"IN D,(C)",ast:o.IN("d","c")},81:{name:"OUT (C),D",ast:o.OUT("c","d")},82:{name:"SBC HL,DE",ast:o.SBC16("d","e")},83:{name:"LD (nn),DE",ast:o.LD_NN("d","e")},84:{name:"NEG",ast:o.NEG()},85:{name:"RETN / RETI",ast:o.RETN_RETI()},86:{name:"IM 1",ast:o.IM(1)},87:{name:"LD A,I",ast:o.LD8("a","i")},88:{name:"IN E,(C)",ast:o.IN("e","c")},89:{name:"OUT (C),E",ast:o.OUT("c","e")},90:{name:"ADC HL,DE",ast:o.ADC16("d",
"e")},91:{name:"LD DE,(nn)",ast:o.LD16("d","e","n","n")},92:{name:"NEG",ast:o.NEG()},95:{name:"LD A,R",ast:o.LD8("a","r")},96:{name:"IN H,(C)",ast:o.IN("h","c")},97:{name:"OUT (C),H",ast:o.OUT("c","h")},98:{name:"SBC HL,HL",ast:o.SBC16("h","l")},99:{name:"LD (nn),HL",ast:o.LD_NN("h","l")},100:{name:"NEG",ast:o.NEG()},102:{name:"IM 0",ast:o.IM(0)},104:{name:"IN L,(C)",ast:o.IN("l","c")},105:{name:"OUT (C),L",ast:o.OUT("c","l")},106:{name:"ADC HL,HL",ast:o.ADC16("h","l")},107:{name:"LD HL,(nn)",ast:o.LD16("h",
"l","n","n")},108:{name:"NEG",ast:o.NEG()},110:{name:"IM 0",ast:o.IM(0)},115:{name:"LD (nn),SP",ast:o.LD_NN("sp")},116:{name:"NEG",ast:o.NEG()},118:{name:"IM 1",ast:o.IM(1)},120:{name:"IN A,(C)",ast:o.IN("a","c")},121:{name:"OUT (C),A",ast:o.OUT("c","a")},122:{name:"ADC HL,SP",ast:o.ADC16("sp")},124:{name:"NEG",ast:o.NEG()},160:{name:"LDI",ast:o.LDI()},161:{name:"CPI",ast:o.CPI()},162:{name:"INI",ast:o.INI()},163:{name:"OUTI",ast:o.OUTI()},168:{name:"LDD",ast:o.LDD()},171:{name:"OUTD",ast:o.OUTD()},
176:{name:"LDIR",ast:o.LDIR()},177:{name:"CPIR",ast:o.CPIR()},179:{name:"OTIR",ast:o.OTIR()},184:{name:"LDDR",ast:o.LDDR()}};var opcodeTable=[{name:"NOP",ast:o.NOOP()},{name:"LD BC,nn",ast:o.LD16("b","c")},{name:"LD (BC),A",ast:o.LD_WRITE_MEM("b","c","a")},{name:"INC BC",ast:o.INC16("b","c")},{name:"INC B",ast:o.INC8("b")},{name:"DEC B",ast:o.DEC8("b")},{name:"LD B,n",ast:o.LD8("b")},{name:"RLCA",ast:o.RLCA()},{name:"EX AF AF'",ast:o.EX_AF()},{name:"ADD HL,BC",ast:o.ADD16("h","l","b","c")},{name:"LD A,(BC)",ast:o.LD8("a","b","c")},{name:"DEC BC",ast:o.DEC16("b","c")},{name:"INC C",ast:o.INC8("c")},{name:"DEC C",ast:o.DEC8("c")},
{name:"LD C,n",ast:o.LD8("c")},{name:"RRCA",ast:o.RRCA()},{name:"DJNZ (PC+e)",ast:o.DJNZ()},{name:"LD DE,nn",ast:o.LD16("d","e")},{name:"LD (DE),A",ast:o.LD_WRITE_MEM("d","e","a")},{name:"INC DE",ast:o.INC16("d","e")},{name:"INC D",ast:o.INC8("d")},{name:"DEC D",ast:o.DEC8("d")},{name:"LD D,n",ast:o.LD8("d")},{name:"RLA",ast:o.RLA()},{name:"JR (PC+e)",ast:o.JP()},{name:"ADD HL,DE",ast:o.ADD16("h","l","d","e")},{name:"LD A,(DE)",ast:o.LD8("a","d","e")},{name:"DEC DE",ast:o.DEC16("d","e")},{name:"INC E",
ast:o.INC8("e")},{name:"DEC E",ast:o.DEC8("e")},{name:"LD E,n",ast:o.LD8("e")},{name:"RRA",ast:o.RRA()},{name:"JR NZ,(PC+e)",ast:o.JRNZ()},{name:"LD HL,nn",ast:o.LD16("h","l")},{name:"LD (nn),HL",ast:o.LD_NN("h","l")},{name:"INC HL",ast:o.INC16("h","l")},{name:"INC H",ast:o.INC8("h")},{name:"DEC H",ast:o.DEC8("h")},{name:"LD H,n",ast:o.LD8("h")},{name:"DAA",ast:o.DAA()},{name:"JR Z,(PC+e)",ast:o.JRZ()},{name:"ADD HL,HL",ast:o.ADD16("h","l","h","l")},{name:"LD HL,(nn)",ast:o.LD16("h","l","n","n")},
{name:"DEC HL",ast:o.DEC16("h","l")},{name:"INC L",ast:o.INC8("l")},{name:"DEC L",ast:o.DEC8("l")},{name:"LD L,n",ast:o.LD8("l")},{name:"CPL",ast:o.CPL()},{name:"JR NC,(PC+e)",ast:o.JRNC()},{name:"LD SP,nn",ast:o.LD_SP()},{name:"LD (nn),A",ast:o.LD_WRITE_MEM("n","n","a")},{name:"INC SP",ast:o.INC8("s","p")},{name:"INC (HL)",ast:o.INC8("h","l")},{name:"DEC (HL)",ast:o.DEC8("h","l")},{name:"LD (HL),n",ast:o.LD_WRITE_MEM("h","l")},{name:"SCF",ast:o.SCF()},{name:"JR C,(PC+e)",ast:o.JRC()},{name:"ADD HL,SP",
ast:o.ADD16("h","l","sp")},{name:"LD A,(nn)",ast:o.LD8("a","n","n")},{name:"DEC SP",ast:o.DEC8("s","p")},{name:"INC A",ast:o.INC8("a")},{name:"DEC A",ast:o.DEC8("a")},{name:"LD A,n",ast:o.LD8("a")},{name:"CCF",ast:o.CCF()},{name:"LD B,B",ast:o.NOOP()},{name:"LD B,C",ast:o.LD8("b","c")},{name:"LD B,D",ast:o.LD8("b","d")},{name:"LD B,E",ast:o.LD8("b","e")},{name:"LD B,H",ast:o.LD8("b","h")},{name:"LD B,L",ast:o.LD8("b","l")},{name:"LD B,(HL)",ast:o.LD8("b","h","l")},{name:"LD B,A",ast:o.LD8("b","a")},
{name:"LD C,B",ast:o.LD8("c","b")},{name:"LD C,C",ast:o.NOOP()},{name:"LD C,D",ast:o.LD8("c","d")},{name:"LD C,E",ast:o.LD8("c","e")},{name:"LD C,H",ast:o.LD8("c","h")},{name:"LD C,L",ast:o.LD8("c","l")},{name:"LD C,(HL)",ast:o.LD8("c","h","l")},{name:"LD C,A",ast:o.LD8("c","a")},{name:"LD D,B",ast:o.LD8("d","b")},{name:"LD D,C",ast:o.LD8("d","c")},{name:"LD D,D",ast:o.NOOP()},{name:"LD D,E",ast:o.LD8("d","e")},{name:"LD D,H",ast:o.LD8("d","h")},{name:"LD D,L",ast:o.LD8("d","l")},{name:"LD D,(HL)",
ast:o.LD8("d","h","l")},{name:"LD D,A",ast:o.LD8("d","a")},{name:"LD E,B",ast:o.LD8("e","b")},{name:"LD E,C",ast:o.LD8("e","c")},{name:"LD E,D",ast:o.LD8("e","d")},{name:"LD E,E",ast:o.NOOP()},{name:"LD E,H",ast:o.LD8("e","h")},{name:"LD E,L",ast:o.LD8("e","l")},{name:"LD E,(HL)",ast:o.LD8("e","h","l")},{name:"LD E,A",ast:o.LD8("e","a")},{name:"LD H,B",ast:o.LD8("h","b")},{name:"LD H,C",ast:o.LD8("h","c")},{name:"LD H,D",ast:o.LD8("h","d")},{name:"LD H,E",ast:o.LD8("h","e")},{name:"LD H,H",ast:o.NOOP()},
{name:"LD H,L",ast:o.LD8("h","l")},{name:"LD H,(HL)",ast:o.LD8("h","h","l")},{name:"LD H,A",ast:o.LD8("h","a")},{name:"LD L,B",ast:o.LD8("l","b")},{name:"LD L,C",ast:o.LD8("l","c")},{name:"LD L,D",ast:o.LD8("l","d")},{name:"LD L,E",ast:o.LD8("l","e")},{name:"LD L,H",ast:o.LD8("l","h")},{name:"LD L,L",ast:o.NOOP()},{name:"LD L,(HL)",ast:o.LD8("l","h","l")},{name:"LD L,A",ast:o.LD8("l","a")},{name:"LD (HL),B",ast:o.LD_WRITE_MEM("h","l","b")},{name:"LD (HL),C",ast:o.LD_WRITE_MEM("h","l","c")},{name:"LD (HL),D",
ast:o.LD_WRITE_MEM("h","l","d")},{name:"LD (HL),E",ast:o.LD_WRITE_MEM("h","l","e")},{name:"LD (HL),H",ast:o.LD_WRITE_MEM("h","l","h")},{name:"LD (HL),L",ast:o.LD_WRITE_MEM("h","l","l")},{name:"HALT",ast:o.HALT()},{name:"LD (HL),A",ast:o.LD_WRITE_MEM("h","l","a")},{name:"LD A,B",ast:o.LD8("a","b")},{name:"LD A,C",ast:o.LD8("a","c")},{name:"LD A,D",ast:o.LD8("a","d")},{name:"LD A,E",ast:o.LD8("a","e")},{name:"LD A,H",ast:o.LD8("a","h")},{name:"LD A,L",ast:o.LD8("a","l")},{name:"LD A,(HL)",ast:o.LD8("a",
"h","l")},{name:"LD A,A",ast:o.NOOP()},{name:"ADD A,B",ast:o.ADD("b")},{name:"ADD A,C",ast:o.ADD("c")},{name:"ADD A,D",ast:o.ADD("d")},{name:"ADD A,E",ast:o.ADD("e")},{name:"ADD A,H",ast:o.ADD("h")},{name:"ADD A,L",ast:o.ADD("l")},{name:"ADD A,(HL)",ast:o.ADD("h","l")},{name:"ADD A,A",ast:o.ADD("a")},{name:"ADC A,B",ast:o.ADC("b")},{name:"ADC A,C",ast:o.ADC("c")},{name:"ADC A,D",ast:o.ADC("d")},{name:"ADC A,E",ast:o.ADC("e")},{name:"ADC A,H",ast:o.ADC("h")},{name:"ADC A,L",ast:o.ADC("l")},{name:"ADC A,(HL)",
ast:o.ADC("h","l")},{name:"ADC A,A",ast:o.ADC("a")},{name:"SUB A,B",ast:o.SUB("b")},{name:"SUB A,C",ast:o.SUB("c")},{name:"SUB A,D",ast:o.SUB("d")},{name:"SUB A,E",ast:o.SUB("e")},{name:"SUB A,H",ast:o.SUB("h")},{name:"SUB A,L",ast:o.SUB("l")},{name:"SUB A,(HL)",ast:o.SUB("h","l")},{name:"SUB A,A",ast:o.SUB("a")},{name:"SBC A,B",ast:o.SBC("b")},{name:"SBC A,C",ast:o.SBC("c")},{name:"SBC A,D",ast:o.SBC("d")},{name:"SBC A,E",ast:o.SBC("e")},{name:"SBC A,H",ast:o.SBC("h")},{name:"SBC A,L",ast:o.SBC("l")},
{name:"SBC A,(HL)",ast:o.SBC("h","l")},{name:"SBC A,A",ast:o.SBC("a")},{name:"AND A,B",ast:o.AND("b")},{name:"AND A,C",ast:o.AND("c")},{name:"AND A,D",ast:o.AND("d")},{name:"AND A,E",ast:o.AND("e")},{name:"AND A,H",ast:o.AND("h")},{name:"AND A,L",ast:o.AND("l")},{name:"AND A,(HL)",ast:o.AND("h","l")},{name:"AND A,A",ast:o.AND("a")},{name:"XOR A,B",ast:o.XOR("b")},{name:"XOR A,C",ast:o.XOR("c")},{name:"XOR A,D",ast:o.XOR("d")},{name:"XOR A,E",ast:o.XOR("e")},{name:"XOR A,H",ast:o.XOR("h")},{name:"XOR A,L",
ast:o.XOR("l")},{name:"XOR A,(HL)",ast:o.XOR("h","l")},{name:"XOR A,A",ast:o.XOR("a")},{name:"OR A,B",ast:o.OR("b")},{name:"OR A,C",ast:o.OR("c")},{name:"OR A,D",ast:o.OR("d")},{name:"OR A,E",ast:o.OR("e")},{name:"OR A,H",ast:o.OR("h")},{name:"OR A,L",ast:o.OR("l")},{name:"OR A,(HL)",ast:o.OR("h","l")},{name:"OR A,A",ast:o.OR("a")},{name:"CP A,B",ast:o.CP("b")},{name:"CP A,C",ast:o.CP("c")},{name:"CP A,D",ast:o.CP("d")},{name:"CP A,E",ast:o.CP("e")},{name:"CP A,H",ast:o.CP("h")},{name:"CP A,L",ast:o.CP("l")},
{name:"CP A,(HL)",ast:o.CP("h","l")},{name:"CP A,A",ast:o.CP("a")},{name:"RET NZ",ast:o.RET("==",F_ZERO)},{name:"POP BC",ast:o.POP("b","c")},{name:"JP NZ,(nn)",ast:o.JP("==",F_ZERO)},{name:"JP (nn)",ast:o.JP()},{name:"CALL NZ (nn)",ast:o.CALL("==",F_ZERO)},{name:"PUSH BC",ast:o.PUSH("b","c")},{name:"ADD A,n",ast:o.ADD()},{name:"RST 0x00",ast:o.RST(0)},{name:"RET Z",ast:o.RET("!=",F_ZERO)},{name:"RET",ast:o.RET()},{name:"JP Z,(nn)",ast:o.JP("!=",F_ZERO)},opcodeTableCB,{name:"CALL Z (nn)",ast:o.CALL("!=",
F_ZERO)},{name:"CALL (nn)",ast:o.CALL()},{name:"ADC A,n",ast:o.ADC()},{name:"RST 0x08",ast:o.RST(8)},{name:"RET NC",ast:o.RET("==",F_CARRY)},{name:"POP DE",ast:o.POP("d","e")},{name:"JP NC,(nn)",ast:o.JP("==",F_CARRY)},{name:"OUT (n),A",ast:o.OUT("a")},{name:"CALL NC (nn)",ast:o.CALL("==",F_CARRY)},{name:"PUSH DE",ast:o.PUSH("d","e")},{name:"SUB n",ast:o.SUB()},{name:"RST 0x10",ast:o.RST(16)},{name:"RET C",ast:o.RET("!=",F_CARRY)},{name:"EXX",ast:o.EXX()},{name:"JP C,(nn)",ast:o.JP("!=",F_CARRY)},
{name:"IN A,(n)",ast:o.IN("a")},{name:"CALL C (nn)",ast:o.CALL("!=",F_CARRY)},generateIndexTable("IX"),{name:"SBC A,n",ast:o.SBC()},{name:"RST 0x18",ast:o.RST(24)},{name:"RET PO",ast:o.RET("==",F_PARITY)},{name:"POP HL",ast:o.POP("h","l")},{name:"JP PO,(nn)",ast:o.JP("==",F_PARITY)},{name:"EX (SP),HL",ast:o.EX_SP_HL()},{name:"CALL PO (nn)",ast:o.CALL("==",F_PARITY)},{name:"PUSH HL",ast:o.PUSH("h","l")},{name:"AND (n)",ast:o.AND()},{name:"RST 0x20",ast:o.RST(32)},{name:"RET PE",ast:o.RET("!=",F_PARITY)},
{name:"JP (HL)",ast:o.JP("h","l")},{name:"JP PE,(nn)",ast:o.JP("!=",F_PARITY)},{name:"EX DE,HL",ast:o.EX_DE_HL()},{name:"CALL PE (nn)",ast:o.CALL("!=",F_PARITY)},opcodeTableED,{name:"XOR n",ast:o.XOR()},{name:"RST 0x28",ast:o.RST(40)},{name:"RET P",ast:o.RET("==",F_SIGN)},{name:"POP AF",ast:o.POP("a","f")},{name:"JP P,(nn)",ast:o.JP("==",F_SIGN)},{name:"DI",ast:o.DI()},{name:"CALL P (nn)",ast:o.CALL("==",F_SIGN)},{name:"PUSH AF",ast:o.PUSH("a","f")},{name:"OR n",ast:o.OR()},{name:"RST 0x30",ast:o.RST(48)},
{name:"RET M",ast:o.RET("!=",F_SIGN)},{name:"LD SP,HL",ast:o.LD_SP("h","l")},{name:"JP M,(nn)",ast:o.JP("!=",F_SIGN)},{name:"EI",ast:o.EI()},{name:"CALL M (nn)",ast:o.CALL("!=",F_SIGN)},generateIndexTable("IY"),{name:"CP n",ast:o.CP()},{name:"RST 0x38",ast:o.RST(56)}];var Analyzer=function(){var a=function(){this.bytecodes={};this.ast=[];this.missingOpcodes={}};a.prototype={analyze:function(a){var c=0;this.bytecodes=a;this.ast=Array(this.bytecodes.length);JSSMS.Utils.console.time("Analyzing");for(c=0;c<this.bytecodes.length;c++)this.normalizeBytecode(c),this.restructure(c);JSSMS.Utils.console.timeEnd("Analyzing");for(c in this.missingOpcodes)console.error("Missing opcode",c,this.missingOpcodes[c])},analyzeFromAddress:function(a){this.bytecodes=[a];this.ast=[];
this.missingOpcodes={};this.normalizeBytecode(0);this.bytecodes[0][this.bytecodes[0].length-1].isFunctionEnder=!0;this.ast=[this.bytecodes];for(var c in this.missingOpcodes)console.error("Missing opcode",c,this.missingOpcodes[c])},normalizeBytecode:function(a){var c=this;this.bytecodes[a]=this.bytecodes[a].map(function(a){var b;switch(a.opcode.length){case 1:b=opcodeTable[a.opcode[0]];break;case 2:b=opcodeTable[a.opcode[0]][a.opcode[1]];break;case 3:b=opcodeTable[a.opcode[0]][a.opcode[1]][a.opcode[2]];
break;default:JSSMS.Utils.console.error("Something went wrong in parsing. Opcode: ["+a.opcode.join(" ")+"]")}if(b&&b.ast){var g=b.ast(a.operand,a.target,a.nextAddress);Array.isArray(g)||void 0===g||(g=[g]);a.ast=g;DEBUG&&(a.name=b.name,b.opcode&&(a.opcode=b.opcode(a.operand,a.target,a.nextAddress)))}else b=a.hexOpcode,c.missingOpcodes[b]=void 0!==c.missingOpcodes[b]?c.missingOpcodes[b]+1:1;return a})},restructure:function(a){this.ast[a]=[];var c=this,e=-1,d=!0,g={};this.bytecodes[a].forEach(function(h){if(h.isJumpTarget||
d)e++,c.ast[a][e]=[],d=!1,g.isFunctionEnder=!0;c.ast[a][e].push(h);h.isFunctionEnder&&(d=!0);g=h})}};return a}();var Optimizer=function(){var a=function(){this.ast=[]};a.prototype={optimize:function(a){this.ast=a;for(a=0;a<this.ast.length;a++)this.localOptimization(a)},localOptimization:function(a){this.ast[a]=this.ast[a].map(this.evaluateBinaryExpressions);this.ast[a]=this.ast[a].map(this.inlineRegisters)},evaluateBinaryExpressions:function(a){return a.map(function(a){var b=a.ast;if(!b)return a;a.ast=JSSMS.Utils.traverse(b,function(a){if("BinaryExpression"==a.type&&"Literal"==a.left.type&&"Literal"==a.right.type){var b=
0;switch(a.operator){case ">>":b=a.left.value>>a.right.value;break;case "&":b=a.left.value&a.right.value;break;default:return JSSMS.Utils.console.log("Unimplemented evaluation optimization for operator",a.operator),a}a.type="Literal";a.value=b;a.raw=DEBUG?JSSMS.Utils.toHex(b):""+b;delete a.right;delete a.left}return a});return a})},inlineRegisters:function(a){var c={b:!1,c:!1,d:!1,e:!1,h:!1,l:!1},e={b:{},c:{},d:{},e:{},h:{},l:{}};return a.map(function(a){var b=a.ast;if(!b)return a;a.ast=JSSMS.Utils.traverse(b,
function(a){"AssignmentExpression"==a.type&&"="==a.operator&&"Register"==a.left.type&&"Literal"==a.right.type&&"a"!=a.left.name&&"f"!=a.left.name&&(c[a.left.name]=!0,e[a.left.name]=a.right);if("AssignmentExpression"==a.type&&"Register"==a.left.type&&"Literal"!=a.right.type&&"a"!=a.left.name&&"f"!=a.left.name)return c[a.left.name]=!1,e[a.left.name]={},a;if("CallExpression"==a.type)return a.arguments[0]&&"Register"==a.arguments[0].type&&c[a.arguments[0].name]&&"a"!=a.arguments[0].name&&"f"!=a.arguments[0].name&&
(a.arguments[0]=e[a.arguments[0].name]),a.arguments[1]&&"Register"==a.arguments[1].type&&c[a.arguments[1].name]&&"a"!=a.arguments[1].name&&"f"!=a.arguments[1].name&&(a.arguments[1]=e[a.arguments[1].name]),a;if("MemberExpression"==a.type&&"Register"==a.property.type&&c[a.property.name]&&"a"!=a.property.name&&"f"!=a.property.name)return a.property=e[a.property.name],a;"BinaryExpression"==a.type&&("Register"==a.right.type&&c[a.right.name]&&"a"!=a.right.name&&"f"!=a.right.name&&(a.right=e[a.right.name]),
"Register"==a.left.type&&c[a.left.name]&&"a"!=a.left.name&&"f"!=a.left.name&&(a.left=e[a.left.name]));return a});return a})}};return a}();var Generator=function(){function a(a){switch(a[0]){case 203:return OP_CB_STATES[a[1]];case 221:case 253:return 2==a.length?OP_DD_STATES[a[1]]:OP_INDEX_CB_STATES[a[2]];case 237:return OP_ED_STATES[a[1]];default:return OP_STATES[a[0]]}}function b(a){return JSSMS.Utils.traverse(a,function(a){"Register"==a.type&&(a.type="Identifier");return a})}var c=JSSMS.Utils.toHex,e="page temp location val value JSSMS.Utils.rndInt".split(" "),d=function(){this.ast=[]};d.prototype={generate:function(d){for(var h=
0;h<d.length;h++)d[h]=d[h].map(function(d){var g=[{type:"ExpressionStatement",expression:{type:"Literal",value:"use strict",raw:'"use strict"'}}],h=d[0].address,m=0;d=d.map(function(b){void 0===b.ast&&(b.ast=[]);if(ENABLE_SERVER_LOGGER)var d={type:"ExpressionStatement",expression:{type:"CallExpression",callee:n.Identifier("sync"),arguments:[]}};m+=a(b.opcode);var e=[{type:"ExpressionStatement",expression:{type:"AssignmentExpression",operator:"-=",left:{type:"Identifier",name:"tstates"},right:{type:"Literal",
value:m,raw:DEBUG?c(m):""+m}}}];m=0;ENABLE_SERVER_LOGGER&&(e=[].concat(d,e));b.ast=[].concat(e,b.ast);(ENABLE_SERVER_LOGGER||b.isFunctionEnder)&&null!==b.nextAddress&&(d=b.nextAddress%16384,d={type:"ExpressionStatement",expression:{type:"AssignmentExpression",operator:"=",left:{type:"Identifier",name:"pc"},right:{type:"BinaryExpression",operator:"+",left:{type:"Literal",value:d,raw:DEBUG?c(d):""+d},right:{type:"BinaryExpression",operator:"*",left:{type:"Identifier",name:"page"},right:{type:"Literal",
value:16384,raw:"0x4000"}}}}},b.ast.push(d));DEBUG&&b.ast[0]&&(b.ast[0].leadingComments=[{type:"Line",value:" "+b.label}]);return b.ast});d.forEach(function(a){g=g.concat(a)});g=b(g);g=JSSMS.Utils.traverse(g,function(a){a.type&&"Identifier"==a.type&&-1==e.indexOf(a.name)&&(a.name="this."+a.name);return a});return{type:"Program",body:[{type:"FunctionDeclaration",id:{type:"Identifier",name:h},params:[{type:"Identifier",name:"page"},{type:"Identifier",name:"temp"},{type:"Identifier",name:"location"}],
defaults:[],body:{type:"BlockStatement",body:g},rest:null,generator:!1,expression:!1}]}});this.ast=d}};return d}();var Recompiler=function(){var a=JSSMS.Utils.toHex,b=function(a){this.cpu=a;this.rom=[];this.options={};this.parser={};this.analyzer=new Analyzer;this.optimizer=new Optimizer;this.generator=new Generator;this.bytecodes={}};b.prototype={setRom:function(a){this.rom=a;this.parser=new Parser(a,this.cpu.frameReg)},reset:function(){var b=this;this.options.entryPoints=[{address:0,romPage:0,memPage:0},{address:56,romPage:0,memPage:0},{address:102,romPage:0,memPage:0}];2>=this.rom.length?JSSMS.Utils.console.log("Parsing full ROM"):
(this.options.pageLimit=0,JSSMS.Utils.console.log("Parsing initial memory page of ROM"));for(var e=this.parse().analyze().optimize().generate(),d=0;d<this.rom.length;d++)e[d].forEach(function(e){var h=e.body[0].id.name;DEBUG&&(e.body[0].id.name="_"+a(h));b.cpu.branches[d][h]=(new Function("return "+b.generateCodeFromAst(e)))()})},parse:function(){var a=this;this.options.entryPoints.forEach(function(b){a.parser.addEntryPoint(b)});this.parser.parse(this.options.pageLimit);return this},analyze:function(){this.analyzer.analyze(this.parser.bytecodes);
return this},optimize:function(){this.optimizer.optimize(this.analyzer.ast);return this},generate:function(){this.generator.generate(this.optimizer.ast);return this.generator.ast},recompileFromAddress:function(b,e,d){var g=this;this.parseFromAddress(b,e,d).analyzeFromAddress().optimize().generate()[0].forEach(function(d){DEBUG&&(d.body[0].id.name="_"+a(d.body[0].id.name));g.cpu.branches[e][b%16384]=(new Function("return "+g.generateCodeFromAst(d)))()})},parseFromAddress:function(a,b,d){a={address:a,
romPage:b,memPage:d};this.parser.entryPoints.push(a);this.bytecodes=this.parser.parseFromAddress(a);return this},analyzeFromAddress:function(){this.analyzer.analyzeFromAddress(this.bytecodes);return this},generateCodeFromAst:function(a){return window.escodegen.generate(a,{comment:!0,renumber:!0,hexadecimal:!0,parse:DEBUG?window.esprima.parse:function(a){return{type:"Program",body:[{type:"ExpressionStatement",expression:{type:"Literal",value:a,raw:a}}]}}})},dump:function(){var a=[],b;for(b in this.cpu.branches){a.push("// Page "+
b);for(var d in this.cpu.branches[b])a.push(this.cpu.branches[b][d])}a=a.join("\n");console.log(a)}};return b}();window.JSSMS=JSSMS;})(window);
